/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Activation Item</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ActivationItem#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ActivationItem#getDelay <em>Delay</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getActivationItem()
 * @model
 * @generated
 */
public interface ActivationItem extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Connection</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.ActivationConnection#getActivators <em>Activators</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection</em>' reference.
	 * @see #setConnection(ActivationConnection)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationItem_Connection()
	 * @see com.inchron.realtime.root.model.ActivationConnection#getActivators
	 * @model opposite="activators" required="true"
	 * @generated
	 */
	ActivationConnection getConnection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationItem#getConnection <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connection</em>' reference.
	 * @see #getConnection()
	 * @generated
	 */
	void setConnection(ActivationConnection value);

	/**
	 * Returns the value of the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Delay</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Delay</em>' containment reference.
	 * @see #setDelay(TimeDistribution)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationItem_Delay()
	 * @model containment="true"
	 * @generated
	 */
	TimeDistribution getDelay();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationItem#getDelay <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay</em>' containment reference.
	 * @see #getDelay()
	 * @generated
	 */
	void setDelay(TimeDistribution value);

} // ActivationItem
