/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Bus Message</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.BusMessage#getFullMessages <em>Full Messages</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.BusMessage#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.BusMessage#getInCallGraph <em>In Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.BusMessage#getOutCallGraph <em>Out Call Graph</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getBusMessage()
 * @model abstract="true"
 * @generated
 */
public interface BusMessage extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Full Messages</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.MessageData}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Full Messages</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Full Messages</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getBusMessage_FullMessages()
	 * @model containment="true"
	 * @generated
	 */
	EList<MessageData> getFullMessages();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TraceEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getBusMessage_Events()
	 * @model containment="true"
	 * @generated
	 */
	EList<TraceEvent> getEvents();

	/**
	 * Returns the value of the '<em><b>In Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>In Call Graph</em>' containment reference.
	 * @see #setInCallGraph(CallGraph)
	 * @see com.inchron.realtime.root.model.ModelPackage#getBusMessage_InCallGraph()
	 * @model containment="true"
	 * @generated
	 */
	CallGraph getInCallGraph();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.BusMessage#getInCallGraph <em>In Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>In Call Graph</em>' containment reference.
	 * @see #getInCallGraph()
	 * @generated
	 */
	void setInCallGraph(CallGraph value);

	/**
	 * Returns the value of the '<em><b>Out Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Out Call Graph</em>' containment reference.
	 * @see #setOutCallGraph(CallGraph)
	 * @see com.inchron.realtime.root.model.ModelPackage#getBusMessage_OutCallGraph()
	 * @model containment="true"
	 * @generated
	 */
	CallGraph getOutCallGraph();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.BusMessage#getOutCallGraph <em>Out Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Out Call Graph</em>' containment reference.
	 * @see #getOutCallGraph()
	 * @generated
	 */
	void setOutCallGraph(CallGraph value);

} // BusMessage
