/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Callback Function</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.CallbackFunction#getEntryFunction <em>Entry Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CallbackFunction#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCallbackFunction()
 * @model
 * @generated
 */
public interface CallbackFunction extends EObject {
	/**
	 * Returns the value of the '<em><b>Entry Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Entry Function</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Entry Function</em>' reference.
	 * @see #setEntryFunction(SourceFunction)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCallbackFunction_EntryFunction()
	 * @model required="true"
	 * @generated
	 */
	SourceFunction getEntryFunction();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CallbackFunction#getEntryFunction <em>Entry Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Entry Function</em>' reference.
	 * @see #getEntryFunction()
	 * @generated
	 */
	void setEntryFunction(SourceFunction value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.CallbackFunctionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.CallbackFunctionType
	 * @see #setType(CallbackFunctionType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCallbackFunction_Type()
	 * @model required="true"
	 * @generated
	 */
	CallbackFunctionType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CallbackFunction#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.CallbackFunctionType
	 * @see #getType()
	 * @generated
	 */
	void setType(CallbackFunctionType value);

} // CallbackFunction
