/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.DataObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Component#getVariables <em>Variables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Component#getFunctions <em>Functions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Component#getTranslationUnits <em>Translation Units</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getComponent()
 * @model
 * @generated
 */
public interface Component extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Variables</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.DataObject}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variables</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getComponent_Variables()
	 * @model containment="true"
	 * @generated
	 */
	EList<DataObject> getVariables();

	/**
	 * Returns the value of the '<em><b>Functions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Function}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Functions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getComponent_Functions()
	 * @model containment="true"
	 * @generated
	 */
	EList<Function> getFunctions();

	/**
	 * Returns the value of the '<em><b>Translation Units</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TranslationUnit}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Translation Units</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Translation Units</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getComponent_TranslationUnits()
	 * @model
	 * @generated
	 */
	EList<TranslationUnit> getTranslationUnits();

} // Component
