/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelPackage
 * @generated
 */
public interface ModelFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ModelFactory eINSTANCE = com.inchron.realtime.root.model.impl.ModelFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Activate Process</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Activate Process</em>'.
	 * @generated
	 */
	ActivateProcess createActivateProcess();

	/**
	 * Returns a new object of class '<em>Activation Connection</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Activation Connection</em>'.
	 * @generated
	 */
	ActivationConnection createActivationConnection();

	/**
	 * Returns a new object of class '<em>Activation Item</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Activation Item</em>'.
	 * @generated
	 */
	ActivationItem createActivationItem();

	/**
	 * Returns a new object of class '<em>Address Range</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Address Range</em>'.
	 * @generated
	 */
	AddressRange createAddressRange();

	/**
	 * Returns a new object of class '<em>Arinc System</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Arinc System</em>'.
	 * @generated
	 */
	ArincSystem createArincSystem();

	/**
	 * Returns a new object of class '<em>Callback Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Callback Function</em>'.
	 * @generated
	 */
	CallbackFunction createCallbackFunction();

	/**
	 * Returns a new object of class '<em>Call Graph</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Graph</em>'.
	 * @generated
	 */
	CallGraph createCallGraph();

	/**
	 * Returns a new object of class '<em>Call Sequence</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Sequence</em>'.
	 * @generated
	 */
	CallSequence createCallSequence();

	/**
	 * Returns a new object of class '<em>CAN Bus Message</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CAN Bus Message</em>'.
	 * @generated
	 */
	CANBusMessage createCANBusMessage();

	/**
	 * Returns a new object of class '<em>Clock</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Clock</em>'.
	 * @generated
	 */
	Clock createClock();

	/**
	 * Returns a new object of class '<em>Container</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Container</em>'.
	 * @generated
	 */
	Container createContainer();

	/**
	 * Returns a new object of class '<em>Compiler Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Compiler Settings</em>'.
	 * @generated
	 */
	CompilerSettings createCompilerSettings();

	/**
	 * Returns a new object of class '<em>Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Component</em>'.
	 * @generated
	 */
	Component createComponent();

	/**
	 * Returns a new object of class '<em>Conditional Trace Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Conditional Trace Event</em>'.
	 * @generated
	 */
	ConditionalTraceEvent createConditionalTraceEvent();

	/**
	 * Returns a new object of class '<em>Cpu</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cpu</em>'.
	 * @generated
	 */
	Cpu createCpu();

	/**
	 * Returns a new object of class '<em>Cpu Core</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cpu Core</em>'.
	 * @generated
	 */
	CpuCore createCpuCore();

	/**
	 * Returns a new object of class '<em>Data Flow</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Flow</em>'.
	 * @generated
	 */
	DataFlow createDataFlow();

	/**
	 * Returns a new object of class '<em>Data Flow Connection</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Flow Connection</em>'.
	 * @generated
	 */
	DataFlowConnection createDataFlowConnection();

	/**
	 * Returns a new object of class '<em>Data Flow Edge</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Flow Edge</em>'.
	 * @generated
	 */
	DataFlowEdge createDataFlowEdge();

	/**
	 * Returns a new object of class '<em>Data Flow Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Flow Reference</em>'.
	 * @generated
	 */
	DataFlowReference createDataFlowReference();

	/**
	 * Returns a new object of class '<em>Discrete Distribution Entry</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Discrete Distribution Entry</em>'.
	 * @generated
	 */
	DiscreteDistributionEntry createDiscreteDistributionEntry();

	/**
	 * Returns a new object of class '<em>Enforced Migration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Enforced Migration</em>'.
	 * @generated
	 */
	EnforcedMigration createEnforcedMigration();

	/**
	 * Returns a new object of class '<em>Estimator Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Estimator Settings</em>'.
	 * @generated
	 */
	EstimatorSettings createEstimatorSettings();

	/**
	 * Returns a new object of class '<em>Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event</em>'.
	 * @generated
	 */
	Event createEvent();

	/**
	 * Returns a new object of class '<em>Event Sequence</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Sequence</em>'.
	 * @generated
	 */
	EventSequence createEventSequence();

	/**
	 * Returns a new object of class '<em>Frequency</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Frequency</em>'.
	 * @generated
	 */
	Frequency createFrequency();

	/**
	 * Returns a new object of class '<em>Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Function</em>'.
	 * @generated
	 */
	Function createFunction();

	/**
	 * Returns a new object of class '<em>Function Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Function Call</em>'.
	 * @generated
	 */
	FunctionCall createFunctionCall();

	/**
	 * Returns a new object of class '<em>General Info</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>General Info</em>'.
	 * @generated
	 */
	GeneralInfo createGeneralInfo();

	/**
	 * Returns a new object of class '<em>Generic System</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic System</em>'.
	 * @generated
	 */
	GenericSystem createGenericSystem();

	/**
	 * Returns a new object of class '<em>Hyper Visor Config</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyper Visor Config</em>'.
	 * @generated
	 */
	HyperVisorConfig createHyperVisorConfig();

	/**
	 * Returns a new object of class '<em>Hyper Visor System Schedulable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyper Visor System Schedulable</em>'.
	 * @generated
	 */
	HyperVisorSystemSchedulable createHyperVisorSystemSchedulable();

	/**
	 * Returns a new object of class '<em>Hyper Visor Virtual Core Schedulable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyper Visor Virtual Core Schedulable</em>'.
	 * @generated
	 */
	HyperVisorVirtualCoreSchedulable createHyperVisorVirtualCoreSchedulable();

	/**
	 * Returns a new object of class '<em>Memory Region</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Memory Region</em>'.
	 * @generated
	 */
	MemoryRegion createMemoryRegion();

	/**
	 * Returns a new object of class '<em>Message Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Message Data</em>'.
	 * @generated
	 */
	MessageData createMessageData();

	/**
	 * Returns a new object of class '<em>Mode</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode</em>'.
	 * @generated
	 */
	Mode createMode();

	/**
	 * Returns a new object of class '<em>Mode Condition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Condition</em>'.
	 * @generated
	 */
	ModeCondition createModeCondition();

	/**
	 * Returns a new object of class '<em>Mode Condition Evaluation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Condition Evaluation</em>'.
	 * @generated
	 */
	ModeConditionEvaluation createModeConditionEvaluation();

	/**
	 * Returns a new object of class '<em>Mode Conjunction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Conjunction</em>'.
	 * @generated
	 */
	ModeConjunction createModeConjunction();

	/**
	 * Returns a new object of class '<em>Mode Group</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Group</em>'.
	 * @generated
	 */
	ModeGroup createModeGroup();

	/**
	 * Returns a new object of class '<em>Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Model</em>'.
	 * @generated
	 */
	Model createModel();

	/**
	 * Returns a new object of class '<em>Mode Switch</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Switch</em>'.
	 * @generated
	 */
	ModeSwitch createModeSwitch();

	/**
	 * Returns a new object of class '<em>Mode Switch Default</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Switch Default</em>'.
	 * @generated
	 */
	ModeSwitchDefault createModeSwitchDefault();

	/**
	 * Returns a new object of class '<em>Mode Switch Entry</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Switch Entry</em>'.
	 * @generated
	 */
	ModeSwitchEntry createModeSwitchEntry();

	/**
	 * Returns a new object of class '<em>Mode Switch Point</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Mode Switch Point</em>'.
	 * @generated
	 */
	ModeSwitchPoint createModeSwitchPoint();

	/**
	 * Returns a new object of class '<em>Partition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition</em>'.
	 * @generated
	 */
	Partition createPartition();

	/**
	 * Returns a new object of class '<em>Probability Switch</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Probability Switch</em>'.
	 * @generated
	 */
	ProbabilitySwitch createProbabilitySwitch();

	/**
	 * Returns a new object of class '<em>Probability Switch Entry</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Probability Switch Entry</em>'.
	 * @generated
	 */
	ProbabilitySwitchEntry createProbabilitySwitchEntry();

	/**
	 * Returns a new object of class '<em>Process</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process</em>'.
	 * @generated
	 */
	Process createProcess();

	/**
	 * Returns a new object of class '<em>Resource Consumption</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Consumption</em>'.
	 * @generated
	 */
	ResourceConsumption createResourceConsumption();

	/**
	 * Returns a new object of class '<em>Resume All Interrupts</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resume All Interrupts</em>'.
	 * @generated
	 */
	ResumeAllInterrupts createResumeAllInterrupts();

	/**
	 * Returns a new object of class '<em>Rtos Config</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rtos Config</em>'.
	 * @generated
	 */
	RtosConfig createRtosConfig();

	/**
	 * Returns a new object of class '<em>Rtos Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rtos Model</em>'.
	 * @generated
	 */
	RtosModel createRtosModel();

	/**
	 * Returns a new object of class '<em>Scheduler</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scheduler</em>'.
	 * @generated
	 */
	Scheduler createScheduler();

	/**
	 * Returns a new object of class '<em>Scheduling Entry</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scheduling Entry</em>'.
	 * @generated
	 */
	SchedulingEntry createSchedulingEntry();

	/**
	 * Returns a new object of class '<em>Schedule Point</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Schedule Point</em>'.
	 * @generated
	 */
	SchedulePoint createSchedulePoint();

	/**
	 * Returns a new object of class '<em>Semaphore</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Semaphore</em>'.
	 * @generated
	 */
	Semaphore createSemaphore();

	/**
	 * Returns a new object of class '<em>Semaphore Access</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Semaphore Access</em>'.
	 * @generated
	 */
	SemaphoreAccess createSemaphoreAccess();

	/**
	 * Returns a new object of class '<em>Send Message</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Send Message</em>'.
	 * @generated
	 */
	SendMessage createSendMessage();

	/**
	 * Returns a new object of class '<em>Set Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Event</em>'.
	 * @generated
	 */
	SetEvent createSetEvent();

	/**
	 * Returns a new object of class '<em>Set Guard</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Guard</em>'.
	 * @generated
	 */
	SetGuard createSetGuard();

	/**
	 * Returns a new object of class '<em>Source Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Source Function</em>'.
	 * @generated
	 */
	SourceFunction createSourceFunction();

	/**
	 * Returns a new object of class '<em>Spec Settings</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Spec Settings</em>'.
	 * @generated
	 */
	SpecSettings createSpecSettings();

	/**
	 * Returns a new object of class '<em>Spinlock</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Spinlock</em>'.
	 * @generated
	 */
	Spinlock createSpinlock();

	/**
	 * Returns a new object of class '<em>Spinlock Operation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Spinlock Operation</em>'.
	 * @generated
	 */
	SpinlockOperation createSpinlockOperation();

	/**
	 * Returns a new object of class '<em>Suspend All Interrupts</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Suspend All Interrupts</em>'.
	 * @generated
	 */
	SuspendAllInterrupts createSuspendAllInterrupts();

	/**
	 * Returns a new object of class '<em>Thread XSystem</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Thread XSystem</em>'.
	 * @generated
	 */
	ThreadXSystem createThreadXSystem();

	/**
	 * Returns a new object of class '<em>Time</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Time</em>'.
	 * @generated
	 */
	Time createTime();

	/**
	 * Returns a new object of class '<em>Time Distribution</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Time Distribution</em>'.
	 * @generated
	 */
	TimeDistribution createTimeDistribution();

	/**
	 * Returns a new object of class '<em>Trace Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Trace Event</em>'.
	 * @generated
	 */
	TraceEvent createTraceEvent();

	/**
	 * Returns a new object of class '<em>Translation Unit</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Translation Unit</em>'.
	 * @generated
	 */
	TranslationUnit createTranslationUnit();

	/**
	 * Returns a new object of class '<em>Trigger Token</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Trigger Token</em>'.
	 * @generated
	 */
	TriggerToken createTriggerToken();

	/**
	 * Returns a new object of class '<em>User Code Event Chain</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>User Code Event Chain</em>'.
	 * @generated
	 */
	UserCodeEventChain createUserCodeEventChain();

	/**
	 * Returns a new object of class '<em>User Code Event Chain Step</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>User Code Event Chain Step</em>'.
	 * @generated
	 */
	UserCodeEventChainStep createUserCodeEventChainStep();

	/**
	 * Returns a new object of class '<em>Variable Read Access</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Variable Read Access</em>'.
	 * @generated
	 */
	VariableReadAccess createVariableReadAccess();

	/**
	 * Returns a new object of class '<em>Variable Write Access</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Variable Write Access</em>'.
	 * @generated
	 */
	VariableWriteAccess createVariableWriteAccess();

	/**
	 * Returns a new object of class '<em>Wait Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Wait Event</em>'.
	 * @generated
	 */
	WaitEvent createWaitEvent();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	ModelPackage getModelPackage();

} //ModelFactory
