/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.peripheral.InterruptPort;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Process</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Process#getActivationLimit <em>Activation Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#isActiveAtBoot <em>Active At Boot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#getCallGraph <em>Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#getDeadline <em>Deadline</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#isExtendedTask <em>Extended Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#getTraceEvents <em>Trace Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#isIdleTask <em>Idle Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#isIsr <em>Isr</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#isPreemptable <em>Preemptable</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#getStackLimit <em>Stack Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Process#getTriggeringPort <em>Triggering Port</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getProcess()
 * @model
 * @generated
 */
public interface Process extends Schedulable {
	/**
	 * Returns the value of the '<em><b>Activation Limit</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activation Limit</em>' attribute.
	 * @see #setActivationLimit(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_ActivationLimit()
	 * @model default="1"
	 * @generated
	 */
	int getActivationLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#getActivationLimit <em>Activation Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Activation Limit</em>' attribute.
	 * @see #getActivationLimit()
	 * @generated
	 */
	void setActivationLimit(int value);

	/**
	 * Returns the value of the '<em><b>Active At Boot</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Active At Boot</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Active At Boot</em>' attribute.
	 * @see #setActiveAtBoot(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_ActiveAtBoot()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isActiveAtBoot();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#isActiveAtBoot <em>Active At Boot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Active At Boot</em>' attribute.
	 * @see #isActiveAtBoot()
	 * @generated
	 */
	void setActiveAtBoot(boolean value);

	/**
	 * Returns the value of the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Call Graph</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Call Graph</em>' containment reference.
	 * @see #setCallGraph(CallGraph)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_CallGraph()
	 * @model containment="true"
	 * @generated
	 */
	CallGraph getCallGraph();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#getCallGraph <em>Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Call Graph</em>' containment reference.
	 * @see #getCallGraph()
	 * @generated
	 */
	void setCallGraph(CallGraph value);

	/**
	 * Returns the value of the '<em><b>Deadline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deadline</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deadline</em>' containment reference.
	 * @see #setDeadline(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_Deadline()
	 * @model containment="true"
	 * @generated
	 */
	Time getDeadline();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#getDeadline <em>Deadline</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deadline</em>' containment reference.
	 * @see #getDeadline()
	 * @generated
	 */
	void setDeadline(Time value);

	/**
	 * Returns the value of the '<em><b>Extended Task</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extended Task</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extended Task</em>' attribute.
	 * @see #setExtendedTask(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_ExtendedTask()
	 * @model default="false"
	 * @generated
	 */
	boolean isExtendedTask();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#isExtendedTask <em>Extended Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Extended Task</em>' attribute.
	 * @see #isExtendedTask()
	 * @generated
	 */
	void setExtendedTask(boolean value);

	/**
	 * Returns the value of the '<em><b>Trace Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TraceEvent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_TraceEvents()
	 * @model containment="true"
	 * @generated
	 */
	EList<TraceEvent> getTraceEvents();

	/**
	 * Returns the value of the '<em><b>Idle Task</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Idle Task</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Idle Task</em>' attribute.
	 * @see #setIdleTask(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_IdleTask()
	 * @model default="false"
	 * @generated
	 */
	boolean isIdleTask();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#isIdleTask <em>Idle Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Idle Task</em>' attribute.
	 * @see #isIdleTask()
	 * @generated
	 */
	void setIdleTask(boolean value);

	/**
	 * Returns the value of the '<em><b>Isr</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Isr</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Isr</em>' attribute.
	 * @see #setIsr(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_Isr()
	 * @model default="false" required="true" ordered="false"
	 * @generated
	 */
	boolean isIsr();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#isIsr <em>Isr</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Isr</em>' attribute.
	 * @see #isIsr()
	 * @generated
	 */
	void setIsr(boolean value);

	/**
	 * Returns the value of the '<em><b>Preemptable</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Preemptable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Preemptable</em>' attribute.
	 * @see #setPreemptable(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_Preemptable()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isPreemptable();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#isPreemptable <em>Preemptable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Preemptable</em>' attribute.
	 * @see #isPreemptable()
	 * @generated
	 */
	void setPreemptable(boolean value);

	/**
	 * Returns the value of the '<em><b>Stack Limit</b></em>' attribute.
	 * The default value is <code>"1024"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stack Limit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stack Limit</em>' attribute.
	 * @see #setStackLimit(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_StackLimit()
	 * @model default="1024" required="true" ordered="false"
	 * @generated
	 */
	int getStackLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Process#getStackLimit <em>Stack Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stack Limit</em>' attribute.
	 * @see #getStackLimit()
	 * @generated
	 */
	void setStackLimit(int value);

	/**
	 * Returns the value of the '<em><b>Triggering Port</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.InterruptPort}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.peripheral.InterruptPort#getIsrs <em>Isrs</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Triggering Port</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Triggering Port</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getProcess_TriggeringPort()
	 * @see com.inchron.realtime.root.model.peripheral.InterruptPort#getIsrs
	 * @model opposite="isrs" ordered="false"
	 * @generated
	 */
	EList<InterruptPort> getTriggeringPort();

} // Process
