/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.ExplicitDataAccess;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable Read Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getDataAccess <em>Data Access</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#isIsBuffered <em>Is Buffered</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getNumber <em>Number</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getIndex <em>Index</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getPolicy <em>Policy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#isIsTake <em>Is Take</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getLowerBound <em>Lower Bound</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew <em>Data Must Be New</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getReceivePercentage <em>Receive Percentage</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess()
 * @model
 * @generated
 */
public interface VariableReadAccess extends VariableAccess {
	/**
	 * Returns the value of the '<em><b>Connection</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.DataFlowConnection#getRequesters <em>Requesters</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection</em>' reference.
	 * @see #setConnection(DataFlowConnection)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Connection()
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getRequesters
	 * @model opposite="requesters"
	 * @generated
	 */
	DataFlowConnection getConnection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connection</em>' reference.
	 * @see #getConnection()
	 * @generated
	 */
	void setConnection(DataFlowConnection value);

	/**
	 * Returns the value of the '<em><b>Data Access</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Access</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Access</em>' containment reference.
	 * @see #setDataAccess(ExplicitDataAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_DataAccess()
	 * @model containment="true"
	 * @generated
	 */
	ExplicitDataAccess getDataAccess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getDataAccess <em>Data Access</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Access</em>' containment reference.
	 * @see #getDataAccess()
	 * @generated
	 */
	void setDataAccess(ExplicitDataAccess value);

	/**
	 * Returns the value of the '<em><b>Is Buffered</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Buffered</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Buffered</em>' attribute.
	 * @see #setIsBuffered(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_IsBuffered()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsBuffered();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#isIsBuffered <em>Is Buffered</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Buffered</em>' attribute.
	 * @see #isIsBuffered()
	 * @generated
	 */
	void setIsBuffered(boolean value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Generic"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableReadAccessType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @see #setType(VariableReadAccessType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Type()
	 * @model default="Generic" required="true"
	 * @generated
	 */
	VariableReadAccessType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @see #getType()
	 * @generated
	 */
	void setType(VariableReadAccessType value);

	/**
	 * Returns the value of the '<em><b>Number</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Number</em>' attribute.
	 * @see #setNumber(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Number()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getNumber();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getNumber <em>Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number</em>' attribute.
	 * @see #getNumber()
	 * @generated
	 */
	void setNumber(int value);

	/**
	 * Returns the value of the '<em><b>Index</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Index</em>' attribute.
	 * @see #setIndex(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Index()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getIndex();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getIndex <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Index</em>' attribute.
	 * @see #getIndex()
	 * @generated
	 */
	void setIndex(int value);

	/**
	 * Returns the value of the '<em><b>Policy</b></em>' attribute.
	 * The default value is <code>"FIFO"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableReadAccessPolicy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Policy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @see #setPolicy(VariableReadAccessPolicy)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Policy()
	 * @model default="FIFO" required="true"
	 * @generated
	 */
	VariableReadAccessPolicy getPolicy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getPolicy <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @see #getPolicy()
	 * @generated
	 */
	void setPolicy(VariableReadAccessPolicy value);

	/**
	 * Returns the value of the '<em><b>Is Take</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Take</em>' attribute.
	 * @see #setIsTake(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_IsTake()
	 * @model default="true" required="true"
	 * @generated
	 */
	boolean isIsTake();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#isIsTake <em>Is Take</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Take</em>' attribute.
	 * @see #isIsTake()
	 * @generated
	 */
	void setIsTake(boolean value);

	/**
	 * Returns the value of the '<em><b>Lower Bound</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lower Bound</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lower Bound</em>' attribute.
	 * @see #setLowerBound(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_LowerBound()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getLowerBound();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getLowerBound <em>Lower Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lower Bound</em>' attribute.
	 * @see #getLowerBound()
	 * @generated
	 */
	void setLowerBound(int value);

	/**
	 * Returns the value of the '<em><b>Data Must Be New</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Must Be New</em>' attribute.
	 * @see #setDataMustBeNew(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_DataMustBeNew()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isDataMustBeNew();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew <em>Data Must Be New</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Must Be New</em>' attribute.
	 * @see #isDataMustBeNew()
	 * @generated
	 */
	void setDataMustBeNew(boolean value);

	/**
	 * Returns the value of the '<em><b>Receive Percentage</b></em>' attribute.
	 * The default value is <code>"100"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Receive Percentage</em>' attribute.
	 * @see #setReceivePercentage(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_ReceivePercentage()
	 * @model default="100" required="true"
	 * @generated
	 */
	int getReceivePercentage();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getReceivePercentage <em>Receive Percentage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Receive Percentage</em>' attribute.
	 * @see #getReceivePercentage()
	 * @generated
	 */
	void setReceivePercentage(int value);

} // VariableReadAccess
