/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Wait Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.WaitEvent#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.WaitEvent#getTimeout <em>Timeout</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.WaitEvent#isForReset <em>For Reset</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getWaitEvent()
 * @model
 * @generated
 */
public interface WaitEvent extends CallSequenceItem {
	/**
	 * Returns the value of the '<em><b>Events</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Event}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getWaitEvent_Events()
	 * @model required="true"
	 * @generated
	 */
	EList<Event> getEvents();

	/**
	 * Returns the value of the '<em><b>Timeout</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Timeout</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timeout</em>' containment reference.
	 * @see #setTimeout(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getWaitEvent_Timeout()
	 * @model containment="true"
	 * @generated
	 */
	Time getTimeout();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.WaitEvent#getTimeout <em>Timeout</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timeout</em>' containment reference.
	 * @see #getTimeout()
	 * @generated
	 */
	void setTimeout(Time value);

	/**
	 * Returns the value of the '<em><b>For Reset</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>For Reset</em>' attribute.
	 * @see #setForReset(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getWaitEvent_ForReset()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isForReset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.WaitEvent#isForReset <em>For Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>For Reset</em>' attribute.
	 * @see #isForReset()
	 * @generated
	 */
	void setForReset(boolean value);

} // WaitEvent
