/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.SourceFunction;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Alarm Action</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getTask <em>Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getEvent <em>Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getCallback <em>Callback</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxAdvance <em>Max Advance</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxRetard <em>Max Retard</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction()
 * @model
 * @generated
 */
public interface OsAlarmAction extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"ActivateTask"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.autosar.OsAlarmActionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmActionType
	 * @see #setType(OsAlarmActionType)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_Type()
	 * @model default="ActivateTask" required="true" ordered="false"
	 * @generated
	 */
	OsAlarmActionType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsAlarmActionType
	 * @see #getType()
	 * @generated
	 */
	void setType(OsAlarmActionType value);

	/**
	 * Returns the value of the '<em><b>Task</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Task</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Task</em>' reference.
	 * @see #setTask(OsTask)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_Task()
	 * @model
	 * @generated
	 */
	OsTask getTask();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getTask <em>Task</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task</em>' reference.
	 * @see #getTask()
	 * @generated
	 */
	void setTask(OsTask value);

	/**
	 * Returns the value of the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event</em>' reference.
	 * @see #setEvent(OsEvent)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_Event()
	 * @model
	 * @generated
	 */
	OsEvent getEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getEvent <em>Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event</em>' reference.
	 * @see #getEvent()
	 * @generated
	 */
	void setEvent(OsEvent value);

	/**
	 * Returns the value of the '<em><b>Callback</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Callback</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Callback</em>' reference.
	 * @see #setCallback(SourceFunction)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_Callback()
	 * @model
	 * @generated
	 */
	SourceFunction getCallback();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getCallback <em>Callback</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Callback</em>' reference.
	 * @see #getCallback()
	 * @generated
	 */
	void setCallback(SourceFunction value);

	/**
	 * Returns the value of the '<em><b>Max Advance</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Advance</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Advance</em>' attribute.
	 * @see #setMaxAdvance(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_MaxAdvance()
	 * @model default="1"
	 * @generated
	 */
	long getMaxAdvance();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxAdvance <em>Max Advance</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Advance</em>' attribute.
	 * @see #getMaxAdvance()
	 * @generated
	 */
	void setMaxAdvance(long value);

	/**
	 * Returns the value of the '<em><b>Max Retard</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Retard</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Retard</em>' attribute.
	 * @see #setMaxRetard(long)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsAlarmAction_MaxRetard()
	 * @model default="1"
	 * @generated
	 */
	long getMaxRetard();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsAlarmAction#getMaxRetard <em>Max Retard</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Retard</em>' attribute.
	 * @see #getMaxRetard()
	 * @generated
	 */
	void setMaxRetard(long value);

} // OsAlarmAction
