/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.Partition;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Application</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getAlarms <em>Alarms</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getCounters <em>Counters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getCpuCore <em>Cpu Core</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getPartition <em>Partition</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getIsrs <em>Isrs</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getScheduleTables <em>Schedule Tables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#getTasks <em>Tasks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrusted <em>Is Trusted</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrustedWithProtection <em>Is Trusted With Protection</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication()
 * @model
 * @generated
 */
public interface OsApplication extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Alarms</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsAlarm}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alarms</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alarms</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_Alarms()
	 * @model
	 * @generated
	 */
	EList<OsAlarm> getAlarms();

	/**
	 * Returns the value of the '<em><b>Counters</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsCounter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Counters</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Counters</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_Counters()
	 * @model
	 * @generated
	 */
	EList<OsCounter> getCounters();

	/**
	 * Returns the value of the '<em><b>Cpu Core</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu Core</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu Core</em>' reference.
	 * @see #setCpuCore(CpuCore)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_CpuCore()
	 * @model
	 * @generated
	 */
	CpuCore getCpuCore();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsApplication#getCpuCore <em>Cpu Core</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu Core</em>' reference.
	 * @see #getCpuCore()
	 * @generated
	 */
	void setCpuCore(CpuCore value);

	/**
	 * Returns the value of the '<em><b>Partition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Partition</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Partition</em>' reference.
	 * @see #setPartition(Partition)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_Partition()
	 * @model
	 * @generated
	 */
	Partition getPartition();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsApplication#getPartition <em>Partition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Partition</em>' reference.
	 * @see #getPartition()
	 * @generated
	 */
	void setPartition(Partition value);

	/**
	 * Returns the value of the '<em><b>Isrs</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsIsr}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Isrs</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Isrs</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_Isrs()
	 * @model
	 * @generated
	 */
	EList<OsIsr> getIsrs();

	/**
	 * Returns the value of the '<em><b>Schedule Tables</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsScheduleTable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Schedule Tables</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Schedule Tables</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_ScheduleTables()
	 * @model
	 * @generated
	 */
	EList<OsScheduleTable> getScheduleTables();

	/**
	 * Returns the value of the '<em><b>Tasks</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.autosar.OsTask}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tasks</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tasks</em>' reference list.
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_Tasks()
	 * @model
	 * @generated
	 */
	EList<OsTask> getTasks();

	/**
	 * Returns the value of the '<em><b>Is Trusted</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Trusted</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Trusted</em>' attribute.
	 * @see #setIsTrusted(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_IsTrusted()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsTrusted();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrusted <em>Is Trusted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Trusted</em>' attribute.
	 * @see #isIsTrusted()
	 * @generated
	 */
	void setIsTrusted(boolean value);

	/**
	 * Returns the value of the '<em><b>Is Trusted With Protection</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Trusted With Protection</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Trusted With Protection</em>' attribute.
	 * @see #setIsTrustedWithProtection(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsApplication_IsTrustedWithProtection()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsTrustedWithProtection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsApplication#isIsTrustedWithProtection <em>Is Trusted With Protection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Trusted With Protection</em>' attribute.
	 * @see #isIsTrustedWithProtection()
	 * @generated
	 */
	void setIsTrustedWithProtection(boolean value);

} // OsApplication
