/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.ARSystem;
import com.inchron.realtime.root.model.autosar.AutosarFactory;
import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.ClearEvent;
import com.inchron.realtime.root.model.autosar.Operation;
import com.inchron.realtime.root.model.autosar.OsAlarm;
import com.inchron.realtime.root.model.autosar.OsAlarmAction;
import com.inchron.realtime.root.model.autosar.OsAlarmActionType;
import com.inchron.realtime.root.model.autosar.OsApplication;
import com.inchron.realtime.root.model.autosar.OsConfig;
import com.inchron.realtime.root.model.autosar.OsCounter;
import com.inchron.realtime.root.model.autosar.OsEvent;
import com.inchron.realtime.root.model.autosar.OsExpiryPoint;
import com.inchron.realtime.root.model.autosar.OsIsr;
import com.inchron.realtime.root.model.autosar.OsIsrType;
import com.inchron.realtime.root.model.autosar.OsResource;
import com.inchron.realtime.root.model.autosar.OsResourceType;
import com.inchron.realtime.root.model.autosar.OsScheduleTable;
import com.inchron.realtime.root.model.autosar.OsScheduleTableStartType;
import com.inchron.realtime.root.model.autosar.OsSpinlock;
import com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod;
import com.inchron.realtime.root.model.autosar.OsTask;
import com.inchron.realtime.root.model.autosar.ResumeOSInterrupts;
import com.inchron.realtime.root.model.autosar.ServerCall;
import com.inchron.realtime.root.model.autosar.SuspendOSInterrupts;
import com.inchron.realtime.root.model.autosar.SwComponent;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AutosarFactoryImpl extends EFactoryImpl implements AutosarFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AutosarFactory init() {
		try {
			AutosarFactory theAutosarFactory = (AutosarFactory)EPackage.Registry.INSTANCE.getEFactory(AutosarPackage.eNS_URI);
			if (theAutosarFactory != null) {
				return theAutosarFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new AutosarFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AutosarFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case AutosarPackage.AR_SYSTEM: return createARSystem();
			case AutosarPackage.CLEAR_EVENT: return createClearEvent();
			case AutosarPackage.OPERATION: return createOperation();
			case AutosarPackage.OS_ALARM: return createOsAlarm();
			case AutosarPackage.OS_ALARM_ACTION: return createOsAlarmAction();
			case AutosarPackage.OS_APPLICATION: return createOsApplication();
			case AutosarPackage.OS_CONFIG: return createOsConfig();
			case AutosarPackage.OS_COUNTER: return createOsCounter();
			case AutosarPackage.OS_EVENT: return createOsEvent();
			case AutosarPackage.OS_EXPIRY_POINT: return createOsExpiryPoint();
			case AutosarPackage.OS_ISR: return createOsIsr();
			case AutosarPackage.OS_RESOURCE: return createOsResource();
			case AutosarPackage.OS_SCHEDULE_TABLE: return createOsScheduleTable();
			case AutosarPackage.OS_SPINLOCK: return createOsSpinlock();
			case AutosarPackage.OS_TASK: return createOsTask();
			case AutosarPackage.RESUME_OS_INTERRUPTS: return createResumeOSInterrupts();
			case AutosarPackage.RUNNABLE: return createRunnable();
			case AutosarPackage.SERVER_CALL: return createServerCall();
			case AutosarPackage.SUSPEND_OS_INTERRUPTS: return createSuspendOSInterrupts();
			case AutosarPackage.SW_COMPONENT: return createSwComponent();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case AutosarPackage.OS_ALARM_ACTION_TYPE:
				return createOsAlarmActionTypeFromString(eDataType, initialValue);
			case AutosarPackage.OS_ISR_TYPE:
				return createOsIsrTypeFromString(eDataType, initialValue);
			case AutosarPackage.OS_RESOURCE_TYPE:
				return createOsResourceTypeFromString(eDataType, initialValue);
			case AutosarPackage.OS_SCHEDULE_TABLE_START_TYPE:
				return createOsScheduleTableStartTypeFromString(eDataType, initialValue);
			case AutosarPackage.OS_SPINLOCK_LOCK_METHOD:
				return createOsSpinlockLockMethodFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case AutosarPackage.OS_ALARM_ACTION_TYPE:
				return convertOsAlarmActionTypeToString(eDataType, instanceValue);
			case AutosarPackage.OS_ISR_TYPE:
				return convertOsIsrTypeToString(eDataType, instanceValue);
			case AutosarPackage.OS_RESOURCE_TYPE:
				return convertOsResourceTypeToString(eDataType, instanceValue);
			case AutosarPackage.OS_SCHEDULE_TABLE_START_TYPE:
				return convertOsScheduleTableStartTypeToString(eDataType, instanceValue);
			case AutosarPackage.OS_SPINLOCK_LOCK_METHOD:
				return convertOsSpinlockLockMethodToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ARSystem createARSystem() {
		ARSystemImpl arSystem = new ARSystemImpl();
		return arSystem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClearEvent createClearEvent() {
		ClearEventImpl clearEvent = new ClearEventImpl();
		return clearEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Operation createOperation() {
		OperationImpl operation = new OperationImpl();
		return operation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsAlarm createOsAlarm() {
		OsAlarmImpl osAlarm = new OsAlarmImpl();
		return osAlarm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsAlarmAction createOsAlarmAction() {
		OsAlarmActionImpl osAlarmAction = new OsAlarmActionImpl();
		return osAlarmAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsApplication createOsApplication() {
		OsApplicationImpl osApplication = new OsApplicationImpl();
		return osApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsConfig createOsConfig() {
		OsConfigImpl osConfig = new OsConfigImpl();
		return osConfig;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsCounter createOsCounter() {
		OsCounterImpl osCounter = new OsCounterImpl();
		return osCounter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsEvent createOsEvent() {
		OsEventImpl osEvent = new OsEventImpl();
		return osEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsExpiryPoint createOsExpiryPoint() {
		OsExpiryPointImpl osExpiryPoint = new OsExpiryPointImpl();
		return osExpiryPoint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsIsr createOsIsr() {
		OsIsrImpl osIsr = new OsIsrImpl();
		return osIsr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsResource createOsResource() {
		OsResourceImpl osResource = new OsResourceImpl();
		return osResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsScheduleTable createOsScheduleTable() {
		OsScheduleTableImpl osScheduleTable = new OsScheduleTableImpl();
		return osScheduleTable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsSpinlock createOsSpinlock() {
		OsSpinlockImpl osSpinlock = new OsSpinlockImpl();
		return osSpinlock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsTask createOsTask() {
		OsTaskImpl osTask = new OsTaskImpl();
		return osTask;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResumeOSInterrupts createResumeOSInterrupts() {
		ResumeOSInterruptsImpl resumeOSInterrupts = new ResumeOSInterruptsImpl();
		return resumeOSInterrupts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.autosar.Runnable createRunnable() {
		RunnableImpl runnable = new RunnableImpl();
		return runnable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerCall createServerCall() {
		ServerCallImpl serverCall = new ServerCallImpl();
		return serverCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SuspendOSInterrupts createSuspendOSInterrupts() {
		SuspendOSInterruptsImpl suspendOSInterrupts = new SuspendOSInterruptsImpl();
		return suspendOSInterrupts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SwComponent createSwComponent() {
		SwComponentImpl swComponent = new SwComponentImpl();
		return swComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsAlarmActionType createOsAlarmActionTypeFromString(EDataType eDataType, String initialValue) {
		OsAlarmActionType result = OsAlarmActionType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOsAlarmActionTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsIsrType createOsIsrTypeFromString(EDataType eDataType, String initialValue) {
		OsIsrType result = OsIsrType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOsIsrTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsResourceType createOsResourceTypeFromString(EDataType eDataType, String initialValue) {
		OsResourceType result = OsResourceType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOsResourceTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsScheduleTableStartType createOsScheduleTableStartTypeFromString(EDataType eDataType, String initialValue) {
		OsScheduleTableStartType result = OsScheduleTableStartType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOsScheduleTableStartTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsSpinlockLockMethod createOsSpinlockLockMethodFromString(EDataType eDataType, String initialValue) {
		OsSpinlockLockMethod result = OsSpinlockLockMethod.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOsSpinlockLockMethodToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AutosarPackage getAutosarPackage() {
		return (AutosarPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static AutosarPackage getPackage() {
		return AutosarPackage.eINSTANCE;
	}

} //AutosarFactoryImpl
