/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsAlarm;
import com.inchron.realtime.root.model.autosar.OsApplication;
import com.inchron.realtime.root.model.autosar.OsConfig;
import com.inchron.realtime.root.model.autosar.OsCounter;
import com.inchron.realtime.root.model.autosar.OsEvent;
import com.inchron.realtime.root.model.autosar.OsIsr;
import com.inchron.realtime.root.model.autosar.OsResource;
import com.inchron.realtime.root.model.autosar.OsScheduleTable;
import com.inchron.realtime.root.model.autosar.OsSpinlock;
import com.inchron.realtime.root.model.autosar.OsTask;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getAlarms <em>Alarms</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getApplications <em>Applications</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getCounters <em>Counters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getIsrs <em>Isrs</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getResources <em>Resources</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getScheduleTables <em>Schedule Tables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getSpinlocks <em>Spinlocks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsConfigImpl#getTasks <em>Tasks</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsConfigImpl extends ModelObjectImpl implements OsConfig {
	/**
	 * The cached value of the '{@link #getAlarms() <em>Alarms</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlarms()
	 * @generated
	 * @ordered
	 */
	protected EList<OsAlarm> alarms;

	/**
	 * The cached value of the '{@link #getApplications() <em>Applications</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getApplications()
	 * @generated
	 * @ordered
	 */
	protected EList<OsApplication> applications;

	/**
	 * The cached value of the '{@link #getCounters() <em>Counters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCounters()
	 * @generated
	 * @ordered
	 */
	protected EList<OsCounter> counters;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<OsEvent> events;

	/**
	 * The cached value of the '{@link #getIsrs() <em>Isrs</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIsrs()
	 * @generated
	 * @ordered
	 */
	protected EList<OsIsr> isrs;

	/**
	 * The cached value of the '{@link #getResources() <em>Resources</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResources()
	 * @generated
	 * @ordered
	 */
	protected EList<OsResource> resources;

	/**
	 * The cached value of the '{@link #getScheduleTables() <em>Schedule Tables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScheduleTables()
	 * @generated
	 * @ordered
	 */
	protected EList<OsScheduleTable> scheduleTables;

	/**
	 * The cached value of the '{@link #getSpinlocks() <em>Spinlocks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpinlocks()
	 * @generated
	 * @ordered
	 */
	protected EList<OsSpinlock> spinlocks;

	/**
	 * The cached value of the '{@link #getTasks() <em>Tasks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTasks()
	 * @generated
	 * @ordered
	 */
	protected EList<OsTask> tasks;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsConfigImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_CONFIG;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsAlarm> getAlarms() {
		if (alarms == null) {
			alarms = new EObjectContainmentEList<OsAlarm>(OsAlarm.class, this, AutosarPackage.OS_CONFIG__ALARMS);
		}
		return alarms;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsApplication> getApplications() {
		if (applications == null) {
			applications = new EObjectContainmentEList<OsApplication>(OsApplication.class, this, AutosarPackage.OS_CONFIG__APPLICATIONS);
		}
		return applications;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsCounter> getCounters() {
		if (counters == null) {
			counters = new EObjectContainmentEList<OsCounter>(OsCounter.class, this, AutosarPackage.OS_CONFIG__COUNTERS);
		}
		return counters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsEvent> getEvents() {
		if (events == null) {
			events = new EObjectContainmentEList<OsEvent>(OsEvent.class, this, AutosarPackage.OS_CONFIG__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsIsr> getIsrs() {
		if (isrs == null) {
			isrs = new EObjectContainmentEList<OsIsr>(OsIsr.class, this, AutosarPackage.OS_CONFIG__ISRS);
		}
		return isrs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsResource> getResources() {
		if (resources == null) {
			resources = new EObjectContainmentEList<OsResource>(OsResource.class, this, AutosarPackage.OS_CONFIG__RESOURCES);
		}
		return resources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsScheduleTable> getScheduleTables() {
		if (scheduleTables == null) {
			scheduleTables = new EObjectContainmentEList<OsScheduleTable>(OsScheduleTable.class, this, AutosarPackage.OS_CONFIG__SCHEDULE_TABLES);
		}
		return scheduleTables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsSpinlock> getSpinlocks() {
		if (spinlocks == null) {
			spinlocks = new EObjectContainmentEList<OsSpinlock>(OsSpinlock.class, this, AutosarPackage.OS_CONFIG__SPINLOCKS);
		}
		return spinlocks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsTask> getTasks() {
		if (tasks == null) {
			tasks = new EObjectContainmentEList<OsTask>(OsTask.class, this, AutosarPackage.OS_CONFIG__TASKS);
		}
		return tasks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.OS_CONFIG__ALARMS:
				return ((InternalEList<?>)getAlarms()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__APPLICATIONS:
				return ((InternalEList<?>)getApplications()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__COUNTERS:
				return ((InternalEList<?>)getCounters()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__EVENTS:
				return ((InternalEList<?>)getEvents()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__ISRS:
				return ((InternalEList<?>)getIsrs()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__RESOURCES:
				return ((InternalEList<?>)getResources()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__SCHEDULE_TABLES:
				return ((InternalEList<?>)getScheduleTables()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__SPINLOCKS:
				return ((InternalEList<?>)getSpinlocks()).basicRemove(otherEnd, msgs);
			case AutosarPackage.OS_CONFIG__TASKS:
				return ((InternalEList<?>)getTasks()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_CONFIG__ALARMS:
				return getAlarms();
			case AutosarPackage.OS_CONFIG__APPLICATIONS:
				return getApplications();
			case AutosarPackage.OS_CONFIG__COUNTERS:
				return getCounters();
			case AutosarPackage.OS_CONFIG__EVENTS:
				return getEvents();
			case AutosarPackage.OS_CONFIG__ISRS:
				return getIsrs();
			case AutosarPackage.OS_CONFIG__RESOURCES:
				return getResources();
			case AutosarPackage.OS_CONFIG__SCHEDULE_TABLES:
				return getScheduleTables();
			case AutosarPackage.OS_CONFIG__SPINLOCKS:
				return getSpinlocks();
			case AutosarPackage.OS_CONFIG__TASKS:
				return getTasks();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_CONFIG__ALARMS:
				getAlarms().clear();
				getAlarms().addAll((Collection<? extends OsAlarm>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__APPLICATIONS:
				getApplications().clear();
				getApplications().addAll((Collection<? extends OsApplication>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__COUNTERS:
				getCounters().clear();
				getCounters().addAll((Collection<? extends OsCounter>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection<? extends OsEvent>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__ISRS:
				getIsrs().clear();
				getIsrs().addAll((Collection<? extends OsIsr>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__RESOURCES:
				getResources().clear();
				getResources().addAll((Collection<? extends OsResource>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__SCHEDULE_TABLES:
				getScheduleTables().clear();
				getScheduleTables().addAll((Collection<? extends OsScheduleTable>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__SPINLOCKS:
				getSpinlocks().clear();
				getSpinlocks().addAll((Collection<? extends OsSpinlock>)newValue);
				return;
			case AutosarPackage.OS_CONFIG__TASKS:
				getTasks().clear();
				getTasks().addAll((Collection<? extends OsTask>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_CONFIG__ALARMS:
				getAlarms().clear();
				return;
			case AutosarPackage.OS_CONFIG__APPLICATIONS:
				getApplications().clear();
				return;
			case AutosarPackage.OS_CONFIG__COUNTERS:
				getCounters().clear();
				return;
			case AutosarPackage.OS_CONFIG__EVENTS:
				getEvents().clear();
				return;
			case AutosarPackage.OS_CONFIG__ISRS:
				getIsrs().clear();
				return;
			case AutosarPackage.OS_CONFIG__RESOURCES:
				getResources().clear();
				return;
			case AutosarPackage.OS_CONFIG__SCHEDULE_TABLES:
				getScheduleTables().clear();
				return;
			case AutosarPackage.OS_CONFIG__SPINLOCKS:
				getSpinlocks().clear();
				return;
			case AutosarPackage.OS_CONFIG__TASKS:
				getTasks().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_CONFIG__ALARMS:
				return alarms != null && !alarms.isEmpty();
			case AutosarPackage.OS_CONFIG__APPLICATIONS:
				return applications != null && !applications.isEmpty();
			case AutosarPackage.OS_CONFIG__COUNTERS:
				return counters != null && !counters.isEmpty();
			case AutosarPackage.OS_CONFIG__EVENTS:
				return events != null && !events.isEmpty();
			case AutosarPackage.OS_CONFIG__ISRS:
				return isrs != null && !isrs.isEmpty();
			case AutosarPackage.OS_CONFIG__RESOURCES:
				return resources != null && !resources.isEmpty();
			case AutosarPackage.OS_CONFIG__SCHEDULE_TABLES:
				return scheduleTables != null && !scheduleTables.isEmpty();
			case AutosarPackage.OS_CONFIG__SPINLOCKS:
				return spinlocks != null && !spinlocks.isEmpty();
			case AutosarPackage.OS_CONFIG__TASKS:
				return tasks != null && !tasks.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //OsConfigImpl
