/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.Clock;
import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsCounter;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Counter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getClock <em>Clock</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getDelay <em>Delay</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getGranularity <em>Granularity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#isHardware <em>Hardware</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getMincycle <em>Mincycle</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getRange <em>Range</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsCounterImpl#getReferenceTicks <em>Reference Ticks</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsCounterImpl extends ModelObjectImpl implements OsCounter {
	/**
	 * The cached value of the '{@link #getClock() <em>Clock</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClock()
	 * @generated
	 * @ordered
	 */
	protected Clock clock;

	/**
	 * The cached value of the '{@link #getDelay() <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDelay()
	 * @generated
	 * @ordered
	 */
	protected Time delay;

	/**
	 * The default value of the '{@link #getGranularity() <em>Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGranularity()
	 * @generated
	 * @ordered
	 */
	protected static final long GRANULARITY_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getGranularity() <em>Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGranularity()
	 * @generated
	 * @ordered
	 */
	protected long granularity = GRANULARITY_EDEFAULT;

	/**
	 * The default value of the '{@link #isHardware() <em>Hardware</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHardware()
	 * @generated
	 * @ordered
	 */
	protected static final boolean HARDWARE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isHardware() <em>Hardware</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHardware()
	 * @generated
	 * @ordered
	 */
	protected boolean hardware = HARDWARE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMincycle() <em>Mincycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMincycle()
	 * @generated
	 * @ordered
	 */
	protected static final long MINCYCLE_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getMincycle() <em>Mincycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMincycle()
	 * @generated
	 * @ordered
	 */
	protected long mincycle = MINCYCLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getRange() <em>Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRange()
	 * @generated
	 * @ordered
	 */
	protected static final long RANGE_EDEFAULT = 1000L;

	/**
	 * The cached value of the '{@link #getRange() <em>Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRange()
	 * @generated
	 * @ordered
	 */
	protected long range = RANGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getReferenceTicks() <em>Reference Ticks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceTicks()
	 * @generated
	 * @ordered
	 */
	protected static final long REFERENCE_TICKS_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getReferenceTicks() <em>Reference Ticks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferenceTicks()
	 * @generated
	 * @ordered
	 */
	protected long referenceTicks = REFERENCE_TICKS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsCounterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_COUNTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock getClock() {
		if (clock != null && clock.eIsProxy()) {
			InternalEObject oldClock = (InternalEObject)clock;
			clock = (Clock)eResolveProxy(oldClock);
			if (clock != oldClock) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_COUNTER__CLOCK, oldClock, clock));
			}
		}
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock basicGetClock() {
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetClock(Clock newClock, NotificationChain msgs) {
		Clock oldClock = clock;
		clock = newClock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__CLOCK, oldClock, newClock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClock(Clock newClock) {
		if (newClock != clock) {
			NotificationChain msgs = null;
			if (clock != null)
				msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			if (newClock != null)
				msgs = ((InternalEObject)newClock).eInverseAdd(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			msgs = basicSetClock(newClock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__CLOCK, newClock, newClock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getDelay() {
		return delay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDelay(Time newDelay, NotificationChain msgs) {
		Time oldDelay = delay;
		delay = newDelay;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__DELAY, oldDelay, newDelay);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDelay(Time newDelay) {
		if (newDelay != delay) {
			NotificationChain msgs = null;
			if (delay != null)
				msgs = ((InternalEObject)delay).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.OS_COUNTER__DELAY, null, msgs);
			if (newDelay != null)
				msgs = ((InternalEObject)newDelay).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.OS_COUNTER__DELAY, null, msgs);
			msgs = basicSetDelay(newDelay, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__DELAY, newDelay, newDelay));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getGranularity() {
		return granularity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGranularity(long newGranularity) {
		long oldGranularity = granularity;
		granularity = newGranularity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__GRANULARITY, oldGranularity, granularity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isHardware() {
		return hardware;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHardware(boolean newHardware) {
		boolean oldHardware = hardware;
		hardware = newHardware;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__HARDWARE, oldHardware, hardware));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getMincycle() {
		return mincycle;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMincycle(long newMincycle) {
		long oldMincycle = mincycle;
		mincycle = newMincycle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__MINCYCLE, oldMincycle, mincycle));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getRange() {
		return range;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRange(long newRange) {
		long oldRange = range;
		range = newRange;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__RANGE, oldRange, range));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getReferenceTicks() {
		return referenceTicks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReferenceTicks(long newReferenceTicks) {
		long oldReferenceTicks = referenceTicks;
		referenceTicks = newReferenceTicks;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_COUNTER__REFERENCE_TICKS, oldReferenceTicks, referenceTicks));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				if (clock != null)
					msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
				return basicSetClock((Clock)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				return basicSetClock(null, msgs);
			case AutosarPackage.OS_COUNTER__DELAY:
				return basicSetDelay(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				if (resolve) return getClock();
				return basicGetClock();
			case AutosarPackage.OS_COUNTER__DELAY:
				return getDelay();
			case AutosarPackage.OS_COUNTER__GRANULARITY:
				return getGranularity();
			case AutosarPackage.OS_COUNTER__HARDWARE:
				return isHardware();
			case AutosarPackage.OS_COUNTER__MINCYCLE:
				return getMincycle();
			case AutosarPackage.OS_COUNTER__RANGE:
				return getRange();
			case AutosarPackage.OS_COUNTER__REFERENCE_TICKS:
				return getReferenceTicks();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				setClock((Clock)newValue);
				return;
			case AutosarPackage.OS_COUNTER__DELAY:
				setDelay((Time)newValue);
				return;
			case AutosarPackage.OS_COUNTER__GRANULARITY:
				setGranularity((Long)newValue);
				return;
			case AutosarPackage.OS_COUNTER__HARDWARE:
				setHardware((Boolean)newValue);
				return;
			case AutosarPackage.OS_COUNTER__MINCYCLE:
				setMincycle((Long)newValue);
				return;
			case AutosarPackage.OS_COUNTER__RANGE:
				setRange((Long)newValue);
				return;
			case AutosarPackage.OS_COUNTER__REFERENCE_TICKS:
				setReferenceTicks((Long)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				setClock((Clock)null);
				return;
			case AutosarPackage.OS_COUNTER__DELAY:
				setDelay((Time)null);
				return;
			case AutosarPackage.OS_COUNTER__GRANULARITY:
				setGranularity(GRANULARITY_EDEFAULT);
				return;
			case AutosarPackage.OS_COUNTER__HARDWARE:
				setHardware(HARDWARE_EDEFAULT);
				return;
			case AutosarPackage.OS_COUNTER__MINCYCLE:
				setMincycle(MINCYCLE_EDEFAULT);
				return;
			case AutosarPackage.OS_COUNTER__RANGE:
				setRange(RANGE_EDEFAULT);
				return;
			case AutosarPackage.OS_COUNTER__REFERENCE_TICKS:
				setReferenceTicks(REFERENCE_TICKS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_COUNTER__CLOCK:
				return clock != null;
			case AutosarPackage.OS_COUNTER__DELAY:
				return delay != null;
			case AutosarPackage.OS_COUNTER__GRANULARITY:
				return granularity != GRANULARITY_EDEFAULT;
			case AutosarPackage.OS_COUNTER__HARDWARE:
				return hardware != HARDWARE_EDEFAULT;
			case AutosarPackage.OS_COUNTER__MINCYCLE:
				return mincycle != MINCYCLE_EDEFAULT;
			case AutosarPackage.OS_COUNTER__RANGE:
				return range != RANGE_EDEFAULT;
			case AutosarPackage.OS_COUNTER__REFERENCE_TICKS:
				return referenceTicks != REFERENCE_TICKS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ClockUser.class) {
			switch (derivedFeatureID) {
				case AutosarPackage.OS_COUNTER__CLOCK: return ModelPackage.CLOCK_USER__CLOCK;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ClockUser.class) {
			switch (baseFeatureID) {
				case ModelPackage.CLOCK_USER__CLOCK: return AutosarPackage.OS_COUNTER__CLOCK;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (granularity: ");
		result.append(granularity);
		result.append(", hardware: ");
		result.append(hardware);
		result.append(", mincycle: ");
		result.append(mincycle);
		result.append(", range: ");
		result.append(range);
		result.append(", referenceTicks: ");
		result.append(referenceTicks);
		result.append(')');
		return result.toString();
	}

} //OsCounterImpl
