/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.Operation;
import com.inchron.realtime.root.model.autosar.ServerCall;

import com.inchron.realtime.root.model.impl.CallSequenceItemImpl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Server Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.ServerCallImpl#getInvokedOperation <em>Invoked Operation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ServerCallImpl extends CallSequenceItemImpl implements ServerCall {
	/**
	 * The cached value of the '{@link #getInvokedOperation() <em>Invoked Operation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInvokedOperation()
	 * @generated
	 * @ordered
	 */
	protected Operation invokedOperation;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServerCallImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.SERVER_CALL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Operation getInvokedOperation() {
		if (invokedOperation != null && invokedOperation.eIsProxy()) {
			InternalEObject oldInvokedOperation = (InternalEObject)invokedOperation;
			invokedOperation = (Operation)eResolveProxy(oldInvokedOperation);
			if (invokedOperation != oldInvokedOperation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.SERVER_CALL__INVOKED_OPERATION, oldInvokedOperation, invokedOperation));
			}
		}
		return invokedOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Operation basicGetInvokedOperation() {
		return invokedOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInvokedOperation(Operation newInvokedOperation) {
		Operation oldInvokedOperation = invokedOperation;
		invokedOperation = newInvokedOperation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.SERVER_CALL__INVOKED_OPERATION, oldInvokedOperation, invokedOperation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.SERVER_CALL__INVOKED_OPERATION:
				if (resolve) return getInvokedOperation();
				return basicGetInvokedOperation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.SERVER_CALL__INVOKED_OPERATION:
				setInvokedOperation((Operation)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.SERVER_CALL__INVOKED_OPERATION:
				setInvokedOperation((Operation)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.SERVER_CALL__INVOKED_OPERATION:
				return invokedOperation != null;
		}
		return super.eIsSet(featureID);
	}

} //ServerCallImpl
