/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.fmi.unit.UnitFactory
 * @model kind="package"
 * @generated
 */
public interface UnitPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "unit";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/model/fmi/unit";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "unit";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	UnitPackage eINSTANCE = com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl <em>Base Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getBaseUnit()
	 * @generated
	 */
	int BASE_UNIT = 0;

	/**
	 * The feature id for the '<em><b>A</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__A = 0;

	/**
	 * The feature id for the '<em><b>Cd</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__CD = 1;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__FACTOR = 2;

	/**
	 * The feature id for the '<em><b>K</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__K = 3;

	/**
	 * The feature id for the '<em><b>Kg</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__KG = 4;

	/**
	 * The feature id for the '<em><b>M</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__M = 5;

	/**
	 * The feature id for the '<em><b>Mol</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__MOL = 6;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__OFFSET = 7;

	/**
	 * The feature id for the '<em><b>Rad</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__RAD = 8;

	/**
	 * The feature id for the '<em><b>S</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT__S = 9;

	/**
	 * The number of structural features of the '<em>Base Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT_FEATURE_COUNT = 10;

	/**
	 * The number of operations of the '<em>Base Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_UNIT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.DisplayUnitImpl <em>Display Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.DisplayUnitImpl
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getDisplayUnit()
	 * @generated
	 */
	int DISPLAY_UNIT = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT__FACTOR = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT__OFFSET = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Display Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Display Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISPLAY_UNIT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl <em>Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl
	 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getUnit()
	 * @generated
	 */
	int UNIT = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Base Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT__BASE_UNIT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Display Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT__DISPLAY_UNITS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNIT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit <em>Base Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Base Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit
	 * @generated
	 */
	EClass getBaseUnit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getA <em>A</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>A</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getA()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_A();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getCd <em>Cd</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cd</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getCd()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Cd();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getFactor <em>Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Factor</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getFactor()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Factor();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getK <em>K</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>K</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getK()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_K();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getKg <em>Kg</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Kg</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getKg()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Kg();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getM <em>M</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>M</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getM()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_M();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getMol <em>Mol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mol</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getMol()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Mol();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getOffset()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Offset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getRad <em>Rad</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rad</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getRad()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_Rad();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getS <em>S</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>S</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.BaseUnit#getS()
	 * @see #getBaseUnit()
	 * @generated
	 */
	EAttribute getBaseUnit_S();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit <em>Display Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Display Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.DisplayUnit
	 * @generated
	 */
	EClass getDisplayUnit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getFactor <em>Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Factor</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getFactor()
	 * @see #getDisplayUnit()
	 * @generated
	 */
	EAttribute getDisplayUnit_Factor();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.DisplayUnit#getOffset()
	 * @see #getDisplayUnit()
	 * @generated
	 */
	EAttribute getDisplayUnit_Offset();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.unit.Unit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.Unit
	 * @generated
	 */
	EClass getUnit();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.fmi.unit.Unit#getBaseUnit <em>Base Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Base Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.Unit#getBaseUnit()
	 * @see #getUnit()
	 * @generated
	 */
	EReference getUnit_BaseUnit();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.fmi.unit.Unit#getDisplayUnits <em>Display Units</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Display Units</em>'.
	 * @see com.inchron.realtime.root.model.fmi.unit.Unit#getDisplayUnits()
	 * @see #getUnit()
	 * @generated
	 */
	EReference getUnit_DisplayUnits();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	UnitFactory getUnitFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl <em>Base Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getBaseUnit()
		 * @generated
		 */
		EClass BASE_UNIT = eINSTANCE.getBaseUnit();

		/**
		 * The meta object literal for the '<em><b>A</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__A = eINSTANCE.getBaseUnit_A();

		/**
		 * The meta object literal for the '<em><b>Cd</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__CD = eINSTANCE.getBaseUnit_Cd();

		/**
		 * The meta object literal for the '<em><b>Factor</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__FACTOR = eINSTANCE.getBaseUnit_Factor();

		/**
		 * The meta object literal for the '<em><b>K</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__K = eINSTANCE.getBaseUnit_K();

		/**
		 * The meta object literal for the '<em><b>Kg</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__KG = eINSTANCE.getBaseUnit_Kg();

		/**
		 * The meta object literal for the '<em><b>M</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__M = eINSTANCE.getBaseUnit_M();

		/**
		 * The meta object literal for the '<em><b>Mol</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__MOL = eINSTANCE.getBaseUnit_Mol();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__OFFSET = eINSTANCE.getBaseUnit_Offset();

		/**
		 * The meta object literal for the '<em><b>Rad</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__RAD = eINSTANCE.getBaseUnit_Rad();

		/**
		 * The meta object literal for the '<em><b>S</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BASE_UNIT__S = eINSTANCE.getBaseUnit_S();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.DisplayUnitImpl <em>Display Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.DisplayUnitImpl
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getDisplayUnit()
		 * @generated
		 */
		EClass DISPLAY_UNIT = eINSTANCE.getDisplayUnit();

		/**
		 * The meta object literal for the '<em><b>Factor</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DISPLAY_UNIT__FACTOR = eINSTANCE.getDisplayUnit_Factor();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DISPLAY_UNIT__OFFSET = eINSTANCE.getDisplayUnit_Offset();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl <em>Unit</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl
		 * @see com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl#getUnit()
		 * @generated
		 */
		EClass UNIT = eINSTANCE.getUnit();

		/**
		 * The meta object literal for the '<em><b>Base Unit</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNIT__BASE_UNIT = eINSTANCE.getUnit_BaseUnit();

		/**
		 * The meta object literal for the '<em><b>Display Units</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNIT__DISPLAY_UNITS = eINSTANCE.getUnit_DisplayUnits();

	}

} //UnitPackage
