/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable;

import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.fmi.variable.VariableFactory
 * @model kind="package"
 * @generated
 */
public interface VariablePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "variable";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/model/fmi/variable";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "variable";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	VariablePackage eINSTANCE = com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl <em>Scalar Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getScalarVariable()
	 * @generated
	 */
	int SCALAR_VARIABLE = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__INTRINSIC_ID = PeripheralPackage.ABSTRACT_PORT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__NAME = PeripheralPackage.ABSTRACT_PORT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__OBJECT_ID = PeripheralPackage.ABSTRACT_PORT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__CONNECTION = PeripheralPackage.ABSTRACT_PORT__CONNECTION;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__CALL_GRAPH = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Causality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__CAUSALITY = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__CONNECTIONS = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__DESCRIPTION = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__INITIAL = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Trigger Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__TRIGGER_TYPE = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Value Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__VALUE_REFERENCE = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Variability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE__VARIABILITY = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Scalar Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE_FEATURE_COUNT = PeripheralPackage.ABSTRACT_PORT_FEATURE_COUNT + 8;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE___IS_COMPATIBLE__ABSTRACTPORT = PeripheralPackage.ABSTRACT_PORT___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Scalar Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALAR_VARIABLE_OPERATION_COUNT = PeripheralPackage.ABSTRACT_PORT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.BooleanImpl <em>Boolean</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.BooleanImpl
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getBoolean()
	 * @generated
	 */
	int BOOLEAN = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__INTRINSIC_ID = SCALAR_VARIABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__NAME = SCALAR_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__OBJECT_ID = SCALAR_VARIABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__CONNECTION = SCALAR_VARIABLE__CONNECTION;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__CALL_GRAPH = SCALAR_VARIABLE__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Causality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__CAUSALITY = SCALAR_VARIABLE__CAUSALITY;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__CONNECTIONS = SCALAR_VARIABLE__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__DESCRIPTION = SCALAR_VARIABLE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__INITIAL = SCALAR_VARIABLE__INITIAL;

	/**
	 * The feature id for the '<em><b>Trigger Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__TRIGGER_TYPE = SCALAR_VARIABLE__TRIGGER_TYPE;

	/**
	 * The feature id for the '<em><b>Value Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__VALUE_REFERENCE = SCALAR_VARIABLE__VALUE_REFERENCE;

	/**
	 * The feature id for the '<em><b>Variability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__VARIABILITY = SCALAR_VARIABLE__VARIABILITY;

	/**
	 * The feature id for the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__DECLARED_TYPE = SCALAR_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Start</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN__START = SCALAR_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Boolean</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_FEATURE_COUNT = SCALAR_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN___IS_COMPATIBLE__ABSTRACTPORT = SCALAR_VARIABLE___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Boolean</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_OPERATION_COUNT = SCALAR_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.EnumerationImpl <em>Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.EnumerationImpl
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getEnumeration()
	 * @generated
	 */
	int ENUMERATION = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__INTRINSIC_ID = SCALAR_VARIABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__NAME = SCALAR_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__OBJECT_ID = SCALAR_VARIABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__CONNECTION = SCALAR_VARIABLE__CONNECTION;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__CALL_GRAPH = SCALAR_VARIABLE__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Causality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__CAUSALITY = SCALAR_VARIABLE__CAUSALITY;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__CONNECTIONS = SCALAR_VARIABLE__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__DESCRIPTION = SCALAR_VARIABLE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__INITIAL = SCALAR_VARIABLE__INITIAL;

	/**
	 * The feature id for the '<em><b>Trigger Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__TRIGGER_TYPE = SCALAR_VARIABLE__TRIGGER_TYPE;

	/**
	 * The feature id for the '<em><b>Value Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__VALUE_REFERENCE = SCALAR_VARIABLE__VALUE_REFERENCE;

	/**
	 * The feature id for the '<em><b>Variability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__VARIABILITY = SCALAR_VARIABLE__VARIABILITY;

	/**
	 * The feature id for the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__DECLARED_TYPE = SCALAR_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__MAX = SCALAR_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Min</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__MIN = SCALAR_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__QUANTITY = SCALAR_VARIABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION__START = SCALAR_VARIABLE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_FEATURE_COUNT = SCALAR_VARIABLE_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION___IS_COMPATIBLE__ABSTRACTPORT = SCALAR_VARIABLE___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_OPERATION_COUNT = SCALAR_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.IntegerImpl <em>Integer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.IntegerImpl
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getInteger()
	 * @generated
	 */
	int INTEGER = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__INTRINSIC_ID = SCALAR_VARIABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__NAME = SCALAR_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__OBJECT_ID = SCALAR_VARIABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__CONNECTION = SCALAR_VARIABLE__CONNECTION;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__CALL_GRAPH = SCALAR_VARIABLE__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Causality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__CAUSALITY = SCALAR_VARIABLE__CAUSALITY;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__CONNECTIONS = SCALAR_VARIABLE__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__DESCRIPTION = SCALAR_VARIABLE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__INITIAL = SCALAR_VARIABLE__INITIAL;

	/**
	 * The feature id for the '<em><b>Trigger Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__TRIGGER_TYPE = SCALAR_VARIABLE__TRIGGER_TYPE;

	/**
	 * The feature id for the '<em><b>Value Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__VALUE_REFERENCE = SCALAR_VARIABLE__VALUE_REFERENCE;

	/**
	 * The feature id for the '<em><b>Variability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__VARIABILITY = SCALAR_VARIABLE__VARIABILITY;

	/**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__MAX = SCALAR_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Min</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__MIN = SCALAR_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__QUANTITY = SCALAR_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__DECLARED_TYPE = SCALAR_VARIABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER__START = SCALAR_VARIABLE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Integer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_FEATURE_COUNT = SCALAR_VARIABLE_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER___IS_COMPATIBLE__ABSTRACTPORT = SCALAR_VARIABLE___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Integer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_OPERATION_COUNT = SCALAR_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl <em>Real</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.RealImpl
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getReal()
	 * @generated
	 */
	int REAL = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__INTRINSIC_ID = SCALAR_VARIABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__NAME = SCALAR_VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__OBJECT_ID = SCALAR_VARIABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__CONNECTION = SCALAR_VARIABLE__CONNECTION;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__CALL_GRAPH = SCALAR_VARIABLE__CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Causality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__CAUSALITY = SCALAR_VARIABLE__CAUSALITY;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__CONNECTIONS = SCALAR_VARIABLE__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__DESCRIPTION = SCALAR_VARIABLE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Initial</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__INITIAL = SCALAR_VARIABLE__INITIAL;

	/**
	 * The feature id for the '<em><b>Trigger Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__TRIGGER_TYPE = SCALAR_VARIABLE__TRIGGER_TYPE;

	/**
	 * The feature id for the '<em><b>Value Reference</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__VALUE_REFERENCE = SCALAR_VARIABLE__VALUE_REFERENCE;

	/**
	 * The feature id for the '<em><b>Variability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__VARIABILITY = SCALAR_VARIABLE__VARIABILITY;

	/**
	 * The feature id for the '<em><b>Display Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__DISPLAY_UNIT = SCALAR_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__MAX = SCALAR_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Min</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__MIN = SCALAR_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__QUANTITY = SCALAR_VARIABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Relative Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__RELATIVE_QUANTITY = SCALAR_VARIABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__UNIT = SCALAR_VARIABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Declared Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__DECLARED_TYPE = SCALAR_VARIABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Start</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL__START = SCALAR_VARIABLE_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Real</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_FEATURE_COUNT = SCALAR_VARIABLE_FEATURE_COUNT + 8;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL___IS_COMPATIBLE__ABSTRACTPORT = SCALAR_VARIABLE___IS_COMPATIBLE__ABSTRACTPORT;

	/**
	 * The number of operations of the '<em>Real</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_OPERATION_COUNT = SCALAR_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.Causality <em>Causality</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.Causality
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getCausality()
	 * @generated
	 */
	int CAUSALITY = 5;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.Initial <em>Initial</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.Initial
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getInitial()
	 * @generated
	 */
	int INITIAL = 6;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.TriggerType <em>Trigger Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.TriggerType
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getTriggerType()
	 * @generated
	 */
	int TRIGGER_TYPE = 7;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.variable.Variability <em>Variability</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.variable.Variability
	 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getVariability()
	 * @generated
	 */
	int VARIABILITY = 8;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.variable.Boolean <em>Boolean</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boolean</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Boolean
	 * @generated
	 */
	EClass getBoolean();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.variable.Boolean#getDeclaredType <em>Declared Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Declared Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Boolean#getDeclaredType()
	 * @see #getBoolean()
	 * @generated
	 */
	EReference getBoolean_DeclaredType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Boolean#isStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Boolean#isStart()
	 * @see #getBoolean()
	 * @generated
	 */
	EAttribute getBoolean_Start();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration <em>Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enumeration</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration
	 * @generated
	 */
	EClass getEnumeration();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getDeclaredType <em>Declared Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Declared Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration#getDeclaredType()
	 * @see #getEnumeration()
	 * @generated
	 */
	EReference getEnumeration_DeclaredType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration#getMax()
	 * @see #getEnumeration()
	 * @generated
	 */
	EAttribute getEnumeration_Max();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getMin <em>Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration#getMin()
	 * @see #getEnumeration()
	 * @generated
	 */
	EAttribute getEnumeration_Min();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getQuantity <em>Quantity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Quantity</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration#getQuantity()
	 * @see #getEnumeration()
	 * @generated
	 */
	EAttribute getEnumeration_Quantity();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Enumeration#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Enumeration#getStart()
	 * @see #getEnumeration()
	 * @generated
	 */
	EAttribute getEnumeration_Start();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.variable.Integer <em>Integer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Integer</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Integer
	 * @generated
	 */
	EClass getInteger();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.variable.Integer#getDeclaredType <em>Declared Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Declared Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Integer#getDeclaredType()
	 * @see #getInteger()
	 * @generated
	 */
	EReference getInteger_DeclaredType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Integer#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Integer#getStart()
	 * @see #getInteger()
	 * @generated
	 */
	EAttribute getInteger_Start();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.variable.Real <em>Real</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Real
	 * @generated
	 */
	EClass getReal();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.variable.Real#getDeclaredType <em>Declared Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Declared Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Real#getDeclaredType()
	 * @see #getReal()
	 * @generated
	 */
	EReference getReal_DeclaredType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.Real#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Real#getStart()
	 * @see #getReal()
	 * @generated
	 */
	EAttribute getReal_Start();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable <em>Scalar Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scalar Variable</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable
	 * @generated
	 */
	EClass getScalarVariable();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCallGraph <em>Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCallGraph()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EReference getScalarVariable_CallGraph();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCausality <em>Causality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Causality</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getCausality()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_Causality();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getConnections <em>Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connections</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getConnections()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EReference getScalarVariable_Connections();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getDescription()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_Description();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getInitial <em>Initial</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getInitial()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_Initial();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getTriggerType <em>Trigger Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Trigger Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getTriggerType()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_TriggerType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getValueReference <em>Value Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value Reference</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getValueReference()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_ValueReference();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getVariability <em>Variability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Variability</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.ScalarVariable#getVariability()
	 * @see #getScalarVariable()
	 * @generated
	 */
	EAttribute getScalarVariable_Variability();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.fmi.variable.Causality <em>Causality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Causality</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Causality
	 * @generated
	 */
	EEnum getCausality();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.fmi.variable.Initial <em>Initial</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Initial</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Initial
	 * @generated
	 */
	EEnum getInitial();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.fmi.variable.TriggerType <em>Trigger Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Trigger Type</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.TriggerType
	 * @generated
	 */
	EEnum getTriggerType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.fmi.variable.Variability <em>Variability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variability</em>'.
	 * @see com.inchron.realtime.root.model.fmi.variable.Variability
	 * @generated
	 */
	EEnum getVariability();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	VariableFactory getVariableFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.BooleanImpl <em>Boolean</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.BooleanImpl
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getBoolean()
		 * @generated
		 */
		EClass BOOLEAN = eINSTANCE.getBoolean();

		/**
		 * The meta object literal for the '<em><b>Declared Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BOOLEAN__DECLARED_TYPE = eINSTANCE.getBoolean_DeclaredType();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOLEAN__START = eINSTANCE.getBoolean_Start();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.EnumerationImpl <em>Enumeration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.EnumerationImpl
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getEnumeration()
		 * @generated
		 */
		EClass ENUMERATION = eINSTANCE.getEnumeration();

		/**
		 * The meta object literal for the '<em><b>Declared Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENUMERATION__DECLARED_TYPE = eINSTANCE.getEnumeration_DeclaredType();

		/**
		 * The meta object literal for the '<em><b>Max</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUMERATION__MAX = eINSTANCE.getEnumeration_Max();

		/**
		 * The meta object literal for the '<em><b>Min</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUMERATION__MIN = eINSTANCE.getEnumeration_Min();

		/**
		 * The meta object literal for the '<em><b>Quantity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUMERATION__QUANTITY = eINSTANCE.getEnumeration_Quantity();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUMERATION__START = eINSTANCE.getEnumeration_Start();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.IntegerImpl <em>Integer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.IntegerImpl
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getInteger()
		 * @generated
		 */
		EClass INTEGER = eINSTANCE.getInteger();

		/**
		 * The meta object literal for the '<em><b>Declared Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTEGER__DECLARED_TYPE = eINSTANCE.getInteger_DeclaredType();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTEGER__START = eINSTANCE.getInteger_Start();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.RealImpl <em>Real</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.RealImpl
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getReal()
		 * @generated
		 */
		EClass REAL = eINSTANCE.getReal();

		/**
		 * The meta object literal for the '<em><b>Declared Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REAL__DECLARED_TYPE = eINSTANCE.getReal_DeclaredType();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL__START = eINSTANCE.getReal_Start();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl <em>Scalar Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.ScalarVariableImpl
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getScalarVariable()
		 * @generated
		 */
		EClass SCALAR_VARIABLE = eINSTANCE.getScalarVariable();

		/**
		 * The meta object literal for the '<em><b>Call Graph</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCALAR_VARIABLE__CALL_GRAPH = eINSTANCE.getScalarVariable_CallGraph();

		/**
		 * The meta object literal for the '<em><b>Causality</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__CAUSALITY = eINSTANCE.getScalarVariable_Causality();

		/**
		 * The meta object literal for the '<em><b>Connections</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCALAR_VARIABLE__CONNECTIONS = eINSTANCE.getScalarVariable_Connections();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__DESCRIPTION = eINSTANCE.getScalarVariable_Description();

		/**
		 * The meta object literal for the '<em><b>Initial</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__INITIAL = eINSTANCE.getScalarVariable_Initial();

		/**
		 * The meta object literal for the '<em><b>Trigger Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__TRIGGER_TYPE = eINSTANCE.getScalarVariable_TriggerType();

		/**
		 * The meta object literal for the '<em><b>Value Reference</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__VALUE_REFERENCE = eINSTANCE.getScalarVariable_ValueReference();

		/**
		 * The meta object literal for the '<em><b>Variability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALAR_VARIABLE__VARIABILITY = eINSTANCE.getScalarVariable_Variability();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.Causality <em>Causality</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.Causality
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getCausality()
		 * @generated
		 */
		EEnum CAUSALITY = eINSTANCE.getCausality();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.Initial <em>Initial</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.Initial
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getInitial()
		 * @generated
		 */
		EEnum INITIAL = eINSTANCE.getInitial();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.TriggerType <em>Trigger Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.TriggerType
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getTriggerType()
		 * @generated
		 */
		EEnum TRIGGER_TYPE = eINSTANCE.getTriggerType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.variable.Variability <em>Variability</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.variable.Variability
		 * @see com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl#getVariability()
		 * @generated
		 */
		EEnum VARIABILITY = eINSTANCE.getVariability();

	}

} //VariablePackage
