/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CallbackFunction;
import com.inchron.realtime.root.model.CallbackFunctionType;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.SourceFunction;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Callback Function</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.CallbackFunctionImpl#getEntryFunction <em>Entry Function</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CallbackFunctionImpl#getType <em>Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CallbackFunctionImpl extends MinimalEObjectImpl.Container implements CallbackFunction {
	/**
	 * The cached value of the '{@link #getEntryFunction() <em>Entry Function</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntryFunction()
	 * @generated
	 * @ordered
	 */
	protected SourceFunction entryFunction;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final CallbackFunctionType TYPE_EDEFAULT = CallbackFunctionType.INIT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected CallbackFunctionType type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallbackFunctionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getCallbackFunction();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction getEntryFunction() {
		if (entryFunction != null && entryFunction.eIsProxy()) {
			InternalEObject oldEntryFunction = (InternalEObject)entryFunction;
			entryFunction = (SourceFunction)eResolveProxy(oldEntryFunction);
			if (entryFunction != oldEntryFunction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION, oldEntryFunction, entryFunction));
			}
		}
		return entryFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SourceFunction basicGetEntryFunction() {
		return entryFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEntryFunction(SourceFunction newEntryFunction) {
		SourceFunction oldEntryFunction = entryFunction;
		entryFunction = newEntryFunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION, oldEntryFunction, entryFunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallbackFunctionType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(CallbackFunctionType newType) {
		CallbackFunctionType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CALLBACK_FUNCTION__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION:
				if (resolve) return getEntryFunction();
				return basicGetEntryFunction();
			case ModelPackage.CALLBACK_FUNCTION__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION:
				setEntryFunction((SourceFunction)newValue);
				return;
			case ModelPackage.CALLBACK_FUNCTION__TYPE:
				setType((CallbackFunctionType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION:
				setEntryFunction((SourceFunction)null);
				return;
			case ModelPackage.CALLBACK_FUNCTION__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CALLBACK_FUNCTION__ENTRY_FUNCTION:
				return entryFunction != null;
			case ModelPackage.CALLBACK_FUNCTION__TYPE:
				return type != TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //CallbackFunctionImpl
