/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ConditionalTraceEvent;
import com.inchron.realtime.root.model.EventSequence;
import com.inchron.realtime.root.model.ModelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Sequence</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.EventSequenceImpl#isOutOfOrderReset <em>Out Of Order Reset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.EventSequenceImpl#getSequence <em>Sequence</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventSequenceImpl extends EventChainImpl implements EventSequence {
	/**
	 * The default value of the '{@link #isOutOfOrderReset() <em>Out Of Order Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isOutOfOrderReset()
	 * @generated
	 * @ordered
	 */
	protected static final boolean OUT_OF_ORDER_RESET_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isOutOfOrderReset() <em>Out Of Order Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isOutOfOrderReset()
	 * @generated
	 * @ordered
	 */
	protected boolean outOfOrderReset = OUT_OF_ORDER_RESET_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSequence() <em>Sequence</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSequence()
	 * @generated
	 * @ordered
	 */
	protected EList<ConditionalTraceEvent> sequence;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventSequenceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getEventSequence();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isOutOfOrderReset() {
		return outOfOrderReset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutOfOrderReset(boolean newOutOfOrderReset) {
		boolean oldOutOfOrderReset = outOfOrderReset;
		outOfOrderReset = newOutOfOrderReset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.EVENT_SEQUENCE__OUT_OF_ORDER_RESET, oldOutOfOrderReset, outOfOrderReset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConditionalTraceEvent> getSequence() {
		if (sequence == null) {
			sequence = new EObjectContainmentEList<ConditionalTraceEvent>(ConditionalTraceEvent.class, this, ModelPackage.EVENT_SEQUENCE__SEQUENCE);
		}
		return sequence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.EVENT_SEQUENCE__SEQUENCE:
				return ((InternalEList<?>)getSequence()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.EVENT_SEQUENCE__OUT_OF_ORDER_RESET:
				return isOutOfOrderReset();
			case ModelPackage.EVENT_SEQUENCE__SEQUENCE:
				return getSequence();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.EVENT_SEQUENCE__OUT_OF_ORDER_RESET:
				setOutOfOrderReset((Boolean)newValue);
				return;
			case ModelPackage.EVENT_SEQUENCE__SEQUENCE:
				getSequence().clear();
				getSequence().addAll((Collection<? extends ConditionalTraceEvent>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.EVENT_SEQUENCE__OUT_OF_ORDER_RESET:
				setOutOfOrderReset(OUT_OF_ORDER_RESET_EDEFAULT);
				return;
			case ModelPackage.EVENT_SEQUENCE__SEQUENCE:
				getSequence().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.EVENT_SEQUENCE__OUT_OF_ORDER_RESET:
				return outOfOrderReset != OUT_OF_ORDER_RESET_EDEFAULT;
			case ModelPackage.EVENT_SEQUENCE__SEQUENCE:
				return sequence != null && !sequence.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (outOfOrderReset: ");
		result.append(outOfOrderReset);
		result.append(')');
		return result.toString();
	}

} //EventSequenceImpl
