/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.MemoryRegion;
import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Memory Region</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getBase <em>Base</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getFile <em>File</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getFlags <em>Flags</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getPages <em>Pages</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getPageSize <em>Page Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getSections <em>Sections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl#getSharedName <em>Shared Name</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MemoryRegionImpl extends ModelObjectImpl implements MemoryRegion {
	/**
	 * The default value of the '{@link #getBase() <em>Base</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBase()
	 * @generated
	 * @ordered
	 */
	protected static final long BASE_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getBase() <em>Base</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBase()
	 * @generated
	 * @ordered
	 */
	protected long base = BASE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFile() <em>File</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFile()
	 * @generated
	 * @ordered
	 */
	protected static final String FILE_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getFile() <em>File</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFile()
	 * @generated
	 * @ordered
	 */
	protected String file = FILE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFlags() <em>Flags</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFlags()
	 * @generated
	 * @ordered
	 */
	protected static final int FLAGS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getFlags() <em>Flags</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFlags()
	 * @generated
	 * @ordered
	 */
	protected int flags = FLAGS_EDEFAULT;

	/**
	 * The default value of the '{@link #getPages() <em>Pages</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPages()
	 * @generated
	 * @ordered
	 */
	protected static final int PAGES_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPages() <em>Pages</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPages()
	 * @generated
	 * @ordered
	 */
	protected int pages = PAGES_EDEFAULT;

	/**
	 * The default value of the '{@link #getPageSize() <em>Page Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPageSize()
	 * @generated
	 * @ordered
	 */
	protected static final long PAGE_SIZE_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getPageSize() <em>Page Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPageSize()
	 * @generated
	 * @ordered
	 */
	protected long pageSize = PAGE_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getSections() <em>Sections</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSections()
	 * @generated
	 * @ordered
	 */
	protected static final String SECTIONS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSections() <em>Sections</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSections()
	 * @generated
	 * @ordered
	 */
	protected String sections = SECTIONS_EDEFAULT;

	/**
	 * The default value of the '{@link #getSharedName() <em>Shared Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSharedName()
	 * @generated
	 * @ordered
	 */
	protected static final String SHARED_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSharedName() <em>Shared Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSharedName()
	 * @generated
	 * @ordered
	 */
	protected String sharedName = SHARED_NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MemoryRegionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getMemoryRegion();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getBase() {
		return base;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBase(long newBase) {
		long oldBase = base;
		base = newBase;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__BASE, oldBase, base));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFile() {
		return file;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFile(String newFile) {
		String oldFile = file;
		file = newFile;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__FILE, oldFile, file));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getFlags() {
		return flags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFlags(int newFlags) {
		int oldFlags = flags;
		flags = newFlags;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__FLAGS, oldFlags, flags));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPages() {
		return pages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPages(int newPages) {
		int oldPages = pages;
		pages = newPages;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__PAGES, oldPages, pages));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getPageSize() {
		return pageSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPageSize(long newPageSize) {
		long oldPageSize = pageSize;
		pageSize = newPageSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__PAGE_SIZE, oldPageSize, pageSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSections() {
		return sections;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSections(String newSections) {
		String oldSections = sections;
		sections = newSections;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__SECTIONS, oldSections, sections));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSharedName() {
		return sharedName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSharedName(String newSharedName) {
		String oldSharedName = sharedName;
		sharedName = newSharedName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MEMORY_REGION__SHARED_NAME, oldSharedName, sharedName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.MEMORY_REGION__BASE:
				return getBase();
			case ModelPackage.MEMORY_REGION__FILE:
				return getFile();
			case ModelPackage.MEMORY_REGION__FLAGS:
				return getFlags();
			case ModelPackage.MEMORY_REGION__PAGES:
				return getPages();
			case ModelPackage.MEMORY_REGION__PAGE_SIZE:
				return getPageSize();
			case ModelPackage.MEMORY_REGION__SECTIONS:
				return getSections();
			case ModelPackage.MEMORY_REGION__SHARED_NAME:
				return getSharedName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.MEMORY_REGION__BASE:
				setBase((Long)newValue);
				return;
			case ModelPackage.MEMORY_REGION__FILE:
				setFile((String)newValue);
				return;
			case ModelPackage.MEMORY_REGION__FLAGS:
				setFlags((Integer)newValue);
				return;
			case ModelPackage.MEMORY_REGION__PAGES:
				setPages((Integer)newValue);
				return;
			case ModelPackage.MEMORY_REGION__PAGE_SIZE:
				setPageSize((Long)newValue);
				return;
			case ModelPackage.MEMORY_REGION__SECTIONS:
				setSections((String)newValue);
				return;
			case ModelPackage.MEMORY_REGION__SHARED_NAME:
				setSharedName((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.MEMORY_REGION__BASE:
				setBase(BASE_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__FILE:
				setFile(FILE_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__FLAGS:
				setFlags(FLAGS_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__PAGES:
				setPages(PAGES_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__PAGE_SIZE:
				setPageSize(PAGE_SIZE_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__SECTIONS:
				setSections(SECTIONS_EDEFAULT);
				return;
			case ModelPackage.MEMORY_REGION__SHARED_NAME:
				setSharedName(SHARED_NAME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.MEMORY_REGION__BASE:
				return base != BASE_EDEFAULT;
			case ModelPackage.MEMORY_REGION__FILE:
				return FILE_EDEFAULT == null ? file != null : !FILE_EDEFAULT.equals(file);
			case ModelPackage.MEMORY_REGION__FLAGS:
				return flags != FLAGS_EDEFAULT;
			case ModelPackage.MEMORY_REGION__PAGES:
				return pages != PAGES_EDEFAULT;
			case ModelPackage.MEMORY_REGION__PAGE_SIZE:
				return pageSize != PAGE_SIZE_EDEFAULT;
			case ModelPackage.MEMORY_REGION__SECTIONS:
				return SECTIONS_EDEFAULT == null ? sections != null : !SECTIONS_EDEFAULT.equals(sections);
			case ModelPackage.MEMORY_REGION__SHARED_NAME:
				return SHARED_NAME_EDEFAULT == null ? sharedName != null : !SHARED_NAME_EDEFAULT.equals(sharedName);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (base: ");
		result.append(base);
		result.append(", file: ");
		result.append(file);
		result.append(", flags: ");
		result.append(flags);
		result.append(", pages: ");
		result.append(pages);
		result.append(", pageSize: ");
		result.append(pageSize);
		result.append(", sections: ");
		result.append(sections);
		result.append(", sharedName: ");
		result.append(sharedName);
		result.append(')');
		return result.toString();
	}

} //MemoryRegionImpl
