/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.DataFlowConnection;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TimeDistribution;
import com.inchron.realtime.root.model.VariableWriteAccess;
import com.inchron.realtime.root.model.VariableWriteAccessPolicy;
import com.inchron.realtime.root.model.VariableWriteAccessType;

import com.inchron.realtime.root.model.memory.ExplicitDataAccess;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Variable Write Access</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getDataAccess <em>Data Access</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getDelay <em>Delay</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#isIsBuffered <em>Is Buffered</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getNumber <em>Number</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl#getPolicy <em>Policy</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VariableWriteAccessImpl extends VariableAccessImpl implements VariableWriteAccess {
	/**
	 * The cached value of the '{@link #getConnection() <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnection()
	 * @generated
	 * @ordered
	 */
	protected DataFlowConnection connection;

	/**
	 * The cached value of the '{@link #getDataAccess() <em>Data Access</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataAccess()
	 * @generated
	 * @ordered
	 */
	protected ExplicitDataAccess dataAccess;

	/**
	 * The cached value of the '{@link #getDelay() <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDelay()
	 * @generated
	 * @ordered
	 */
	protected TimeDistribution delay;

	/**
	 * The default value of the '{@link #isIsBuffered() <em>Is Buffered</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsBuffered()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_BUFFERED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsBuffered() <em>Is Buffered</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsBuffered()
	 * @generated
	 * @ordered
	 */
	protected boolean isBuffered = IS_BUFFERED_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final VariableWriteAccessType TYPE_EDEFAULT = VariableWriteAccessType.GENERIC;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected VariableWriteAccessType type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getNumber() <em>Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumber()
	 * @generated
	 * @ordered
	 */
	protected static final int NUMBER_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getNumber() <em>Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNumber()
	 * @generated
	 * @ordered
	 */
	protected int number = NUMBER_EDEFAULT;

	/**
	 * The default value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final VariableWriteAccessPolicy POLICY_EDEFAULT = VariableWriteAccessPolicy.OVERWRITE_OLDEST;

	/**
	 * The cached value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected VariableWriteAccessPolicy policy = POLICY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VariableWriteAccessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getVariableWriteAccess();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowConnection getConnection() {
		if (connection != null && connection.eIsProxy()) {
			InternalEObject oldConnection = (InternalEObject)connection;
			connection = (DataFlowConnection)eResolveProxy(oldConnection);
			if (connection != oldConnection) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, oldConnection, connection));
			}
		}
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowConnection basicGetConnection() {
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConnection(DataFlowConnection newConnection, NotificationChain msgs) {
		DataFlowConnection oldConnection = connection;
		connection = newConnection;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, oldConnection, newConnection);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConnection(DataFlowConnection newConnection) {
		if (newConnection != connection) {
			NotificationChain msgs = null;
			if (connection != null)
				msgs = ((InternalEObject)connection).eInverseRemove(this, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, DataFlowConnection.class, msgs);
			if (newConnection != null)
				msgs = ((InternalEObject)newConnection).eInverseAdd(this, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, DataFlowConnection.class, msgs);
			msgs = basicSetConnection(newConnection, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION, newConnection, newConnection));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExplicitDataAccess getDataAccess() {
		return dataAccess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataAccess(ExplicitDataAccess newDataAccess, NotificationChain msgs) {
		ExplicitDataAccess oldDataAccess = dataAccess;
		dataAccess = newDataAccess;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS, oldDataAccess, newDataAccess);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataAccess(ExplicitDataAccess newDataAccess) {
		if (newDataAccess != dataAccess) {
			NotificationChain msgs = null;
			if (dataAccess != null)
				msgs = ((InternalEObject)dataAccess).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS, null, msgs);
			if (newDataAccess != null)
				msgs = ((InternalEObject)newDataAccess).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS, null, msgs);
			msgs = basicSetDataAccess(newDataAccess, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS, newDataAccess, newDataAccess));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistribution getDelay() {
		return delay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDelay(TimeDistribution newDelay, NotificationChain msgs) {
		TimeDistribution oldDelay = delay;
		delay = newDelay;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__DELAY, oldDelay, newDelay);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDelay(TimeDistribution newDelay) {
		if (newDelay != delay) {
			NotificationChain msgs = null;
			if (delay != null)
				msgs = ((InternalEObject)delay).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.VARIABLE_WRITE_ACCESS__DELAY, null, msgs);
			if (newDelay != null)
				msgs = ((InternalEObject)newDelay).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.VARIABLE_WRITE_ACCESS__DELAY, null, msgs);
			msgs = basicSetDelay(newDelay, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__DELAY, newDelay, newDelay));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsBuffered() {
		return isBuffered;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsBuffered(boolean newIsBuffered) {
		boolean oldIsBuffered = isBuffered;
		isBuffered = newIsBuffered;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__IS_BUFFERED, oldIsBuffered, isBuffered));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableWriteAccessType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(VariableWriteAccessType newType) {
		VariableWriteAccessType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getNumber() {
		return number;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNumber(int newNumber) {
		int oldNumber = number;
		number = newNumber;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__NUMBER, oldNumber, number));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableWriteAccessPolicy getPolicy() {
		return policy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPolicy(VariableWriteAccessPolicy newPolicy) {
		VariableWriteAccessPolicy oldPolicy = policy;
		policy = newPolicy == null ? POLICY_EDEFAULT : newPolicy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_WRITE_ACCESS__POLICY, oldPolicy, policy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				if (connection != null)
					msgs = ((InternalEObject)connection).eInverseRemove(this, ModelPackage.DATA_FLOW_CONNECTION__PROVIDER, DataFlowConnection.class, msgs);
				return basicSetConnection((DataFlowConnection)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				return basicSetConnection(null, msgs);
			case ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS:
				return basicSetDataAccess(null, msgs);
			case ModelPackage.VARIABLE_WRITE_ACCESS__DELAY:
				return basicSetDelay(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				if (resolve) return getConnection();
				return basicGetConnection();
			case ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS:
				return getDataAccess();
			case ModelPackage.VARIABLE_WRITE_ACCESS__DELAY:
				return getDelay();
			case ModelPackage.VARIABLE_WRITE_ACCESS__IS_BUFFERED:
				return isIsBuffered();
			case ModelPackage.VARIABLE_WRITE_ACCESS__TYPE:
				return getType();
			case ModelPackage.VARIABLE_WRITE_ACCESS__NUMBER:
				return getNumber();
			case ModelPackage.VARIABLE_WRITE_ACCESS__POLICY:
				return getPolicy();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				setConnection((DataFlowConnection)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS:
				setDataAccess((ExplicitDataAccess)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DELAY:
				setDelay((TimeDistribution)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__IS_BUFFERED:
				setIsBuffered((Boolean)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__TYPE:
				setType((VariableWriteAccessType)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__NUMBER:
				setNumber((Integer)newValue);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__POLICY:
				setPolicy((VariableWriteAccessPolicy)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				setConnection((DataFlowConnection)null);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS:
				setDataAccess((ExplicitDataAccess)null);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DELAY:
				setDelay((TimeDistribution)null);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__IS_BUFFERED:
				setIsBuffered(IS_BUFFERED_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__NUMBER:
				setNumber(NUMBER_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_WRITE_ACCESS__POLICY:
				setPolicy(POLICY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.VARIABLE_WRITE_ACCESS__CONNECTION:
				return connection != null;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DATA_ACCESS:
				return dataAccess != null;
			case ModelPackage.VARIABLE_WRITE_ACCESS__DELAY:
				return delay != null;
			case ModelPackage.VARIABLE_WRITE_ACCESS__IS_BUFFERED:
				return isBuffered != IS_BUFFERED_EDEFAULT;
			case ModelPackage.VARIABLE_WRITE_ACCESS__TYPE:
				return type != TYPE_EDEFAULT;
			case ModelPackage.VARIABLE_WRITE_ACCESS__NUMBER:
				return number != NUMBER_EDEFAULT;
			case ModelPackage.VARIABLE_WRITE_ACCESS__POLICY:
				return policy != POLICY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isBuffered: ");
		result.append(isBuffered);
		result.append(", type: ");
		result.append(type);
		result.append(", number: ");
		result.append(number);
		result.append(", policy: ");
		result.append(policy);
		result.append(')');
		return result.toString();
	}

} //VariableWriteAccessImpl
