/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#getAccessType <em>Access Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#getStartOffset <em>Start Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#getBandwidth <em>Bandwidth</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkSize <em>Chunk Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkPeriod <em>Chunk Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.DataAccess#isIsAsynchronous <em>Is Asynchronous</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess()
 * @model abstract="true"
 * @generated
 */
public interface DataAccess extends TraceObject {
	/**
	 * Returns the value of the '<em><b>Access Type</b></em>' attribute.
	 * The default value is <code>"Read"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.memory.DataAccessType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Access Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Access Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.DataAccessType
	 * @see #setAccessType(DataAccessType)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_AccessType()
	 * @model default="Read" required="true"
	 * @generated
	 */
	DataAccessType getAccessType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#getAccessType <em>Access Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Access Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.DataAccessType
	 * @see #getAccessType()
	 * @generated
	 */
	void setAccessType(DataAccessType value);

	/**
	 * Returns the value of the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Offset</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Offset</em>' containment reference.
	 * @see #setStartOffset(Time)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_StartOffset()
	 * @model containment="true"
	 * @generated
	 */
	Time getStartOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#getStartOffset <em>Start Offset</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Offset</em>' containment reference.
	 * @see #getStartOffset()
	 * @generated
	 */
	void setStartOffset(Time value);

	/**
	 * Returns the value of the '<em><b>Bandwidth</b></em>' attribute.
	 * The default value is <code>"1000000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bandwidth</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bandwidth</em>' attribute.
	 * @see #setBandwidth(long)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_Bandwidth()
	 * @model default="1000000" required="true"
	 * @generated
	 */
	long getBandwidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#getBandwidth <em>Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bandwidth</em>' attribute.
	 * @see #getBandwidth()
	 * @generated
	 */
	void setBandwidth(long value);

	/**
	 * Returns the value of the '<em><b>Chunk Size</b></em>' attribute.
	 * The default value is <code>"64"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Chunk Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Chunk Size</em>' attribute.
	 * @see #setChunkSize(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_ChunkSize()
	 * @model default="64"
	 * @generated
	 */
	int getChunkSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkSize <em>Chunk Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chunk Size</em>' attribute.
	 * @see #getChunkSize()
	 * @generated
	 */
	void setChunkSize(int value);

	/**
	 * Returns the value of the '<em><b>Chunk Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Chunk Period</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Chunk Period</em>' containment reference.
	 * @see #setChunkPeriod(Time)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_ChunkPeriod()
	 * @model containment="true"
	 * @generated
	 */
	Time getChunkPeriod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkPeriod <em>Chunk Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chunk Period</em>' containment reference.
	 * @see #getChunkPeriod()
	 * @generated
	 */
	void setChunkPeriod(Time value);

	/**
	 * Returns the value of the '<em><b>Is Asynchronous</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Asynchronous</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Asynchronous</em>' attribute.
	 * @see #setIsAsynchronous(boolean)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getDataAccess_IsAsynchronous()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsAsynchronous();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.DataAccess#isIsAsynchronous <em>Is Asynchronous</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Asynchronous</em>' attribute.
	 * @see #isIsAsynchronous()
	 * @generated
	 */
	void setIsAsynchronous(boolean value);

} // DataAccess
