/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.memory.MemoryFactory
 * @model kind="package"
 * @generated
 */
public interface MemoryPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "memory";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/model/memory";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "memory";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MemoryPackage eINSTANCE = com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl <em>Responder Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.ResponderPortImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getResponderPort()
	 * @generated
	 */
	int RESPONDER_PORT = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__OBJECT_ID = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Read Access Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__READ_ACCESS_PATTERN = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Write Access Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__WRITE_ACCESS_PATTERN = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Initiator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT__INITIATOR = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Responder Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Responder Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONDER_PORT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.InitiatorPortImpl <em>Initiator Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.InitiatorPortImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInitiatorPort()
	 * @generated
	 */
	int INITIATOR_PORT = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT__PRIORITY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Responder</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT__RESPONDER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Initiator Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Initiator Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INITIATOR_PORT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl <em>Qos Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.QosEntryImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getQosEntry()
	 * @generated
	 */
	int QOS_ENTRY = 2;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY__PRIORITY = 0;

	/**
	 * The feature id for the '<em><b>Minimum Bandwidth</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY__MINIMUM_BANDWIDTH = 1;

	/**
	 * The feature id for the '<em><b>In Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY__IN_PORT = 2;

	/**
	 * The feature id for the '<em><b>Out Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY__OUT_PORT = 3;

	/**
	 * The number of structural features of the '<em>Qos Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Qos Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QOS_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl <em>Interconnect</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.InterconnectImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInterconnect()
	 * @generated
	 */
	int INTERCONNECT = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__CLOCK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Bit Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__BIT_WIDTH = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Scheduling Policy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__SCHEDULING_POLICY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Connected Slaves</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__CONNECTED_SLAVES = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Connected Masters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__CONNECTED_MASTERS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__PRESCALER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Qos Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT__QOS_ENTRIES = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Interconnect</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Interconnect</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERCONNECT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.MemoryImpl <em>Memory</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getMemory()
	 * @generated
	 */
	int MEMORY = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__CLOCK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Bit Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__BIT_WIDTH = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__SIZE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__TYPE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__PRESCALER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Connected Master</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY__CONNECTED_MASTER = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Memory</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Memory</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.DataObjectImpl <em>Data Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.DataObjectImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataObject()
	 * @generated
	 */
	int DATA_OBJECT = 5;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT__SIZE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Memory</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT__MEMORY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Data Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Data Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OBJECT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl <em>Data Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.DataAccessImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataAccess()
	 * @generated
	 */
	int DATA_ACCESS = 6;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__OBJECT_ID = ModelPackage.TRACE_OBJECT__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Access Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__ACCESS_TYPE = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__START_OFFSET = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Bandwidth</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__BANDWIDTH = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Chunk Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__CHUNK_SIZE = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Chunk Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__CHUNK_PERIOD = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Is Asynchronous</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS__IS_ASYNCHRONOUS = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS_FEATURE_COUNT = ModelPackage.TRACE_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_ACCESS_OPERATION_COUNT = ModelPackage.TRACE_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.ExplicitDataAccessImpl <em>Explicit Data Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.ExplicitDataAccessImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getExplicitDataAccess()
	 * @generated
	 */
	int EXPLICIT_DATA_ACCESS = 7;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__OBJECT_ID = DATA_ACCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Access Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__ACCESS_TYPE = DATA_ACCESS__ACCESS_TYPE;

	/**
	 * The feature id for the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__START_OFFSET = DATA_ACCESS__START_OFFSET;

	/**
	 * The feature id for the '<em><b>Bandwidth</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__BANDWIDTH = DATA_ACCESS__BANDWIDTH;

	/**
	 * The feature id for the '<em><b>Chunk Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__CHUNK_SIZE = DATA_ACCESS__CHUNK_SIZE;

	/**
	 * The feature id for the '<em><b>Chunk Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__CHUNK_PERIOD = DATA_ACCESS__CHUNK_PERIOD;

	/**
	 * The feature id for the '<em><b>Is Asynchronous</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__IS_ASYNCHRONOUS = DATA_ACCESS__IS_ASYNCHRONOUS;

	/**
	 * The feature id for the '<em><b>Data Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS__DATA_OBJECT = DATA_ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Explicit Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS_FEATURE_COUNT = DATA_ACCESS_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Explicit Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DATA_ACCESS_OPERATION_COUNT = DATA_ACCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.impl.RateBasedDataAccessImpl <em>Rate Based Data Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.impl.RateBasedDataAccessImpl
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getRateBasedDataAccess()
	 * @generated
	 */
	int RATE_BASED_DATA_ACCESS = 8;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__OBJECT_ID = DATA_ACCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Access Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__ACCESS_TYPE = DATA_ACCESS__ACCESS_TYPE;

	/**
	 * The feature id for the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__START_OFFSET = DATA_ACCESS__START_OFFSET;

	/**
	 * The feature id for the '<em><b>Bandwidth</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__BANDWIDTH = DATA_ACCESS__BANDWIDTH;

	/**
	 * The feature id for the '<em><b>Chunk Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__CHUNK_SIZE = DATA_ACCESS__CHUNK_SIZE;

	/**
	 * The feature id for the '<em><b>Chunk Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__CHUNK_PERIOD = DATA_ACCESS__CHUNK_PERIOD;

	/**
	 * The feature id for the '<em><b>Is Asynchronous</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__IS_ASYNCHRONOUS = DATA_ACCESS__IS_ASYNCHRONOUS;

	/**
	 * The feature id for the '<em><b>Memory</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS__MEMORY = DATA_ACCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Rate Based Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS_FEATURE_COUNT = DATA_ACCESS_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Rate Based Data Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RATE_BASED_DATA_ACCESS_OPERATION_COUNT = DATA_ACCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.InterconnectScheduling <em>Interconnect Scheduling</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.InterconnectScheduling
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInterconnectScheduling()
	 * @generated
	 */
	int INTERCONNECT_SCHEDULING = 9;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.MemoryType <em>Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.MemoryType
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getMemoryType()
	 * @generated
	 */
	int MEMORY_TYPE = 10;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.memory.DataAccessType <em>Data Access Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.memory.DataAccessType
	 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataAccessType()
	 * @generated
	 */
	int DATA_ACCESS_TYPE = 11;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.ResponderPort <em>Responder Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Responder Port</em>'.
	 * @see com.inchron.realtime.root.model.memory.ResponderPort
	 * @generated
	 */
	EClass getResponderPort();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.ResponderPort#getReadAccessPattern <em>Read Access Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Read Access Pattern</em>'.
	 * @see com.inchron.realtime.root.model.memory.ResponderPort#getReadAccessPattern()
	 * @see #getResponderPort()
	 * @generated
	 */
	EAttribute getResponderPort_ReadAccessPattern();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.ResponderPort#getWriteAccessPattern <em>Write Access Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Write Access Pattern</em>'.
	 * @see com.inchron.realtime.root.model.memory.ResponderPort#getWriteAccessPattern()
	 * @see #getResponderPort()
	 * @generated
	 */
	EAttribute getResponderPort_WriteAccessPattern();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.ResponderPort#getInitiator <em>Initiator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Initiator</em>'.
	 * @see com.inchron.realtime.root.model.memory.ResponderPort#getInitiator()
	 * @see #getResponderPort()
	 * @generated
	 */
	EReference getResponderPort_Initiator();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.InitiatorPort <em>Initiator Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Initiator Port</em>'.
	 * @see com.inchron.realtime.root.model.memory.InitiatorPort
	 * @generated
	 */
	EClass getInitiatorPort();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.InitiatorPort#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see com.inchron.realtime.root.model.memory.InitiatorPort#getPriority()
	 * @see #getInitiatorPort()
	 * @generated
	 */
	EAttribute getInitiatorPort_Priority();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.InitiatorPort#getResponder <em>Responder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Responder</em>'.
	 * @see com.inchron.realtime.root.model.memory.InitiatorPort#getResponder()
	 * @see #getInitiatorPort()
	 * @generated
	 */
	EReference getInitiatorPort_Responder();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.QosEntry <em>Qos Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Qos Entry</em>'.
	 * @see com.inchron.realtime.root.model.memory.QosEntry
	 * @generated
	 */
	EClass getQosEntry();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.QosEntry#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see com.inchron.realtime.root.model.memory.QosEntry#getPriority()
	 * @see #getQosEntry()
	 * @generated
	 */
	EAttribute getQosEntry_Priority();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.QosEntry#getMinimumBandwidth <em>Minimum Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Minimum Bandwidth</em>'.
	 * @see com.inchron.realtime.root.model.memory.QosEntry#getMinimumBandwidth()
	 * @see #getQosEntry()
	 * @generated
	 */
	EAttribute getQosEntry_MinimumBandwidth();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.QosEntry#getInPort <em>In Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>In Port</em>'.
	 * @see com.inchron.realtime.root.model.memory.QosEntry#getInPort()
	 * @see #getQosEntry()
	 * @generated
	 */
	EReference getQosEntry_InPort();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.QosEntry#getOutPort <em>Out Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Out Port</em>'.
	 * @see com.inchron.realtime.root.model.memory.QosEntry#getOutPort()
	 * @see #getQosEntry()
	 * @generated
	 */
	EReference getQosEntry_OutPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.Interconnect <em>Interconnect</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interconnect</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect
	 * @generated
	 */
	EClass getInterconnect();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Interconnect#getBitWidth <em>Bit Width</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bit Width</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getBitWidth()
	 * @see #getInterconnect()
	 * @generated
	 */
	EAttribute getInterconnect_BitWidth();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Interconnect#getSchedulingPolicy <em>Scheduling Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Scheduling Policy</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getSchedulingPolicy()
	 * @see #getInterconnect()
	 * @generated
	 */
	EAttribute getInterconnect_SchedulingPolicy();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.memory.Interconnect#getConnectedSlaves <em>Connected Slaves</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connected Slaves</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getConnectedSlaves()
	 * @see #getInterconnect()
	 * @generated
	 */
	EReference getInterconnect_ConnectedSlaves();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.memory.Interconnect#getConnectedMasters <em>Connected Masters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connected Masters</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getConnectedMasters()
	 * @see #getInterconnect()
	 * @generated
	 */
	EReference getInterconnect_ConnectedMasters();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Interconnect#getPrescaler <em>Prescaler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prescaler</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getPrescaler()
	 * @see #getInterconnect()
	 * @generated
	 */
	EAttribute getInterconnect_Prescaler();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.memory.Interconnect#getQosEntries <em>Qos Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Qos Entries</em>'.
	 * @see com.inchron.realtime.root.model.memory.Interconnect#getQosEntries()
	 * @see #getInterconnect()
	 * @generated
	 */
	EReference getInterconnect_QosEntries();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.Memory <em>Memory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory
	 * @generated
	 */
	EClass getMemory();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Memory#getBitWidth <em>Bit Width</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bit Width</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory#getBitWidth()
	 * @see #getMemory()
	 * @generated
	 */
	EAttribute getMemory_BitWidth();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Memory#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory#getSize()
	 * @see #getMemory()
	 * @generated
	 */
	EAttribute getMemory_Size();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Memory#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory#getType()
	 * @see #getMemory()
	 * @generated
	 */
	EAttribute getMemory_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.Memory#getPrescaler <em>Prescaler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prescaler</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory#getPrescaler()
	 * @see #getMemory()
	 * @generated
	 */
	EAttribute getMemory_Prescaler();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.memory.Memory#getConnectedMaster <em>Connected Master</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connected Master</em>'.
	 * @see com.inchron.realtime.root.model.memory.Memory#getConnectedMaster()
	 * @see #getMemory()
	 * @generated
	 */
	EReference getMemory_ConnectedMaster();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.DataObject <em>Data Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Object</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataObject
	 * @generated
	 */
	EClass getDataObject();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.DataObject#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataObject#getSize()
	 * @see #getDataObject()
	 * @generated
	 */
	EAttribute getDataObject_Size();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.DataObject#getMemory <em>Memory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Memory</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataObject#getMemory()
	 * @see #getDataObject()
	 * @generated
	 */
	EReference getDataObject_Memory();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.DataAccess <em>Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Access</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess
	 * @generated
	 */
	EClass getDataAccess();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.DataAccess#getAccessType <em>Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Access Type</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#getAccessType()
	 * @see #getDataAccess()
	 * @generated
	 */
	EAttribute getDataAccess_AccessType();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.memory.DataAccess#getStartOffset <em>Start Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Offset</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#getStartOffset()
	 * @see #getDataAccess()
	 * @generated
	 */
	EReference getDataAccess_StartOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.DataAccess#getBandwidth <em>Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bandwidth</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#getBandwidth()
	 * @see #getDataAccess()
	 * @generated
	 */
	EAttribute getDataAccess_Bandwidth();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkSize <em>Chunk Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Chunk Size</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#getChunkSize()
	 * @see #getDataAccess()
	 * @generated
	 */
	EAttribute getDataAccess_ChunkSize();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.memory.DataAccess#getChunkPeriod <em>Chunk Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Chunk Period</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#getChunkPeriod()
	 * @see #getDataAccess()
	 * @generated
	 */
	EReference getDataAccess_ChunkPeriod();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.memory.DataAccess#isIsAsynchronous <em>Is Asynchronous</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Asynchronous</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccess#isIsAsynchronous()
	 * @see #getDataAccess()
	 * @generated
	 */
	EAttribute getDataAccess_IsAsynchronous();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess <em>Explicit Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Explicit Data Access</em>'.
	 * @see com.inchron.realtime.root.model.memory.ExplicitDataAccess
	 * @generated
	 */
	EClass getExplicitDataAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess#getDataObject <em>Data Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Object</em>'.
	 * @see com.inchron.realtime.root.model.memory.ExplicitDataAccess#getDataObject()
	 * @see #getExplicitDataAccess()
	 * @generated
	 */
	EReference getExplicitDataAccess_DataObject();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.memory.RateBasedDataAccess <em>Rate Based Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rate Based Data Access</em>'.
	 * @see com.inchron.realtime.root.model.memory.RateBasedDataAccess
	 * @generated
	 */
	EClass getRateBasedDataAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.memory.RateBasedDataAccess#getMemory <em>Memory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Memory</em>'.
	 * @see com.inchron.realtime.root.model.memory.RateBasedDataAccess#getMemory()
	 * @see #getRateBasedDataAccess()
	 * @generated
	 */
	EReference getRateBasedDataAccess_Memory();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.memory.InterconnectScheduling <em>Interconnect Scheduling</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Interconnect Scheduling</em>'.
	 * @see com.inchron.realtime.root.model.memory.InterconnectScheduling
	 * @generated
	 */
	EEnum getInterconnectScheduling();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.memory.MemoryType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.memory.MemoryType
	 * @generated
	 */
	EEnum getMemoryType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.memory.DataAccessType <em>Data Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Data Access Type</em>'.
	 * @see com.inchron.realtime.root.model.memory.DataAccessType
	 * @generated
	 */
	EEnum getDataAccessType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MemoryFactory getMemoryFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.ResponderPortImpl <em>Responder Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.ResponderPortImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getResponderPort()
		 * @generated
		 */
		EClass RESPONDER_PORT = eINSTANCE.getResponderPort();

		/**
		 * The meta object literal for the '<em><b>Read Access Pattern</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESPONDER_PORT__READ_ACCESS_PATTERN = eINSTANCE.getResponderPort_ReadAccessPattern();

		/**
		 * The meta object literal for the '<em><b>Write Access Pattern</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESPONDER_PORT__WRITE_ACCESS_PATTERN = eINSTANCE.getResponderPort_WriteAccessPattern();

		/**
		 * The meta object literal for the '<em><b>Initiator</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESPONDER_PORT__INITIATOR = eINSTANCE.getResponderPort_Initiator();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.InitiatorPortImpl <em>Initiator Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.InitiatorPortImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInitiatorPort()
		 * @generated
		 */
		EClass INITIATOR_PORT = eINSTANCE.getInitiatorPort();

		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INITIATOR_PORT__PRIORITY = eINSTANCE.getInitiatorPort_Priority();

		/**
		 * The meta object literal for the '<em><b>Responder</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INITIATOR_PORT__RESPONDER = eINSTANCE.getInitiatorPort_Responder();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl <em>Qos Entry</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.QosEntryImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getQosEntry()
		 * @generated
		 */
		EClass QOS_ENTRY = eINSTANCE.getQosEntry();

		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QOS_ENTRY__PRIORITY = eINSTANCE.getQosEntry_Priority();

		/**
		 * The meta object literal for the '<em><b>Minimum Bandwidth</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QOS_ENTRY__MINIMUM_BANDWIDTH = eINSTANCE.getQosEntry_MinimumBandwidth();

		/**
		 * The meta object literal for the '<em><b>In Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QOS_ENTRY__IN_PORT = eINSTANCE.getQosEntry_InPort();

		/**
		 * The meta object literal for the '<em><b>Out Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QOS_ENTRY__OUT_PORT = eINSTANCE.getQosEntry_OutPort();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl <em>Interconnect</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.InterconnectImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInterconnect()
		 * @generated
		 */
		EClass INTERCONNECT = eINSTANCE.getInterconnect();

		/**
		 * The meta object literal for the '<em><b>Bit Width</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTERCONNECT__BIT_WIDTH = eINSTANCE.getInterconnect_BitWidth();

		/**
		 * The meta object literal for the '<em><b>Scheduling Policy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTERCONNECT__SCHEDULING_POLICY = eINSTANCE.getInterconnect_SchedulingPolicy();

		/**
		 * The meta object literal for the '<em><b>Connected Slaves</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERCONNECT__CONNECTED_SLAVES = eINSTANCE.getInterconnect_ConnectedSlaves();

		/**
		 * The meta object literal for the '<em><b>Connected Masters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERCONNECT__CONNECTED_MASTERS = eINSTANCE.getInterconnect_ConnectedMasters();

		/**
		 * The meta object literal for the '<em><b>Prescaler</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTERCONNECT__PRESCALER = eINSTANCE.getInterconnect_Prescaler();

		/**
		 * The meta object literal for the '<em><b>Qos Entries</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERCONNECT__QOS_ENTRIES = eINSTANCE.getInterconnect_QosEntries();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.MemoryImpl <em>Memory</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getMemory()
		 * @generated
		 */
		EClass MEMORY = eINSTANCE.getMemory();

		/**
		 * The meta object literal for the '<em><b>Bit Width</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEMORY__BIT_WIDTH = eINSTANCE.getMemory_BitWidth();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEMORY__SIZE = eINSTANCE.getMemory_Size();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEMORY__TYPE = eINSTANCE.getMemory_Type();

		/**
		 * The meta object literal for the '<em><b>Prescaler</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEMORY__PRESCALER = eINSTANCE.getMemory_Prescaler();

		/**
		 * The meta object literal for the '<em><b>Connected Master</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MEMORY__CONNECTED_MASTER = eINSTANCE.getMemory_ConnectedMaster();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.DataObjectImpl <em>Data Object</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.DataObjectImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataObject()
		 * @generated
		 */
		EClass DATA_OBJECT = eINSTANCE.getDataObject();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_OBJECT__SIZE = eINSTANCE.getDataObject_Size();

		/**
		 * The meta object literal for the '<em><b>Memory</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_OBJECT__MEMORY = eINSTANCE.getDataObject_Memory();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.DataAccessImpl <em>Data Access</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.DataAccessImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataAccess()
		 * @generated
		 */
		EClass DATA_ACCESS = eINSTANCE.getDataAccess();

		/**
		 * The meta object literal for the '<em><b>Access Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ACCESS__ACCESS_TYPE = eINSTANCE.getDataAccess_AccessType();

		/**
		 * The meta object literal for the '<em><b>Start Offset</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_ACCESS__START_OFFSET = eINSTANCE.getDataAccess_StartOffset();

		/**
		 * The meta object literal for the '<em><b>Bandwidth</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ACCESS__BANDWIDTH = eINSTANCE.getDataAccess_Bandwidth();

		/**
		 * The meta object literal for the '<em><b>Chunk Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ACCESS__CHUNK_SIZE = eINSTANCE.getDataAccess_ChunkSize();

		/**
		 * The meta object literal for the '<em><b>Chunk Period</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_ACCESS__CHUNK_PERIOD = eINSTANCE.getDataAccess_ChunkPeriod();

		/**
		 * The meta object literal for the '<em><b>Is Asynchronous</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_ACCESS__IS_ASYNCHRONOUS = eINSTANCE.getDataAccess_IsAsynchronous();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.ExplicitDataAccessImpl <em>Explicit Data Access</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.ExplicitDataAccessImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getExplicitDataAccess()
		 * @generated
		 */
		EClass EXPLICIT_DATA_ACCESS = eINSTANCE.getExplicitDataAccess();

		/**
		 * The meta object literal for the '<em><b>Data Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLICIT_DATA_ACCESS__DATA_OBJECT = eINSTANCE.getExplicitDataAccess_DataObject();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.impl.RateBasedDataAccessImpl <em>Rate Based Data Access</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.impl.RateBasedDataAccessImpl
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getRateBasedDataAccess()
		 * @generated
		 */
		EClass RATE_BASED_DATA_ACCESS = eINSTANCE.getRateBasedDataAccess();

		/**
		 * The meta object literal for the '<em><b>Memory</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RATE_BASED_DATA_ACCESS__MEMORY = eINSTANCE.getRateBasedDataAccess_Memory();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.InterconnectScheduling <em>Interconnect Scheduling</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.InterconnectScheduling
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getInterconnectScheduling()
		 * @generated
		 */
		EEnum INTERCONNECT_SCHEDULING = eINSTANCE.getInterconnectScheduling();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.MemoryType <em>Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.MemoryType
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getMemoryType()
		 * @generated
		 */
		EEnum MEMORY_TYPE = eINSTANCE.getMemoryType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.memory.DataAccessType <em>Data Access Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.memory.DataAccessType
		 * @see com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl#getDataAccessType()
		 * @generated
		 */
		EEnum DATA_ACCESS_TYPE = eINSTANCE.getDataAccessType();

	}

} //MemoryPackage
