/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Qos Entry</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.QosEntry#getPriority <em>Priority</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.QosEntry#getMinimumBandwidth <em>Minimum Bandwidth</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.QosEntry#getInPort <em>In Port</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.QosEntry#getOutPort <em>Out Port</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getQosEntry()
 * @model
 * @generated
 */
public interface QosEntry extends EObject {
	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getQosEntry_Priority()
	 * @model default="0"
	 * @generated
	 */
	int getPriority();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.QosEntry#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);

	/**
	 * Returns the value of the '<em><b>Minimum Bandwidth</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Minimum Bandwidth</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Minimum Bandwidth</em>' attribute.
	 * @see #setMinimumBandwidth(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getQosEntry_MinimumBandwidth()
	 * @model default="0"
	 * @generated
	 */
	int getMinimumBandwidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.QosEntry#getMinimumBandwidth <em>Minimum Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Minimum Bandwidth</em>' attribute.
	 * @see #getMinimumBandwidth()
	 * @generated
	 */
	void setMinimumBandwidth(int value);

	/**
	 * Returns the value of the '<em><b>In Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>In Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>In Port</em>' reference.
	 * @see #setInPort(ResponderPort)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getQosEntry_InPort()
	 * @model required="true"
	 * @generated
	 */
	ResponderPort getInPort();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.QosEntry#getInPort <em>In Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>In Port</em>' reference.
	 * @see #getInPort()
	 * @generated
	 */
	void setInPort(ResponderPort value);

	/**
	 * Returns the value of the '<em><b>Out Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Out Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Out Port</em>' reference.
	 * @see #setOutPort(InitiatorPort)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getQosEntry_OutPort()
	 * @model required="true"
	 * @generated
	 */
	InitiatorPort getOutPort();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.QosEntry#getOutPort <em>Out Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Out Port</em>' reference.
	 * @see #getOutPort()
	 * @generated
	 */
	void setOutPort(InitiatorPort value);

} // QosEntry
