/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AFDX Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getDirection <em>Direction</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getQueueLength <em>Queue Length</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXPort()
 * @model
 * @generated
 */
public interface AFDXPort extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Direction</b></em>' attribute.
	 * The default value is <code>"Sender"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.peripheral.AFDXPortDirection}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Direction</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Direction</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortDirection
	 * @see #setDirection(AFDXPortDirection)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXPort_Direction()
	 * @model default="Sender" required="true"
	 * @generated
	 */
	AFDXPortDirection getDirection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getDirection <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Direction</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortDirection
	 * @see #getDirection()
	 * @generated
	 */
	void setDirection(AFDXPortDirection value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Queuing"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.peripheral.AFDXPortType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortType
	 * @see #setType(AFDXPortType)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXPort_Type()
	 * @model default="Queuing" required="true"
	 * @generated
	 */
	AFDXPortType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.AFDXPortType
	 * @see #getType()
	 * @generated
	 */
	void setType(AFDXPortType value);

	/**
	 * Returns the value of the '<em><b>Queue Length</b></em>' attribute.
	 * The default value is <code>"5"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Queue Length</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Queue Length</em>' attribute.
	 * @see #setQueueLength(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXPort_QueueLength()
	 * @model default="5" required="true"
	 * @generated
	 */
	int getQueueLength();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXPort#getQueueLength <em>Queue Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Queue Length</em>' attribute.
	 * @see #getQueueLength()
	 * @generated
	 */
	void setQueueLength(int value);

} // AFDXPort
