/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Ethernet Switch</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isFastForward <em>Fast Forward</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isLogEnabled <em>Log Enabled</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernetSwitch()
 * @model
 * @generated
 */
public interface EthernetSwitch extends AbstractEthernet {
	/**
	 * Returns the value of the '<em><b>Fast Forward</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Fast Forward</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Fast Forward</em>' attribute.
	 * @see #setFastForward(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernetSwitch_FastForward()
	 * @model default="true"
	 * @generated
	 */
	boolean isFastForward();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isFastForward <em>Fast Forward</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Fast Forward</em>' attribute.
	 * @see #isFastForward()
	 * @generated
	 */
	void setFastForward(boolean value);

	/**
	 * Returns the value of the '<em><b>Log Enabled</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Log Enabled</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Log Enabled</em>' attribute.
	 * @see #setLogEnabled(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getEthernetSwitch_LogEnabled()
	 * @model default="false"
	 * @generated
	 */
	boolean isLogEnabled();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.EthernetSwitch#isLogEnabled <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Log Enabled</em>' attribute.
	 * @see #isLogEnabled()
	 * @generated
	 */
	void setLogEnabled(boolean value);

} // EthernetSwitch
