/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Flex Ray Bus</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMacroTick <em>Gd Macro Tick</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMacroPerCycle <em>GMacro Per Cycle</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGNumberOfStaticSlots <em>GNumber Of Static Slots</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdNit <em>Gd Nit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGPayloadLengthStatic <em>GPayload Length Static</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdStaticSlot <em>Gd Static Slot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdDynamicSlotIdlePhase <em>Gd Dynamic Slot Idle Phase</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMiniSlot <em>Gd Mini Slot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdActionPointOffset <em>Gd Action Point Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMinislotActionPointOffset <em>Gd Minislot Action Point Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdTSSTransmitter <em>Gd TSS Transmitter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGSyncNodeMax <em>GSync Node Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGColdstartAttempts <em>GColdstart Attempts</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionFatal <em>GMax Without Clock Correction Fatal</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionPassive <em>GMax Without Clock Correction Passive</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus()
 * @model
 * @generated
 */
public interface FlexRayBus extends Bus {
	/**
	 * Returns the value of the '<em><b>Speed</b></em>' attribute.
	 * The default value is <code>"10000000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Speed</em>' attribute.
	 * @see #setSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_Speed()
	 * @model default="10000000"
	 * @generated
	 */
	int getSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getSpeed <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Speed</em>' attribute.
	 * @see #getSpeed()
	 * @generated
	 */
	void setSpeed(int value);

	/**
	 * Returns the value of the '<em><b>Gd Macro Tick</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Macro Tick</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Macro Tick</em>' attribute.
	 * @see #setGdMacroTick(double)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdMacroTick()
	 * @model default="1.0"
	 * @generated
	 */
	double getGdMacroTick();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMacroTick <em>Gd Macro Tick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Macro Tick</em>' attribute.
	 * @see #getGdMacroTick()
	 * @generated
	 */
	void setGdMacroTick(double value);

	/**
	 * Returns the value of the '<em><b>GMacro Per Cycle</b></em>' attribute.
	 * The default value is <code>"5000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GMacro Per Cycle</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GMacro Per Cycle</em>' attribute.
	 * @see #setGMacroPerCycle(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GMacroPerCycle()
	 * @model default="5000"
	 * @generated
	 */
	int getGMacroPerCycle();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMacroPerCycle <em>GMacro Per Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GMacro Per Cycle</em>' attribute.
	 * @see #getGMacroPerCycle()
	 * @generated
	 */
	void setGMacroPerCycle(int value);

	/**
	 * Returns the value of the '<em><b>GNumber Of Static Slots</b></em>' attribute.
	 * The default value is <code>"89"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GNumber Of Static Slots</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GNumber Of Static Slots</em>' attribute.
	 * @see #setGNumberOfStaticSlots(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GNumberOfStaticSlots()
	 * @model default="89"
	 * @generated
	 */
	int getGNumberOfStaticSlots();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGNumberOfStaticSlots <em>GNumber Of Static Slots</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GNumber Of Static Slots</em>' attribute.
	 * @see #getGNumberOfStaticSlots()
	 * @generated
	 */
	void setGNumberOfStaticSlots(int value);

	/**
	 * Returns the value of the '<em><b>Gd Nit</b></em>' attribute.
	 * The default value is <code>"100"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Nit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Nit</em>' attribute.
	 * @see #setGdNit(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdNit()
	 * @model default="100"
	 * @generated
	 */
	int getGdNit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdNit <em>Gd Nit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Nit</em>' attribute.
	 * @see #getGdNit()
	 * @generated
	 */
	void setGdNit(int value);

	/**
	 * Returns the value of the '<em><b>GPayload Length Static</b></em>' attribute.
	 * The default value is <code>"8"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GPayload Length Static</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GPayload Length Static</em>' attribute.
	 * @see #setGPayloadLengthStatic(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GPayloadLengthStatic()
	 * @model default="8"
	 * @generated
	 */
	int getGPayloadLengthStatic();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGPayloadLengthStatic <em>GPayload Length Static</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GPayload Length Static</em>' attribute.
	 * @see #getGPayloadLengthStatic()
	 * @generated
	 */
	void setGPayloadLengthStatic(int value);

	/**
	 * Returns the value of the '<em><b>Gd Static Slot</b></em>' attribute.
	 * The default value is <code>"34"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Static Slot</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Static Slot</em>' attribute.
	 * @see #setGdStaticSlot(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdStaticSlot()
	 * @model default="34"
	 * @generated
	 */
	int getGdStaticSlot();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdStaticSlot <em>Gd Static Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Static Slot</em>' attribute.
	 * @see #getGdStaticSlot()
	 * @generated
	 */
	void setGdStaticSlot(int value);

	/**
	 * Returns the value of the '<em><b>Gd Dynamic Slot Idle Phase</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Dynamic Slot Idle Phase</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Dynamic Slot Idle Phase</em>' attribute.
	 * @see #setGdDynamicSlotIdlePhase(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdDynamicSlotIdlePhase()
	 * @model default="1"
	 * @generated
	 */
	int getGdDynamicSlotIdlePhase();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdDynamicSlotIdlePhase <em>Gd Dynamic Slot Idle Phase</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Dynamic Slot Idle Phase</em>' attribute.
	 * @see #getGdDynamicSlotIdlePhase()
	 * @generated
	 */
	void setGdDynamicSlotIdlePhase(int value);

	/**
	 * Returns the value of the '<em><b>Gd Mini Slot</b></em>' attribute.
	 * The default value is <code>"7"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Mini Slot</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Mini Slot</em>' attribute.
	 * @see #setGdMiniSlot(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdMiniSlot()
	 * @model default="7"
	 * @generated
	 */
	int getGdMiniSlot();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMiniSlot <em>Gd Mini Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Mini Slot</em>' attribute.
	 * @see #getGdMiniSlot()
	 * @generated
	 */
	void setGdMiniSlot(int value);

	/**
	 * Returns the value of the '<em><b>Gd Action Point Offset</b></em>' attribute.
	 * The default value is <code>"3"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Action Point Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Action Point Offset</em>' attribute.
	 * @see #setGdActionPointOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdActionPointOffset()
	 * @model default="3"
	 * @generated
	 */
	int getGdActionPointOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdActionPointOffset <em>Gd Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Action Point Offset</em>' attribute.
	 * @see #getGdActionPointOffset()
	 * @generated
	 */
	void setGdActionPointOffset(int value);

	/**
	 * Returns the value of the '<em><b>Gd Minislot Action Point Offset</b></em>' attribute.
	 * The default value is <code>"3"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd Minislot Action Point Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd Minislot Action Point Offset</em>' attribute.
	 * @see #setGdMinislotActionPointOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdMinislotActionPointOffset()
	 * @model default="3"
	 * @generated
	 */
	int getGdMinislotActionPointOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdMinislotActionPointOffset <em>Gd Minislot Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd Minislot Action Point Offset</em>' attribute.
	 * @see #getGdMinislotActionPointOffset()
	 * @generated
	 */
	void setGdMinislotActionPointOffset(int value);

	/**
	 * Returns the value of the '<em><b>Gd TSS Transmitter</b></em>' attribute.
	 * The default value is <code>"15"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Gd TSS Transmitter</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Gd TSS Transmitter</em>' attribute.
	 * @see #setGdTSSTransmitter(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GdTSSTransmitter()
	 * @model default="15"
	 * @generated
	 */
	int getGdTSSTransmitter();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGdTSSTransmitter <em>Gd TSS Transmitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Gd TSS Transmitter</em>' attribute.
	 * @see #getGdTSSTransmitter()
	 * @generated
	 */
	void setGdTSSTransmitter(int value);

	/**
	 * Returns the value of the '<em><b>GSync Node Max</b></em>' attribute.
	 * The default value is <code>"10"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GSync Node Max</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GSync Node Max</em>' attribute.
	 * @see #setGSyncNodeMax(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GSyncNodeMax()
	 * @model default="10"
	 * @generated
	 */
	int getGSyncNodeMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGSyncNodeMax <em>GSync Node Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GSync Node Max</em>' attribute.
	 * @see #getGSyncNodeMax()
	 * @generated
	 */
	void setGSyncNodeMax(int value);

	/**
	 * Returns the value of the '<em><b>GColdstart Attempts</b></em>' attribute.
	 * The default value is <code>"31"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GColdstart Attempts</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GColdstart Attempts</em>' attribute.
	 * @see #setGColdstartAttempts(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GColdstartAttempts()
	 * @model default="31"
	 * @generated
	 */
	int getGColdstartAttempts();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGColdstartAttempts <em>GColdstart Attempts</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GColdstart Attempts</em>' attribute.
	 * @see #getGColdstartAttempts()
	 * @generated
	 */
	void setGColdstartAttempts(int value);

	/**
	 * Returns the value of the '<em><b>GMax Without Clock Correction Fatal</b></em>' attribute.
	 * The default value is <code>"6"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GMax Without Clock Correction Fatal</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GMax Without Clock Correction Fatal</em>' attribute.
	 * @see #setGMaxWithoutClockCorrectionFatal(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GMaxWithoutClockCorrectionFatal()
	 * @model default="6"
	 * @generated
	 */
	int getGMaxWithoutClockCorrectionFatal();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionFatal <em>GMax Without Clock Correction Fatal</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GMax Without Clock Correction Fatal</em>' attribute.
	 * @see #getGMaxWithoutClockCorrectionFatal()
	 * @generated
	 */
	void setGMaxWithoutClockCorrectionFatal(int value);

	/**
	 * Returns the value of the '<em><b>GMax Without Clock Correction Passive</b></em>' attribute.
	 * The default value is <code>"3"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>GMax Without Clock Correction Passive</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>GMax Without Clock Correction Passive</em>' attribute.
	 * @see #setGMaxWithoutClockCorrectionPassive(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRayBus_GMaxWithoutClockCorrectionPassive()
	 * @model default="3"
	 * @generated
	 */
	int getGMaxWithoutClockCorrectionPassive();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRayBus#getGMaxWithoutClockCorrectionPassive <em>GMax Without Clock Correction Passive</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>GMax Without Clock Correction Passive</em>' attribute.
	 * @see #getGMaxWithoutClockCorrectionPassive()
	 * @generated
	 */
	void setGMaxWithoutClockCorrectionPassive(int value);

} // FlexRayBus
