/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.peripheral.AS5643Bus;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AS5643 Bus</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AS5643BusImpl#getFrameLength <em>Frame Length</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AS5643BusImpl extends BusImpl implements AS5643Bus {
	/**
	 * The default value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int SPEED_EDEFAULT = 100000000;

	/**
	 * The cached value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected int speed = SPEED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getFrameLength() <em>Frame Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFrameLength()
	 * @generated
	 * @ordered
	 */
	protected Time frameLength;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AS5643BusImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.AS5643_BUS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpeed(int newSpeed) {
		int oldSpeed = speed;
		speed = newSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643_BUS__SPEED, oldSpeed, speed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getFrameLength() {
		return frameLength;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFrameLength(Time newFrameLength, NotificationChain msgs) {
		Time oldFrameLength = frameLength;
		frameLength = newFrameLength;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643_BUS__FRAME_LENGTH, oldFrameLength, newFrameLength);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFrameLength(Time newFrameLength) {
		if (newFrameLength != frameLength) {
			NotificationChain msgs = null;
			if (frameLength != null)
				msgs = ((InternalEObject)frameLength).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.AS5643_BUS__FRAME_LENGTH, null, msgs);
			if (newFrameLength != null)
				msgs = ((InternalEObject)newFrameLength).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.AS5643_BUS__FRAME_LENGTH, null, msgs);
			msgs = basicSetFrameLength(newFrameLength, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AS5643_BUS__FRAME_LENGTH, newFrameLength, newFrameLength));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PeripheralPackage.AS5643_BUS__FRAME_LENGTH:
				return basicSetFrameLength(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.AS5643_BUS__SPEED:
				return getSpeed();
			case PeripheralPackage.AS5643_BUS__FRAME_LENGTH:
				return getFrameLength();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.AS5643_BUS__SPEED:
				setSpeed((Integer)newValue);
				return;
			case PeripheralPackage.AS5643_BUS__FRAME_LENGTH:
				setFrameLength((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AS5643_BUS__SPEED:
				setSpeed(SPEED_EDEFAULT);
				return;
			case PeripheralPackage.AS5643_BUS__FRAME_LENGTH:
				setFrameLength((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AS5643_BUS__SPEED:
				return speed != SPEED_EDEFAULT;
			case PeripheralPackage.AS5643_BUS__FRAME_LENGTH:
				return frameLength != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (speed: ");
		result.append(speed);
		result.append(')');
		return result.toString();
	}

} //AS5643BusImpl
