/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.FlexRayBus;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Flex Ray Bus</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdMacroTick <em>Gd Macro Tick</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGMacroPerCycle <em>GMacro Per Cycle</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGNumberOfStaticSlots <em>GNumber Of Static Slots</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdNit <em>Gd Nit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGPayloadLengthStatic <em>GPayload Length Static</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdStaticSlot <em>Gd Static Slot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdDynamicSlotIdlePhase <em>Gd Dynamic Slot Idle Phase</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdMiniSlot <em>Gd Mini Slot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdActionPointOffset <em>Gd Action Point Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdMinislotActionPointOffset <em>Gd Minislot Action Point Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGdTSSTransmitter <em>Gd TSS Transmitter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGSyncNodeMax <em>GSync Node Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGColdstartAttempts <em>GColdstart Attempts</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGMaxWithoutClockCorrectionFatal <em>GMax Without Clock Correction Fatal</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.FlexRayBusImpl#getGMaxWithoutClockCorrectionPassive <em>GMax Without Clock Correction Passive</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FlexRayBusImpl extends BusImpl implements FlexRayBus {
	/**
	 * The default value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int SPEED_EDEFAULT = 10000000;

	/**
	 * The cached value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected int speed = SPEED_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdMacroTick() <em>Gd Macro Tick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMacroTick()
	 * @generated
	 * @ordered
	 */
	protected static final double GD_MACRO_TICK_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getGdMacroTick() <em>Gd Macro Tick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMacroTick()
	 * @generated
	 * @ordered
	 */
	protected double gdMacroTick = GD_MACRO_TICK_EDEFAULT;

	/**
	 * The default value of the '{@link #getGMacroPerCycle() <em>GMacro Per Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMacroPerCycle()
	 * @generated
	 * @ordered
	 */
	protected static final int GMACRO_PER_CYCLE_EDEFAULT = 5000;

	/**
	 * The cached value of the '{@link #getGMacroPerCycle() <em>GMacro Per Cycle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMacroPerCycle()
	 * @generated
	 * @ordered
	 */
	protected int gMacroPerCycle = GMACRO_PER_CYCLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGNumberOfStaticSlots() <em>GNumber Of Static Slots</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGNumberOfStaticSlots()
	 * @generated
	 * @ordered
	 */
	protected static final int GNUMBER_OF_STATIC_SLOTS_EDEFAULT = 89;

	/**
	 * The cached value of the '{@link #getGNumberOfStaticSlots() <em>GNumber Of Static Slots</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGNumberOfStaticSlots()
	 * @generated
	 * @ordered
	 */
	protected int gNumberOfStaticSlots = GNUMBER_OF_STATIC_SLOTS_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdNit() <em>Gd Nit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdNit()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_NIT_EDEFAULT = 100;

	/**
	 * The cached value of the '{@link #getGdNit() <em>Gd Nit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdNit()
	 * @generated
	 * @ordered
	 */
	protected int gdNit = GD_NIT_EDEFAULT;

	/**
	 * The default value of the '{@link #getGPayloadLengthStatic() <em>GPayload Length Static</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGPayloadLengthStatic()
	 * @generated
	 * @ordered
	 */
	protected static final int GPAYLOAD_LENGTH_STATIC_EDEFAULT = 8;

	/**
	 * The cached value of the '{@link #getGPayloadLengthStatic() <em>GPayload Length Static</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGPayloadLengthStatic()
	 * @generated
	 * @ordered
	 */
	protected int gPayloadLengthStatic = GPAYLOAD_LENGTH_STATIC_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdStaticSlot() <em>Gd Static Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdStaticSlot()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_STATIC_SLOT_EDEFAULT = 34;

	/**
	 * The cached value of the '{@link #getGdStaticSlot() <em>Gd Static Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdStaticSlot()
	 * @generated
	 * @ordered
	 */
	protected int gdStaticSlot = GD_STATIC_SLOT_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdDynamicSlotIdlePhase() <em>Gd Dynamic Slot Idle Phase</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdDynamicSlotIdlePhase()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_DYNAMIC_SLOT_IDLE_PHASE_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getGdDynamicSlotIdlePhase() <em>Gd Dynamic Slot Idle Phase</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdDynamicSlotIdlePhase()
	 * @generated
	 * @ordered
	 */
	protected int gdDynamicSlotIdlePhase = GD_DYNAMIC_SLOT_IDLE_PHASE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdMiniSlot() <em>Gd Mini Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMiniSlot()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_MINI_SLOT_EDEFAULT = 7;

	/**
	 * The cached value of the '{@link #getGdMiniSlot() <em>Gd Mini Slot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMiniSlot()
	 * @generated
	 * @ordered
	 */
	protected int gdMiniSlot = GD_MINI_SLOT_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdActionPointOffset() <em>Gd Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdActionPointOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_ACTION_POINT_OFFSET_EDEFAULT = 3;

	/**
	 * The cached value of the '{@link #getGdActionPointOffset() <em>Gd Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdActionPointOffset()
	 * @generated
	 * @ordered
	 */
	protected int gdActionPointOffset = GD_ACTION_POINT_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdMinislotActionPointOffset() <em>Gd Minislot Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMinislotActionPointOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_MINISLOT_ACTION_POINT_OFFSET_EDEFAULT = 3;

	/**
	 * The cached value of the '{@link #getGdMinislotActionPointOffset() <em>Gd Minislot Action Point Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdMinislotActionPointOffset()
	 * @generated
	 * @ordered
	 */
	protected int gdMinislotActionPointOffset = GD_MINISLOT_ACTION_POINT_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getGdTSSTransmitter() <em>Gd TSS Transmitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdTSSTransmitter()
	 * @generated
	 * @ordered
	 */
	protected static final int GD_TSS_TRANSMITTER_EDEFAULT = 15;

	/**
	 * The cached value of the '{@link #getGdTSSTransmitter() <em>Gd TSS Transmitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGdTSSTransmitter()
	 * @generated
	 * @ordered
	 */
	protected int gdTSSTransmitter = GD_TSS_TRANSMITTER_EDEFAULT;

	/**
	 * The default value of the '{@link #getGSyncNodeMax() <em>GSync Node Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGSyncNodeMax()
	 * @generated
	 * @ordered
	 */
	protected static final int GSYNC_NODE_MAX_EDEFAULT = 10;

	/**
	 * The cached value of the '{@link #getGSyncNodeMax() <em>GSync Node Max</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGSyncNodeMax()
	 * @generated
	 * @ordered
	 */
	protected int gSyncNodeMax = GSYNC_NODE_MAX_EDEFAULT;

	/**
	 * The default value of the '{@link #getGColdstartAttempts() <em>GColdstart Attempts</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGColdstartAttempts()
	 * @generated
	 * @ordered
	 */
	protected static final int GCOLDSTART_ATTEMPTS_EDEFAULT = 31;

	/**
	 * The cached value of the '{@link #getGColdstartAttempts() <em>GColdstart Attempts</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGColdstartAttempts()
	 * @generated
	 * @ordered
	 */
	protected int gColdstartAttempts = GCOLDSTART_ATTEMPTS_EDEFAULT;

	/**
	 * The default value of the '{@link #getGMaxWithoutClockCorrectionFatal() <em>GMax Without Clock Correction Fatal</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMaxWithoutClockCorrectionFatal()
	 * @generated
	 * @ordered
	 */
	protected static final int GMAX_WITHOUT_CLOCK_CORRECTION_FATAL_EDEFAULT = 6;

	/**
	 * The cached value of the '{@link #getGMaxWithoutClockCorrectionFatal() <em>GMax Without Clock Correction Fatal</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMaxWithoutClockCorrectionFatal()
	 * @generated
	 * @ordered
	 */
	protected int gMaxWithoutClockCorrectionFatal = GMAX_WITHOUT_CLOCK_CORRECTION_FATAL_EDEFAULT;

	/**
	 * The default value of the '{@link #getGMaxWithoutClockCorrectionPassive() <em>GMax Without Clock Correction Passive</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMaxWithoutClockCorrectionPassive()
	 * @generated
	 * @ordered
	 */
	protected static final int GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE_EDEFAULT = 3;

	/**
	 * The cached value of the '{@link #getGMaxWithoutClockCorrectionPassive() <em>GMax Without Clock Correction Passive</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGMaxWithoutClockCorrectionPassive()
	 * @generated
	 * @ordered
	 */
	protected int gMaxWithoutClockCorrectionPassive = GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlexRayBusImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.FLEX_RAY_BUS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpeed(int newSpeed) {
		int oldSpeed = speed;
		speed = newSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__SPEED, oldSpeed, speed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getGdMacroTick() {
		return gdMacroTick;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdMacroTick(double newGdMacroTick) {
		double oldGdMacroTick = gdMacroTick;
		gdMacroTick = newGdMacroTick;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_MACRO_TICK, oldGdMacroTick, gdMacroTick));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGMacroPerCycle() {
		return gMacroPerCycle;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGMacroPerCycle(int newGMacroPerCycle) {
		int oldGMacroPerCycle = gMacroPerCycle;
		gMacroPerCycle = newGMacroPerCycle;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GMACRO_PER_CYCLE, oldGMacroPerCycle, gMacroPerCycle));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGNumberOfStaticSlots() {
		return gNumberOfStaticSlots;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGNumberOfStaticSlots(int newGNumberOfStaticSlots) {
		int oldGNumberOfStaticSlots = gNumberOfStaticSlots;
		gNumberOfStaticSlots = newGNumberOfStaticSlots;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS, oldGNumberOfStaticSlots, gNumberOfStaticSlots));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdNit() {
		return gdNit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdNit(int newGdNit) {
		int oldGdNit = gdNit;
		gdNit = newGdNit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_NIT, oldGdNit, gdNit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGPayloadLengthStatic() {
		return gPayloadLengthStatic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGPayloadLengthStatic(int newGPayloadLengthStatic) {
		int oldGPayloadLengthStatic = gPayloadLengthStatic;
		gPayloadLengthStatic = newGPayloadLengthStatic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC, oldGPayloadLengthStatic, gPayloadLengthStatic));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdStaticSlot() {
		return gdStaticSlot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdStaticSlot(int newGdStaticSlot) {
		int oldGdStaticSlot = gdStaticSlot;
		gdStaticSlot = newGdStaticSlot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_STATIC_SLOT, oldGdStaticSlot, gdStaticSlot));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdDynamicSlotIdlePhase() {
		return gdDynamicSlotIdlePhase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdDynamicSlotIdlePhase(int newGdDynamicSlotIdlePhase) {
		int oldGdDynamicSlotIdlePhase = gdDynamicSlotIdlePhase;
		gdDynamicSlotIdlePhase = newGdDynamicSlotIdlePhase;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE, oldGdDynamicSlotIdlePhase, gdDynamicSlotIdlePhase));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdMiniSlot() {
		return gdMiniSlot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdMiniSlot(int newGdMiniSlot) {
		int oldGdMiniSlot = gdMiniSlot;
		gdMiniSlot = newGdMiniSlot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_MINI_SLOT, oldGdMiniSlot, gdMiniSlot));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdActionPointOffset() {
		return gdActionPointOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdActionPointOffset(int newGdActionPointOffset) {
		int oldGdActionPointOffset = gdActionPointOffset;
		gdActionPointOffset = newGdActionPointOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET, oldGdActionPointOffset, gdActionPointOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdMinislotActionPointOffset() {
		return gdMinislotActionPointOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdMinislotActionPointOffset(int newGdMinislotActionPointOffset) {
		int oldGdMinislotActionPointOffset = gdMinislotActionPointOffset;
		gdMinislotActionPointOffset = newGdMinislotActionPointOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET, oldGdMinislotActionPointOffset, gdMinislotActionPointOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGdTSSTransmitter() {
		return gdTSSTransmitter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGdTSSTransmitter(int newGdTSSTransmitter) {
		int oldGdTSSTransmitter = gdTSSTransmitter;
		gdTSSTransmitter = newGdTSSTransmitter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GD_TSS_TRANSMITTER, oldGdTSSTransmitter, gdTSSTransmitter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGSyncNodeMax() {
		return gSyncNodeMax;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGSyncNodeMax(int newGSyncNodeMax) {
		int oldGSyncNodeMax = gSyncNodeMax;
		gSyncNodeMax = newGSyncNodeMax;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GSYNC_NODE_MAX, oldGSyncNodeMax, gSyncNodeMax));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGColdstartAttempts() {
		return gColdstartAttempts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGColdstartAttempts(int newGColdstartAttempts) {
		int oldGColdstartAttempts = gColdstartAttempts;
		gColdstartAttempts = newGColdstartAttempts;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS, oldGColdstartAttempts, gColdstartAttempts));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGMaxWithoutClockCorrectionFatal() {
		return gMaxWithoutClockCorrectionFatal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGMaxWithoutClockCorrectionFatal(int newGMaxWithoutClockCorrectionFatal) {
		int oldGMaxWithoutClockCorrectionFatal = gMaxWithoutClockCorrectionFatal;
		gMaxWithoutClockCorrectionFatal = newGMaxWithoutClockCorrectionFatal;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL, oldGMaxWithoutClockCorrectionFatal, gMaxWithoutClockCorrectionFatal));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getGMaxWithoutClockCorrectionPassive() {
		return gMaxWithoutClockCorrectionPassive;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGMaxWithoutClockCorrectionPassive(int newGMaxWithoutClockCorrectionPassive) {
		int oldGMaxWithoutClockCorrectionPassive = gMaxWithoutClockCorrectionPassive;
		gMaxWithoutClockCorrectionPassive = newGMaxWithoutClockCorrectionPassive;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE, oldGMaxWithoutClockCorrectionPassive, gMaxWithoutClockCorrectionPassive));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY_BUS__SPEED:
				return getSpeed();
			case PeripheralPackage.FLEX_RAY_BUS__GD_MACRO_TICK:
				return getGdMacroTick();
			case PeripheralPackage.FLEX_RAY_BUS__GMACRO_PER_CYCLE:
				return getGMacroPerCycle();
			case PeripheralPackage.FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS:
				return getGNumberOfStaticSlots();
			case PeripheralPackage.FLEX_RAY_BUS__GD_NIT:
				return getGdNit();
			case PeripheralPackage.FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC:
				return getGPayloadLengthStatic();
			case PeripheralPackage.FLEX_RAY_BUS__GD_STATIC_SLOT:
				return getGdStaticSlot();
			case PeripheralPackage.FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE:
				return getGdDynamicSlotIdlePhase();
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINI_SLOT:
				return getGdMiniSlot();
			case PeripheralPackage.FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET:
				return getGdActionPointOffset();
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET:
				return getGdMinislotActionPointOffset();
			case PeripheralPackage.FLEX_RAY_BUS__GD_TSS_TRANSMITTER:
				return getGdTSSTransmitter();
			case PeripheralPackage.FLEX_RAY_BUS__GSYNC_NODE_MAX:
				return getGSyncNodeMax();
			case PeripheralPackage.FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS:
				return getGColdstartAttempts();
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL:
				return getGMaxWithoutClockCorrectionFatal();
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE:
				return getGMaxWithoutClockCorrectionPassive();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY_BUS__SPEED:
				setSpeed((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MACRO_TICK:
				setGdMacroTick((Double)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMACRO_PER_CYCLE:
				setGMacroPerCycle((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS:
				setGNumberOfStaticSlots((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_NIT:
				setGdNit((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC:
				setGPayloadLengthStatic((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_STATIC_SLOT:
				setGdStaticSlot((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE:
				setGdDynamicSlotIdlePhase((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINI_SLOT:
				setGdMiniSlot((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET:
				setGdActionPointOffset((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET:
				setGdMinislotActionPointOffset((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_TSS_TRANSMITTER:
				setGdTSSTransmitter((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GSYNC_NODE_MAX:
				setGSyncNodeMax((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS:
				setGColdstartAttempts((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL:
				setGMaxWithoutClockCorrectionFatal((Integer)newValue);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE:
				setGMaxWithoutClockCorrectionPassive((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY_BUS__SPEED:
				setSpeed(SPEED_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MACRO_TICK:
				setGdMacroTick(GD_MACRO_TICK_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMACRO_PER_CYCLE:
				setGMacroPerCycle(GMACRO_PER_CYCLE_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS:
				setGNumberOfStaticSlots(GNUMBER_OF_STATIC_SLOTS_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_NIT:
				setGdNit(GD_NIT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC:
				setGPayloadLengthStatic(GPAYLOAD_LENGTH_STATIC_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_STATIC_SLOT:
				setGdStaticSlot(GD_STATIC_SLOT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE:
				setGdDynamicSlotIdlePhase(GD_DYNAMIC_SLOT_IDLE_PHASE_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINI_SLOT:
				setGdMiniSlot(GD_MINI_SLOT_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET:
				setGdActionPointOffset(GD_ACTION_POINT_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET:
				setGdMinislotActionPointOffset(GD_MINISLOT_ACTION_POINT_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GD_TSS_TRANSMITTER:
				setGdTSSTransmitter(GD_TSS_TRANSMITTER_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GSYNC_NODE_MAX:
				setGSyncNodeMax(GSYNC_NODE_MAX_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS:
				setGColdstartAttempts(GCOLDSTART_ATTEMPTS_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL:
				setGMaxWithoutClockCorrectionFatal(GMAX_WITHOUT_CLOCK_CORRECTION_FATAL_EDEFAULT);
				return;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE:
				setGMaxWithoutClockCorrectionPassive(GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.FLEX_RAY_BUS__SPEED:
				return speed != SPEED_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MACRO_TICK:
				return gdMacroTick != GD_MACRO_TICK_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GMACRO_PER_CYCLE:
				return gMacroPerCycle != GMACRO_PER_CYCLE_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GNUMBER_OF_STATIC_SLOTS:
				return gNumberOfStaticSlots != GNUMBER_OF_STATIC_SLOTS_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_NIT:
				return gdNit != GD_NIT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GPAYLOAD_LENGTH_STATIC:
				return gPayloadLengthStatic != GPAYLOAD_LENGTH_STATIC_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_STATIC_SLOT:
				return gdStaticSlot != GD_STATIC_SLOT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_DYNAMIC_SLOT_IDLE_PHASE:
				return gdDynamicSlotIdlePhase != GD_DYNAMIC_SLOT_IDLE_PHASE_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINI_SLOT:
				return gdMiniSlot != GD_MINI_SLOT_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_ACTION_POINT_OFFSET:
				return gdActionPointOffset != GD_ACTION_POINT_OFFSET_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_MINISLOT_ACTION_POINT_OFFSET:
				return gdMinislotActionPointOffset != GD_MINISLOT_ACTION_POINT_OFFSET_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GD_TSS_TRANSMITTER:
				return gdTSSTransmitter != GD_TSS_TRANSMITTER_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GSYNC_NODE_MAX:
				return gSyncNodeMax != GSYNC_NODE_MAX_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GCOLDSTART_ATTEMPTS:
				return gColdstartAttempts != GCOLDSTART_ATTEMPTS_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_FATAL:
				return gMaxWithoutClockCorrectionFatal != GMAX_WITHOUT_CLOCK_CORRECTION_FATAL_EDEFAULT;
			case PeripheralPackage.FLEX_RAY_BUS__GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE:
				return gMaxWithoutClockCorrectionPassive != GMAX_WITHOUT_CLOCK_CORRECTION_PASSIVE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (speed: ");
		result.append(speed);
		result.append(", gdMacroTick: ");
		result.append(gdMacroTick);
		result.append(", gMacroPerCycle: ");
		result.append(gMacroPerCycle);
		result.append(", gNumberOfStaticSlots: ");
		result.append(gNumberOfStaticSlots);
		result.append(", gdNit: ");
		result.append(gdNit);
		result.append(", gPayloadLengthStatic: ");
		result.append(gPayloadLengthStatic);
		result.append(", gdStaticSlot: ");
		result.append(gdStaticSlot);
		result.append(", gdDynamicSlotIdlePhase: ");
		result.append(gdDynamicSlotIdlePhase);
		result.append(", gdMiniSlot: ");
		result.append(gdMiniSlot);
		result.append(", gdActionPointOffset: ");
		result.append(gdActionPointOffset);
		result.append(", gdMinislotActionPointOffset: ");
		result.append(gdMinislotActionPointOffset);
		result.append(", gdTSSTransmitter: ");
		result.append(gdTSSTransmitter);
		result.append(", gSyncNodeMax: ");
		result.append(gSyncNodeMax);
		result.append(", gColdstartAttempts: ");
		result.append(gColdstartAttempts);
		result.append(", gMaxWithoutClockCorrectionFatal: ");
		result.append(gMaxWithoutClockCorrectionFatal);
		result.append(", gMaxWithoutClockCorrectionPassive: ");
		result.append(gMaxWithoutClockCorrectionPassive);
		result.append(')');
		return result.toString();
	}

} //FlexRayBusImpl
