/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.peripheral.GenericIO;
import com.inchron.realtime.root.model.peripheral.GenericIOType;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Generic IO</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getBusWidth <em>Bus Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getBlockSize <em>Block Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getStartIRQOffset <em>Start IRQ Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#isEmulateDMA <em>Emulate DMA</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getPreOverhead <em>Pre Overhead</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getPostOverhead <em>Post Overhead</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.GenericIOImpl#getSlaveSetupTime <em>Slave Setup Time</em>}</li>
 * </ul>
 *
 * @generated
 */
public class GenericIOImpl extends PeripheralImpl implements GenericIO {
	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final GenericIOType TYPE_EDEFAULT = GenericIOType.PT_P;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected GenericIOType type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected static final int SPEED_EDEFAULT = 10000000;

	/**
	 * The cached value of the '{@link #getSpeed() <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSpeed()
	 * @generated
	 * @ordered
	 */
	protected int speed = SPEED_EDEFAULT;

	/**
	 * The default value of the '{@link #getBusWidth() <em>Bus Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBusWidth()
	 * @generated
	 * @ordered
	 */
	protected static final int BUS_WIDTH_EDEFAULT = 8;

	/**
	 * The cached value of the '{@link #getBusWidth() <em>Bus Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBusWidth()
	 * @generated
	 * @ordered
	 */
	protected int busWidth = BUS_WIDTH_EDEFAULT;

	/**
	 * The default value of the '{@link #getBlockSize() <em>Block Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlockSize()
	 * @generated
	 * @ordered
	 */
	protected static final int BLOCK_SIZE_EDEFAULT = 64;

	/**
	 * The cached value of the '{@link #getBlockSize() <em>Block Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlockSize()
	 * @generated
	 * @ordered
	 */
	protected int blockSize = BLOCK_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStartIRQOffset() <em>Start IRQ Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartIRQOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int START_IRQ_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStartIRQOffset() <em>Start IRQ Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartIRQOffset()
	 * @generated
	 * @ordered
	 */
	protected int startIRQOffset = START_IRQ_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #isEmulateDMA() <em>Emulate DMA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEmulateDMA()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EMULATE_DMA_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isEmulateDMA() <em>Emulate DMA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEmulateDMA()
	 * @generated
	 * @ordered
	 */
	protected boolean emulateDMA = EMULATE_DMA_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPreOverhead() <em>Pre Overhead</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPreOverhead()
	 * @generated
	 * @ordered
	 */
	protected Time preOverhead;

	/**
	 * The cached value of the '{@link #getPostOverhead() <em>Post Overhead</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPostOverhead()
	 * @generated
	 * @ordered
	 */
	protected Time postOverhead;

	/**
	 * The cached value of the '{@link #getSlaveSetupTime() <em>Slave Setup Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSlaveSetupTime()
	 * @generated
	 * @ordered
	 */
	protected Time slaveSetupTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GenericIOImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.GENERIC_IO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericIOType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(GenericIOType newType) {
		GenericIOType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSpeed() {
		return speed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSpeed(int newSpeed) {
		int oldSpeed = speed;
		speed = newSpeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__SPEED, oldSpeed, speed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getBusWidth() {
		return busWidth;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBusWidth(int newBusWidth) {
		int oldBusWidth = busWidth;
		busWidth = newBusWidth;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__BUS_WIDTH, oldBusWidth, busWidth));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getBlockSize() {
		return blockSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBlockSize(int newBlockSize) {
		int oldBlockSize = blockSize;
		blockSize = newBlockSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__BLOCK_SIZE, oldBlockSize, blockSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStartIRQOffset() {
		return startIRQOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartIRQOffset(int newStartIRQOffset) {
		int oldStartIRQOffset = startIRQOffset;
		startIRQOffset = newStartIRQOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__START_IRQ_OFFSET, oldStartIRQOffset, startIRQOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEmulateDMA() {
		return emulateDMA;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEmulateDMA(boolean newEmulateDMA) {
		boolean oldEmulateDMA = emulateDMA;
		emulateDMA = newEmulateDMA;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__EMULATE_DMA, oldEmulateDMA, emulateDMA));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPreOverhead() {
		return preOverhead;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPreOverhead(Time newPreOverhead, NotificationChain msgs) {
		Time oldPreOverhead = preOverhead;
		preOverhead = newPreOverhead;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__PRE_OVERHEAD, oldPreOverhead, newPreOverhead);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPreOverhead(Time newPreOverhead) {
		if (newPreOverhead != preOverhead) {
			NotificationChain msgs = null;
			if (preOverhead != null)
				msgs = ((InternalEObject)preOverhead).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__PRE_OVERHEAD, null, msgs);
			if (newPreOverhead != null)
				msgs = ((InternalEObject)newPreOverhead).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__PRE_OVERHEAD, null, msgs);
			msgs = basicSetPreOverhead(newPreOverhead, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__PRE_OVERHEAD, newPreOverhead, newPreOverhead));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPostOverhead() {
		return postOverhead;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPostOverhead(Time newPostOverhead, NotificationChain msgs) {
		Time oldPostOverhead = postOverhead;
		postOverhead = newPostOverhead;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__POST_OVERHEAD, oldPostOverhead, newPostOverhead);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPostOverhead(Time newPostOverhead) {
		if (newPostOverhead != postOverhead) {
			NotificationChain msgs = null;
			if (postOverhead != null)
				msgs = ((InternalEObject)postOverhead).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__POST_OVERHEAD, null, msgs);
			if (newPostOverhead != null)
				msgs = ((InternalEObject)newPostOverhead).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__POST_OVERHEAD, null, msgs);
			msgs = basicSetPostOverhead(newPostOverhead, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__POST_OVERHEAD, newPostOverhead, newPostOverhead));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getSlaveSetupTime() {
		return slaveSetupTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSlaveSetupTime(Time newSlaveSetupTime, NotificationChain msgs) {
		Time oldSlaveSetupTime = slaveSetupTime;
		slaveSetupTime = newSlaveSetupTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME, oldSlaveSetupTime, newSlaveSetupTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSlaveSetupTime(Time newSlaveSetupTime) {
		if (newSlaveSetupTime != slaveSetupTime) {
			NotificationChain msgs = null;
			if (slaveSetupTime != null)
				msgs = ((InternalEObject)slaveSetupTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME, null, msgs);
			if (newSlaveSetupTime != null)
				msgs = ((InternalEObject)newSlaveSetupTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME, null, msgs);
			msgs = basicSetSlaveSetupTime(newSlaveSetupTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME, newSlaveSetupTime, newSlaveSetupTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PeripheralPackage.GENERIC_IO__PRE_OVERHEAD:
				return basicSetPreOverhead(null, msgs);
			case PeripheralPackage.GENERIC_IO__POST_OVERHEAD:
				return basicSetPostOverhead(null, msgs);
			case PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME:
				return basicSetSlaveSetupTime(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.GENERIC_IO__TYPE:
				return getType();
			case PeripheralPackage.GENERIC_IO__SPEED:
				return getSpeed();
			case PeripheralPackage.GENERIC_IO__BUS_WIDTH:
				return getBusWidth();
			case PeripheralPackage.GENERIC_IO__BLOCK_SIZE:
				return getBlockSize();
			case PeripheralPackage.GENERIC_IO__START_IRQ_OFFSET:
				return getStartIRQOffset();
			case PeripheralPackage.GENERIC_IO__EMULATE_DMA:
				return isEmulateDMA();
			case PeripheralPackage.GENERIC_IO__PRE_OVERHEAD:
				return getPreOverhead();
			case PeripheralPackage.GENERIC_IO__POST_OVERHEAD:
				return getPostOverhead();
			case PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME:
				return getSlaveSetupTime();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.GENERIC_IO__TYPE:
				setType((GenericIOType)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__SPEED:
				setSpeed((Integer)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__BUS_WIDTH:
				setBusWidth((Integer)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__BLOCK_SIZE:
				setBlockSize((Integer)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__START_IRQ_OFFSET:
				setStartIRQOffset((Integer)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__EMULATE_DMA:
				setEmulateDMA((Boolean)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__PRE_OVERHEAD:
				setPreOverhead((Time)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__POST_OVERHEAD:
				setPostOverhead((Time)newValue);
				return;
			case PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME:
				setSlaveSetupTime((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.GENERIC_IO__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__SPEED:
				setSpeed(SPEED_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__BUS_WIDTH:
				setBusWidth(BUS_WIDTH_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__BLOCK_SIZE:
				setBlockSize(BLOCK_SIZE_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__START_IRQ_OFFSET:
				setStartIRQOffset(START_IRQ_OFFSET_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__EMULATE_DMA:
				setEmulateDMA(EMULATE_DMA_EDEFAULT);
				return;
			case PeripheralPackage.GENERIC_IO__PRE_OVERHEAD:
				setPreOverhead((Time)null);
				return;
			case PeripheralPackage.GENERIC_IO__POST_OVERHEAD:
				setPostOverhead((Time)null);
				return;
			case PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME:
				setSlaveSetupTime((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.GENERIC_IO__TYPE:
				return type != TYPE_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__SPEED:
				return speed != SPEED_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__BUS_WIDTH:
				return busWidth != BUS_WIDTH_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__BLOCK_SIZE:
				return blockSize != BLOCK_SIZE_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__START_IRQ_OFFSET:
				return startIRQOffset != START_IRQ_OFFSET_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__EMULATE_DMA:
				return emulateDMA != EMULATE_DMA_EDEFAULT;
			case PeripheralPackage.GENERIC_IO__PRE_OVERHEAD:
				return preOverhead != null;
			case PeripheralPackage.GENERIC_IO__POST_OVERHEAD:
				return postOverhead != null;
			case PeripheralPackage.GENERIC_IO__SLAVE_SETUP_TIME:
				return slaveSetupTime != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(", speed: ");
		result.append(speed);
		result.append(", busWidth: ");
		result.append(busWidth);
		result.append(", blockSize: ");
		result.append(blockSize);
		result.append(", startIRQOffset: ");
		result.append(startIRQOffset);
		result.append(", emulateDMA: ");
		result.append(emulateDMA);
		result.append(')');
		return result.toString();
	}

} //GenericIOImpl
