/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.RootPackage;

import com.inchron.realtime.root.impl.RootPackageImpl;

import com.inchron.realtime.root.model.ModelPackage;

import com.inchron.realtime.root.model.autosar.AutosarPackage;

import com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl;

import com.inchron.realtime.root.model.fmi.FmiPackage;

import com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl;

import com.inchron.realtime.root.model.fmi.type.TypePackage;

import com.inchron.realtime.root.model.fmi.type.impl.TypePackageImpl;

import com.inchron.realtime.root.model.fmi.unit.UnitPackage;

import com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl;

import com.inchron.realtime.root.model.fmi.variable.VariablePackage;

import com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl;

import com.inchron.realtime.root.model.impl.ModelPackageImpl;

import com.inchron.realtime.root.model.memory.MemoryPackage;

import com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl;

import com.inchron.realtime.root.model.peripheral.PeripheralFactory;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import com.inchron.realtime.root.model.requirement.RequirementPackage;

import com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl;

import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl;

import com.inchron.realtime.root.settings.SettingsPackage;

import com.inchron.realtime.root.settings.impl.SettingsPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PeripheralPackageImpl extends EPackageImpl implements PeripheralPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass busMasterPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass busSlavePortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass interruptPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inputPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass outputPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass biDirPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass portConnectionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractPeripheralEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass peripheralEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass busEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractEthernetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass afdxPortEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass afdxEthernetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass as5643EClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass as5643BusEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass canEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass canBusEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass consoleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass ethernetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass ethernetSwitchEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flexRayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass flexRayBusEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass genericIOEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass irqEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass restBusEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass restBusCANEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass restBusFlexRayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum afdxPortDirectionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum afdxPortTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum genericIOTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private PeripheralPackageImpl() {
		super(eNS_URI, PeripheralFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link PeripheralPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @generated
	 */
	public static PeripheralPackage init() {
		if (isInited) return (PeripheralPackage)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI);

		// Obtain or create and register package
		PeripheralPackageImpl thePeripheralPackage = (PeripheralPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof PeripheralPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new PeripheralPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		RootPackageImpl theRootPackage = (RootPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) instanceof RootPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) : RootPackage.eINSTANCE);
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		FmiPackageImpl theFmiPackage = (FmiPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) instanceof FmiPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) : FmiPackage.eINSTANCE);
		TypePackageImpl theTypePackage = (TypePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) instanceof TypePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) : TypePackage.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackage.eINSTANCE);
		VariablePackageImpl theVariablePackage = (VariablePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) instanceof VariablePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) : VariablePackage.eINSTANCE);
		MemoryPackageImpl theMemoryPackage = (MemoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) instanceof MemoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) : MemoryPackage.eINSTANCE);
		RequirementPackageImpl theRequirementPackage = (RequirementPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) instanceof RequirementPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) : RequirementPackage.eINSTANCE);
		StimulationPackageImpl theStimulationPackage = (StimulationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) instanceof StimulationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) : StimulationPackage.eINSTANCE);
		SettingsPackageImpl theSettingsPackage = (SettingsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) instanceof SettingsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) : SettingsPackage.eINSTANCE);

		// Load packages
		theRootPackage.loadPackage();

		// Fix loaded packages
		thePeripheralPackage.fixPackageContents();
		theRootPackage.fixPackageContents();
		theModelPackage.fixPackageContents();
		theAutosarPackage.fixPackageContents();
		theFmiPackage.fixPackageContents();
		theTypePackage.fixPackageContents();
		theUnitPackage.fixPackageContents();
		theVariablePackage.fixPackageContents();
		theMemoryPackage.fixPackageContents();
		theRequirementPackage.fixPackageContents();
		theStimulationPackage.fixPackageContents();
		theSettingsPackage.fixPackageContents();

		// Mark meta-data to indicate it can't be changed
		thePeripheralPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(PeripheralPackage.eNS_URI, thePeripheralPackage);
		return thePeripheralPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractPort() {
		if (abstractPortEClass == null) {
			abstractPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(0);
		}
		return abstractPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractPort_Connection() {
        return (EReference)getAbstractPort().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractPort__IsCompatible__AbstractPort() {
        return getAbstractPort().getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusMasterPort() {
		if (busMasterPortEClass == null) {
			busMasterPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(1);
		}
		return busMasterPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusSlavePort() {
		if (busSlavePortEClass == null) {
			busSlavePortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(2);
		}
		return busSlavePortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInterruptPort() {
		if (interruptPortEClass == null) {
			interruptPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(3);
		}
		return interruptPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInterruptPort_Isrs() {
        return (EReference)getInterruptPort().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInputPort() {
		if (inputPortEClass == null) {
			inputPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(4);
		}
		return inputPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOutputPort() {
		if (outputPortEClass == null) {
			outputPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(5);
		}
		return outputPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBiDirPort() {
		if (biDirPortEClass == null) {
			biDirPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(6);
		}
		return biDirPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPortConnection() {
		if (portConnectionEClass == null) {
			portConnectionEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(7);
		}
		return portConnectionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPortConnection_Ports() {
        return (EReference)getPortConnection().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractPeripheral() {
		if (abstractPeripheralEClass == null) {
			abstractPeripheralEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(8);
		}
		return abstractPeripheralEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractPeripheral_Exactness() {
        return (EAttribute)getAbstractPeripheral().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractPeripheral_Events() {
        return (EReference)getAbstractPeripheral().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractPeripheral_Ports() {
        return (EReference)getAbstractPeripheral().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getAbstractPeripheral__IsCompatible__AbstractPeripheral() {
        return getAbstractPeripheral().getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPeripheral() {
		if (peripheralEClass == null) {
			peripheralEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(9);
		}
		return peripheralEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPeripheral_AddressRange() {
        return (EReference)getPeripheral().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBus() {
		if (busEClass == null) {
			busEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(10);
		}
		return busEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractEthernet() {
		if (abstractEthernetEClass == null) {
			abstractEthernetEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(11);
		}
		return abstractEthernetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractEthernet_AutoNegotiate() {
        return (EAttribute)getAbstractEthernet().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractEthernet_FullDuplex() {
        return (EAttribute)getAbstractEthernet().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractEthernet_NumberOfPorts() {
        return (EAttribute)getAbstractEthernet().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractEthernet_Speed() {
        return (EAttribute)getAbstractEthernet().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAbstractEthernet_SupportsQoS() {
        return (EAttribute)getAbstractEthernet().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAFDXPort() {
		if (afdxPortEClass == null) {
			afdxPortEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(12);
		}
		return afdxPortEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXPort_Direction() {
        return (EAttribute)getAFDXPort().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXPort_Type() {
        return (EAttribute)getAFDXPort().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXPort_QueueLength() {
        return (EAttribute)getAFDXPort().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAFDXEthernet() {
		if (afdxEthernetEClass == null) {
			afdxEthernetEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(15);
		}
		return afdxEthernetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_NetworkId() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_EquipmentId() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_PartitionId() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_InterfaceId1() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_Mac1() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_InterfaceId2() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAFDXEthernet_Mac2() {
        return (EAttribute)getAFDXEthernet().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAFDXEthernet_AfdxPorts() {
        return (EReference)getAFDXEthernet().getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAS5643() {
		if (as5643EClass == null) {
			as5643EClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(16);
		}
		return as5643EClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_CC() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_NodeId() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_Rank() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_TransmissionOffset() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_ReceiveOffset() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_DatapumpOffset() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643_MonitorNode() {
        return (EAttribute)getAS5643().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAS5643Bus() {
		if (as5643BusEClass == null) {
			as5643BusEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(17);
		}
		return as5643BusEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAS5643Bus_Speed() {
        return (EAttribute)getAS5643Bus().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAS5643Bus_FrameLength() {
        return (EReference)getAS5643Bus().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCAN() {
		if (canEClass == null) {
			canEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(18);
		}
		return canEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCAN_BufferStrategy() {
        return (EAttribute)getCAN().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCAN_NumberOfBuffers() {
        return (EAttribute)getCAN().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCANBus() {
		if (canBusEClass == null) {
			canBusEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(19);
		}
		return canBusEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCANBus_LogEnabled() {
        return (EAttribute)getCANBus().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCANBus_Speed() {
        return (EAttribute)getCANBus().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCANBus_DataSpeed() {
        return (EAttribute)getCANBus().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConsole() {
		if (consoleEClass == null) {
			consoleEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(20);
		}
		return consoleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEthernet() {
		if (ethernetEClass == null) {
			ethernetEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(21);
		}
		return ethernetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEthernet_MacAddress() {
        return (EAttribute)getEthernet().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEthernet_CrossOver() {
        return (EAttribute)getEthernet().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEthernet_RxQueueSize() {
        return (EAttribute)getEthernet().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEthernetSwitch() {
		if (ethernetSwitchEClass == null) {
			ethernetSwitchEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(22);
		}
		return ethernetSwitchEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEthernetSwitch_FastForward() {
        return (EAttribute)getEthernetSwitch().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEthernetSwitch_LogEnabled() {
        return (EAttribute)getEthernetSwitch().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlexRay() {
		if (flexRayEClass == null) {
			flexRayEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(23);
		}
		return flexRayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_ColdStarter() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PSingleSlotEnabled() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PKeySlotId() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PKeySlotUsedForStartup() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PKeySlotUsedForSync() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PdMicrotick() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PLatestTx() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PdListenTimeOut() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PdMaxDrift() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PAllowHaltDueToClock() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PAllowPassiveToActive() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_POffsetCorrectionOut() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRay_PRateCorrectionOut() {
        return (EAttribute)getFlexRay().getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFlexRayBus() {
		if (flexRayBusEClass == null) {
			flexRayBusEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(24);
		}
		return flexRayBusEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_Speed() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdMacroTick() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GMacroPerCycle() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GNumberOfStaticSlots() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdNit() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GPayloadLengthStatic() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdStaticSlot() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdDynamicSlotIdlePhase() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdMiniSlot() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdActionPointOffset() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdMinislotActionPointOffset() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GdTSSTransmitter() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GSyncNodeMax() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GColdstartAttempts() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GMaxWithoutClockCorrectionFatal() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFlexRayBus_GMaxWithoutClockCorrectionPassive() {
        return (EAttribute)getFlexRayBus().getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGenericIO() {
		if (genericIOEClass == null) {
			genericIOEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(25);
		}
		return genericIOEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_Type() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_Speed() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_BusWidth() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_BlockSize() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_StartIRQOffset() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGenericIO_EmulateDMA() {
        return (EAttribute)getGenericIO().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericIO_PreOverhead() {
        return (EReference)getGenericIO().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericIO_PostOverhead() {
        return (EReference)getGenericIO().getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGenericIO_SlaveSetupTime() {
        return (EReference)getGenericIO().getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIRQ() {
		if (irqEClass == null) {
			irqEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(27);
		}
		return irqEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLIN() {
		if (linEClass == null) {
			linEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(28);
		}
		return linEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLIN_Master() {
        return (EAttribute)getLIN().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLIN_Protocol() {
        return (EAttribute)getLIN().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRestBus() {
		if (restBusEClass == null) {
			restBusEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(29);
		}
		return restBusEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRestBusCAN() {
		if (restBusCANEClass == null) {
			restBusCANEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(30);
		}
		return restBusCANEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRestBusFlexRay() {
		if (restBusFlexRayEClass == null) {
			restBusFlexRayEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(31);
		}
		return restBusFlexRayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimer() {
		if (timerEClass == null) {
			timerEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(32);
		}
		return timerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getAFDXPortDirection() {
		if (afdxPortDirectionEEnum == null) {
			afdxPortDirectionEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(13);
		}
		return afdxPortDirectionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getAFDXPortType() {
		if (afdxPortTypeEEnum == null) {
			afdxPortTypeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(14);
		}
		return afdxPortTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getGenericIOType() {
		if (genericIOTypeEEnum == null) {
			genericIOTypeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI).getEClassifiers().get(26);
		}
		return genericIOTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PeripheralFactory getPeripheralFactory() {
		return (PeripheralFactory)getEFactoryInstance();
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isFixed = false;

	/**
	 * Fixes up the loaded package, to make it appear as if it had been programmatically built.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fixPackageContents() {
		if (isFixed) return;
		isFixed = true;
		fixEClassifiers();
	}

	/**
	 * Sets the instance class on the given classifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void fixInstanceClass(EClassifier eClassifier) {
		if (eClassifier.getInstanceClassName() == null) {
			eClassifier.setInstanceClassName("com.inchron.realtime.root.model.peripheral." + eClassifier.getName());
			setGeneratedClassName(eClassifier);
		}
	}

} //PeripheralPackageImpl
