/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.EventChain;
import com.inchron.realtime.root.model.EventChainStep;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Chain Break Off Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isEvaluateBreakOffAsSuccess <em>Evaluate Break Off As Success</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getEventChain <em>Event Chain</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getIgnoreLastInstances <em>Ignore Last Instances</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreNonSequential <em>Ignore Non Sequential</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreSkipped <em>Ignore Skipped</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getRequiredLastStep <em>Required Last Step</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement()
 * @model
 * @generated
 */
public interface EventChainBreakOffRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Evaluate Break Off As Success</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Evaluate Break Off As Success</em>' attribute.
	 * @see #setEvaluateBreakOffAsSuccess(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_EvaluateBreakOffAsSuccess()
	 * @model default="false"
	 * @generated
	 */
	boolean isEvaluateBreakOffAsSuccess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isEvaluateBreakOffAsSuccess <em>Evaluate Break Off As Success</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evaluate Break Off As Success</em>' attribute.
	 * @see #isEvaluateBreakOffAsSuccess()
	 * @generated
	 */
	void setEvaluateBreakOffAsSuccess(boolean value);

	/**
	 * Returns the value of the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Chain</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Chain</em>' reference.
	 * @see #setEventChain(EventChain)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_EventChain()
	 * @model required="true"
	 * @generated
	 */
	EventChain getEventChain();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getEventChain <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Chain</em>' reference.
	 * @see #getEventChain()
	 * @generated
	 */
	void setEventChain(EventChain value);

	/**
	 * Returns the value of the '<em><b>Ignore Last Instances</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ignore Last Instances</em>' attribute.
	 * @see #setIgnoreLastInstances(int)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_IgnoreLastInstances()
	 * @model default="0"
	 * @generated
	 */
	int getIgnoreLastInstances();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getIgnoreLastInstances <em>Ignore Last Instances</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ignore Last Instances</em>' attribute.
	 * @see #getIgnoreLastInstances()
	 * @generated
	 */
	void setIgnoreLastInstances(int value);

	/**
	 * Returns the value of the '<em><b>Ignore Non Sequential</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ignore Non Sequential</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ignore Non Sequential</em>' attribute.
	 * @see #setIgnoreNonSequential(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_IgnoreNonSequential()
	 * @model default="false"
	 * @generated
	 */
	boolean isIgnoreNonSequential();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreNonSequential <em>Ignore Non Sequential</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ignore Non Sequential</em>' attribute.
	 * @see #isIgnoreNonSequential()
	 * @generated
	 */
	void setIgnoreNonSequential(boolean value);

	/**
	 * Returns the value of the '<em><b>Ignore Skipped</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ignore Skipped</em>' attribute.
	 * @see #setIgnoreSkipped(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_IgnoreSkipped()
	 * @model default="false"
	 * @generated
	 */
	boolean isIgnoreSkipped();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreSkipped <em>Ignore Skipped</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ignore Skipped</em>' attribute.
	 * @see #isIgnoreSkipped()
	 * @generated
	 */
	void setIgnoreSkipped(boolean value);

	/**
	 * Returns the value of the '<em><b>Required Last Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Required Last Step</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Required Last Step</em>' reference.
	 * @see #setRequiredLastStep(EventChainStep)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainBreakOffRequirement_RequiredLastStep()
	 * @model required="true"
	 * @generated
	 */
	EventChainStep getRequiredLastStep();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getRequiredLastStep <em>Required Last Step</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Required Last Step</em>' reference.
	 * @see #getRequiredLastStep()
	 * @generated
	 */
	void setRequiredLastStep(EventChainStep value);

} // EventChainBreakOffRequirement
