/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.TraceEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event IEvent JRequirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getEndEvent <em>End Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterA <em>Parameter A</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterB <em>Parameter B</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getStartEvent <em>Start Event</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventIEventJRequirement()
 * @model
 * @generated
 */
public interface EventIEventJRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>End Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End Event</em>' reference.
	 * @see #setEndEvent(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventIEventJRequirement_EndEvent()
	 * @model
	 * @generated
	 */
	TraceEvent getEndEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getEndEvent <em>End Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End Event</em>' reference.
	 * @see #getEndEvent()
	 * @generated
	 */
	void setEndEvent(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Parameter A</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter A</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameter A</em>' attribute.
	 * @see #setParameterA(int)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventIEventJRequirement_ParameterA()
	 * @model default="1"
	 * @generated
	 */
	int getParameterA();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterA <em>Parameter A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parameter A</em>' attribute.
	 * @see #getParameterA()
	 * @generated
	 */
	void setParameterA(int value);

	/**
	 * Returns the value of the '<em><b>Parameter B</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter B</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameter B</em>' attribute.
	 * @see #setParameterB(int)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventIEventJRequirement_ParameterB()
	 * @model default="0"
	 * @generated
	 */
	int getParameterB();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterB <em>Parameter B</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parameter B</em>' attribute.
	 * @see #getParameterB()
	 * @generated
	 */
	void setParameterB(int value);

	/**
	 * Returns the value of the '<em><b>Start Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Event</em>' reference.
	 * @see #setStartEvent(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventIEventJRequirement_StartEvent()
	 * @model
	 * @generated
	 */
	TraceEvent getStartEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getStartEvent <em>Start Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Event</em>' reference.
	 * @see #getStartEvent()
	 * @generated
	 */
	void setStartEvent(TraceEvent value);

} // EventIEventJRequirement
