/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Net Slack Time Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineDelta <em>Deadline Delta</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineEvent <em>Deadline Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getNetSlackTimeRequirement()
 * @model
 * @generated
 */
public interface NetSlackTimeRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>Deadline Delta</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deadline Delta</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deadline Delta</em>' containment reference.
	 * @see #setDeadlineDelta(Time)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getNetSlackTimeRequirement_DeadlineDelta()
	 * @model containment="true"
	 * @generated
	 */
	Time getDeadlineDelta();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineDelta <em>Deadline Delta</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deadline Delta</em>' containment reference.
	 * @see #getDeadlineDelta()
	 * @generated
	 */
	void setDeadlineDelta(Time value);

	/**
	 * Returns the value of the '<em><b>Deadline Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deadline Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deadline Event</em>' reference.
	 * @see #setDeadlineEvent(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getNetSlackTimeRequirement_DeadlineEvent()
	 * @model
	 * @generated
	 */
	TraceEvent getDeadlineEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineEvent <em>Deadline Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deadline Event</em>' reference.
	 * @see #getDeadlineEvent()
	 * @generated
	 */
	void setDeadlineEvent(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Process</em>' reference.
	 * @see #setProcess(com.inchron.realtime.root.model.Process)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getNetSlackTimeRequirement_Process()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.Process getProcess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getProcess <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process</em>' reference.
	 * @see #getProcess()
	 * @generated
	 */
	void setProcess(com.inchron.realtime.root.model.Process value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Delta"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType
	 * @see #setType(NetSlackTimeRequirementType)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getNetSlackTimeRequirement_Type()
	 * @model default="Delta"
	 * @generated
	 */
	NetSlackTimeRequirementType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType
	 * @see #getType()
	 * @generated
	 */
	void setType(NetSlackTimeRequirementType value);

} // NetSlackTimeRequirement
