/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Periodic Event Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getEvent <em>Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getPrewarnMarginCritical <em>Prewarn Margin Critical</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getPeriodicEventRequirement()
 * @model
 * @generated
 */
public interface PeriodicEventRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event</em>' reference.
	 * @see #setEvent(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getPeriodicEventRequirement_Event()
	 * @model
	 * @generated
	 */
	TraceEvent getEvent();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getEvent <em>Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event</em>' reference.
	 * @see #getEvent()
	 * @generated
	 */
	void setEvent(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Prewarn Margin Critical</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prewarn Margin Critical</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prewarn Margin Critical</em>' containment reference.
	 * @see #setPrewarnMarginCritical(Time)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getPeriodicEventRequirement_PrewarnMarginCritical()
	 * @model containment="true"
	 * @generated
	 */
	Time getPrewarnMarginCritical();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getPrewarnMarginCritical <em>Prewarn Margin Critical</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prewarn Margin Critical</em>' containment reference.
	 * @see #getPrewarnMarginCritical()
	 * @generated
	 */
	void setPrewarnMarginCritical(Time value);

} // PeriodicEventRequirement
