/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#getDescription <em>Description</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#getEtag <em>Etag</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#isEvaluate <em>Evaluate</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#getProvidedBy <em>Provided By</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#isShow <em>Show</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.Requirement#getUrl <em>Url</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement()
 * @model abstract="true"
 * @generated
 */
public interface Requirement extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_Description()
	 * @model extendedMetaData="kind='content'"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Etag</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Etag</em>' attribute.
	 * @see #setEtag(String)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_Etag()
	 * @model
	 * @generated
	 */
	String getEtag();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#getEtag <em>Etag</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Etag</em>' attribute.
	 * @see #getEtag()
	 * @generated
	 */
	void setEtag(String value);

	/**
	 * Returns the value of the '<em><b>Evaluate</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Evaluate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Evaluate</em>' attribute.
	 * @see #setEvaluate(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_Evaluate()
	 * @model default="true"
	 * @generated
	 */
	boolean isEvaluate();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#isEvaluate <em>Evaluate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evaluate</em>' attribute.
	 * @see #isEvaluate()
	 * @generated
	 */
	void setEvaluate(boolean value);

	/**
	 * Returns the value of the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Provided By</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Provided By</em>' attribute.
	 * @see #setProvidedBy(String)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_ProvidedBy()
	 * @model extendedMetaData="kind='content'"
	 * @generated
	 */
	String getProvidedBy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#getProvidedBy <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Provided By</em>' attribute.
	 * @see #getProvidedBy()
	 * @generated
	 */
	void setProvidedBy(String value);

	/**
	 * Returns the value of the '<em><b>Show</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Show</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show</em>' attribute.
	 * @see #setShow(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_Show()
	 * @model default="true"
	 * @generated
	 */
	boolean isShow();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#isShow <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show</em>' attribute.
	 * @see #isShow()
	 * @generated
	 */
	void setShow(boolean value);

	/**
	 * Returns the value of the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Url</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Url</em>' attribute.
	 * @see #setUrl(String)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getRequirement_Url()
	 * @model
	 * @generated
	 */
	String getUrl();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.Requirement#getUrl <em>Url</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Url</em>' attribute.
	 * @see #getUrl()
	 * @generated
	 */
	void setUrl(String value);

} // Requirement
