/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage
 * @generated
 */
public interface RequirementFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RequirementFactory eINSTANCE = com.inchron.realtime.root.model.requirement.impl.RequirementFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Call Nesting Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Nesting Requirement</em>'.
	 * @generated
	 */
	CallNestingRequirement createCallNestingRequirement();

	/**
	 * Returns a new object of class '<em>Evaluation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Evaluation</em>'.
	 * @generated
	 */
	Evaluation createEvaluation();

	/**
	 * Returns a new object of class '<em>Event Chain Break Off Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Chain Break Off Requirement</em>'.
	 * @generated
	 */
	EventChainBreakOffRequirement createEventChainBreakOffRequirement();

	/**
	 * Returns a new object of class '<em>Event Chain Join Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Chain Join Requirement</em>'.
	 * @generated
	 */
	EventChainJoinRequirement createEventChainJoinRequirement();

	/**
	 * Returns a new object of class '<em>Event Chain Multiple Processing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Chain Multiple Processing Requirement</em>'.
	 * @generated
	 */
	EventChainMultipleProcessingRequirement createEventChainMultipleProcessingRequirement();

	/**
	 * Returns a new object of class '<em>Event Chain Timing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Chain Timing Requirement</em>'.
	 * @generated
	 */
	EventChainTimingRequirement createEventChainTimingRequirement();

	/**
	 * Returns a new object of class '<em>Event IEvent JRequirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event IEvent JRequirement</em>'.
	 * @generated
	 */
	EventIEventJRequirement createEventIEventJRequirement();

	/**
	 * Returns a new object of class '<em>Event Net Exec Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Net Exec Time Requirement</em>'.
	 * @generated
	 */
	EventNetExecTimeRequirement createEventNetExecTimeRequirement();

	/**
	 * Returns a new object of class '<em>Event Timing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event Timing Requirement</em>'.
	 * @generated
	 */
	EventTimingRequirement createEventTimingRequirement();

	/**
	 * Returns a new object of class '<em>Group Of Requirements</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Group Of Requirements</em>'.
	 * @generated
	 */
	GroupOfRequirements createGroupOfRequirements();

	/**
	 * Returns a new object of class '<em>Illegal Event Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Illegal Event Requirement</em>'.
	 * @generated
	 */
	IllegalEventRequirement createIllegalEventRequirement();

	/**
	 * Returns a new object of class '<em>Load Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Load Requirement</em>'.
	 * @generated
	 */
	LoadRequirement createLoadRequirement();

	/**
	 * Returns a new object of class '<em>Net Exec Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Net Exec Time Requirement</em>'.
	 * @generated
	 */
	NetExecTimeRequirement createNetExecTimeRequirement();

	/**
	 * Returns a new object of class '<em>Net Slack Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Net Slack Time Requirement</em>'.
	 * @generated
	 */
	NetSlackTimeRequirement createNetSlackTimeRequirement();

	/**
	 * Returns a new object of class '<em>Periodic Event Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Periodic Event Requirement</em>'.
	 * @generated
	 */
	PeriodicEventRequirement createPeriodicEventRequirement();

	/**
	 * Returns a new object of class '<em>Recursion Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Recursion Requirement</em>'.
	 * @generated
	 */
	RecursionRequirement createRecursionRequirement();

	/**
	 * Returns a new object of class '<em>Response Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Response Time Requirement</em>'.
	 * @generated
	 */
	ResponseTimeRequirement createResponseTimeRequirement();

	/**
	 * Returns a new object of class '<em>Rtos Failure Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rtos Failure Requirement</em>'.
	 * @generated
	 */
	RtosFailureRequirement createRtosFailureRequirement();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	RequirementPackage getRequirementPackage();

} //RequirementFactory
