/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.requirement.RequirementFactory
 * @model kind="package"
 * @generated
 */
public interface RequirementPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "requirement";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/model/requirement";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "requirement";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RequirementPackage eINSTANCE = com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl <em>Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRequirement()
	 * @generated
	 */
	int REQUIREMENT = 16;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__DESCRIPTION = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__ETAG = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__EVALUATE = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__PROVIDED_BY = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__SHOW = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__URL = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.CallNestingRequirementImpl <em>Call Nesting Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.CallNestingRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getCallNestingRequirement()
	 * @generated
	 */
	int CALL_NESTING_REQUIREMENT = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT__LIMIT = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Call Nesting Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Call Nesting Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_NESTING_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EvaluationImpl <em>Evaluation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EvaluationImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEvaluation()
	 * @generated
	 */
	int EVALUATION = 1;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVALUATION__PROVIDED_BY = 0;

	/**
	 * The feature id for the '<em><b>Time Created</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVALUATION__TIME_CREATED = 1;

	/**
	 * The feature id for the '<em><b>Verdict</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVALUATION__VERDICT = 2;

	/**
	 * The number of structural features of the '<em>Evaluation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVALUATION_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Evaluation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVALUATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl <em>Event Chain Break Off Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainBreakOffRequirement()
	 * @generated
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Evaluate Break Off As Success</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Ignore Last Instances</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES = REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Ignore Non Sequential</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL = REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Ignore Skipped</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED = REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Required Last Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP = REQUIREMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Event Chain Break Off Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Event Chain Break Off Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_BREAK_OFF_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainJoinRequirementImpl <em>Event Chain Join Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventChainJoinRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainJoinRequirement()
	 * @generated
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Allow Same Instance</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__ALLOW_SAME_INSTANCE = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT__EVENT_CHAIN = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Event Chain Join Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Event Chain Join Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_JOIN_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainMultipleProcessingRequirementImpl <em>Event Chain Multiple Processing Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventChainMultipleProcessingRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainMultipleProcessingRequirement()
	 * @generated
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Event Chain Multiple Processing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Event Chain Multiple Processing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl <em>Timing Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getTimingRequirement()
	 * @generated
	 */
	int TIMING_REQUIREMENT = 19;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__RELATIONAL_OPERATOR = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__LIMIT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__PREWARN_MARGIN = REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT__RELATIVE = REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIMING_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl <em>Event Chain Timing Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainTimingRequirement()
	 * @generated
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT = 5;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Event Chain</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>From Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Instance Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Strategy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY = TIMING_REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>To Step</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP = TIMING_REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Event Chain Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Event Chain Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_TIMING_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl <em>Event IEvent JRequirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventIEventJRequirement()
	 * @generated
	 */
	int EVENT_IEVENT_JREQUIREMENT = 6;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>End Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__END_EVENT = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter A</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__PARAMETER_A = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parameter B</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__PARAMETER_B = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Start Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT__START_EVENT = TIMING_REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Event IEvent JRequirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Event IEvent JRequirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_IEVENT_JREQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl <em>Event Net Exec Time Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventNetExecTimeRequirement()
	 * @generated
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT = 7;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__END = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT__START = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Event Net Exec Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Event Net Exec Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_NET_EXEC_TIME_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.EventTimingRequirementImpl <em>Event Timing Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.EventTimingRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventTimingRequirement()
	 * @generated
	 */
	int EVENT_TIMING_REQUIREMENT = 8;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Trigger</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__TRIGGER = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__START = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Stop</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT__STOP = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Event Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Event Timing Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TIMING_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.GroupOfRequirementsImpl <em>Group Of Requirements</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.GroupOfRequirementsImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getGroupOfRequirements()
	 * @generated
	 */
	int GROUP_OF_REQUIREMENTS = 9;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Requirements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS__REQUIREMENTS = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Group Of Requirements</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Group Of Requirements</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_OF_REQUIREMENTS_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.IllegalEventRequirementImpl <em>Illegal Event Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.IllegalEventRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getIllegalEventRequirement()
	 * @generated
	 */
	int ILLEGAL_EVENT_REQUIREMENT = 10;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT__EVENT = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Illegal Event Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Illegal Event Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ILLEGAL_EVENT_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl <em>Load Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getLoadRequirement()
	 * @generated
	 */
	int LOAD_REQUIREMENT = 11;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Granularity</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__GRANULARITY = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__LIMIT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Load Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__LOAD_RESOURCE = REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__PREWARN_MARGIN = REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__RELATIONAL_OPERATOR = REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Steps</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT__STEPS = REQUIREMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Load Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Load Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.NetExecTimeRequirementImpl <em>Net Exec Time Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.NetExecTimeRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetExecTimeRequirement()
	 * @generated
	 */
	int NET_EXEC_TIME_REQUIREMENT = 12;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT__PROCESS = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Net Exec Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Net Exec Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_EXEC_TIME_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl <em>Net Slack Time Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetSlackTimeRequirement()
	 * @generated
	 */
	int NET_SLACK_TIME_REQUIREMENT = 13;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Deadline Delta</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Deadline Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__PROCESS = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT__TYPE = TIMING_REQUIREMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Net Slack Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Net Slack Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NET_SLACK_TIME_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl <em>Periodic Event Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getPeriodicEventRequirement()
	 * @generated
	 */
	int PERIODIC_EVENT_REQUIREMENT = 14;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__EVENT = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Prewarn Margin Critical</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Periodic Event Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Periodic Event Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERIODIC_EVENT_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.RecursionRequirementImpl <em>Recursion Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.RecursionRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRecursionRequirement()
	 * @generated
	 */
	int RECURSION_REQUIREMENT = 15;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT__LIMIT = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Recursion Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Recursion Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECURSION_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.ResponseTimeRequirementImpl <em>Response Time Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.ResponseTimeRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getResponseTimeRequirement()
	 * @generated
	 */
	int RESPONSE_TIME_REQUIREMENT = 17;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__INTRINSIC_ID = TIMING_REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__NAME = TIMING_REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__DESCRIPTION = TIMING_REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__ETAG = TIMING_REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__EVALUATE = TIMING_REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__PROVIDED_BY = TIMING_REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__SHOW = TIMING_REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__URL = TIMING_REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__RELATIONAL_OPERATOR = TIMING_REQUIREMENT__RELATIONAL_OPERATOR;

	/**
	 * The feature id for the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__LIMIT = TIMING_REQUIREMENT__LIMIT;

	/**
	 * The feature id for the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__PREWARN_MARGIN = TIMING_REQUIREMENT__PREWARN_MARGIN;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__RELATIVE = TIMING_REQUIREMENT__RELATIVE;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT__PROCESS = TIMING_REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Response Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT_FEATURE_COUNT = TIMING_REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Response Time Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESPONSE_TIME_REQUIREMENT_OPERATION_COUNT = TIMING_REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl <em>Rtos Failure Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRtosFailureRequirement()
	 * @generated
	 */
	int RTOS_FAILURE_REQUIREMENT = 18;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__INTRINSIC_ID = REQUIREMENT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__NAME = REQUIREMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__DESCRIPTION = REQUIREMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Etag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__ETAG = REQUIREMENT__ETAG;

	/**
	 * The feature id for the '<em><b>Evaluate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__EVALUATE = REQUIREMENT__EVALUATE;

	/**
	 * The feature id for the '<em><b>Provided By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__PROVIDED_BY = REQUIREMENT__PROVIDED_BY;

	/**
	 * The feature id for the '<em><b>Show</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__SHOW = REQUIREMENT__SHOW;

	/**
	 * The feature id for the '<em><b>Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__URL = REQUIREMENT__URL;

	/**
	 * The feature id for the '<em><b>Enabled RTOS Failures</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES = REQUIREMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Blacklist</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT__BLACKLIST = REQUIREMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Rtos Failure Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT_FEATURE_COUNT = REQUIREMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Rtos Failure Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_FAILURE_REQUIREMENT_OPERATION_COUNT = REQUIREMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.EventChainStrategy <em>Event Chain Strategy</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.EventChainStrategy
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainStrategy()
	 * @generated
	 */
	int EVENT_CHAIN_STRATEGY = 20;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType <em>Net Slack Time Requirement Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetSlackTimeRequirementType()
	 * @generated
	 */
	int NET_SLACK_TIME_REQUIREMENT_TYPE = 21;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperator <em>Relational Operator</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperator
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperator()
	 * @generated
	 */
	int RELATIONAL_OPERATOR = 22;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe <em>Relational Operator Le Ge</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperatorLeGe()
	 * @generated
	 */
	int RELATIONAL_OPERATOR_LE_GE = 23;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe <em>Relational Operator Lt Le Gt Ge</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperatorLtLeGtGe()
	 * @generated
	 */
	int RELATIONAL_OPERATOR_LT_LE_GT_GE = 24;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.RTOSFailure <em>RTOS Failure</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.RTOSFailure
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRTOSFailure()
	 * @generated
	 */
	int RTOS_FAILURE = 25;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.requirement.Verdict <em>Verdict</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.requirement.Verdict
	 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getVerdict()
	 * @generated
	 */
	int VERDICT = 26;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.CallNestingRequirement <em>Call Nesting Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Nesting Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.CallNestingRequirement
	 * @generated
	 */
	EClass getCallNestingRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.CallNestingRequirement#getLimit <em>Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Limit</em>'.
	 * @see com.inchron.realtime.root.model.requirement.CallNestingRequirement#getLimit()
	 * @see #getCallNestingRequirement()
	 * @generated
	 */
	EAttribute getCallNestingRequirement_Limit();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.Evaluation <em>Evaluation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Evaluation</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Evaluation
	 * @generated
	 */
	EClass getEvaluation();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Evaluation#getProvidedBy <em>Provided By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Provided By</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Evaluation#getProvidedBy()
	 * @see #getEvaluation()
	 * @generated
	 */
	EAttribute getEvaluation_ProvidedBy();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Evaluation#getTimeCreated <em>Time Created</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Created</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Evaluation#getTimeCreated()
	 * @see #getEvaluation()
	 * @generated
	 */
	EAttribute getEvaluation_TimeCreated();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Evaluation#getVerdict <em>Verdict</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Verdict</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Evaluation#getVerdict()
	 * @see #getEvaluation()
	 * @generated
	 */
	EAttribute getEvaluation_Verdict();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement <em>Event Chain Break Off Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain Break Off Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement
	 * @generated
	 */
	EClass getEventChainBreakOffRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isEvaluateBreakOffAsSuccess <em>Evaluate Break Off As Success</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Evaluate Break Off As Success</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isEvaluateBreakOffAsSuccess()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EAttribute getEventChainBreakOffRequirement_EvaluateBreakOffAsSuccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getEventChain <em>Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getEventChain()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EReference getEventChainBreakOffRequirement_EventChain();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getIgnoreLastInstances <em>Ignore Last Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ignore Last Instances</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getIgnoreLastInstances()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EAttribute getEventChainBreakOffRequirement_IgnoreLastInstances();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreNonSequential <em>Ignore Non Sequential</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ignore Non Sequential</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreNonSequential()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EAttribute getEventChainBreakOffRequirement_IgnoreNonSequential();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreSkipped <em>Ignore Skipped</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ignore Skipped</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#isIgnoreSkipped()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EAttribute getEventChainBreakOffRequirement_IgnoreSkipped();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getRequiredLastStep <em>Required Last Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Required Last Step</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainBreakOffRequirement#getRequiredLastStep()
	 * @see #getEventChainBreakOffRequirement()
	 * @generated
	 */
	EReference getEventChainBreakOffRequirement_RequiredLastStep();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement <em>Event Chain Join Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain Join Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainJoinRequirement
	 * @generated
	 */
	EClass getEventChainJoinRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#isAllowSameInstance <em>Allow Same Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Allow Same Instance</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#isAllowSameInstance()
	 * @see #getEventChainJoinRequirement()
	 * @generated
	 */
	EAttribute getEventChainJoinRequirement_AllowSameInstance();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#getEventChain <em>Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainJoinRequirement#getEventChain()
	 * @see #getEventChainJoinRequirement()
	 * @generated
	 */
	EReference getEventChainJoinRequirement_EventChain();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventChainMultipleProcessingRequirement <em>Event Chain Multiple Processing Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain Multiple Processing Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainMultipleProcessingRequirement
	 * @generated
	 */
	EClass getEventChainMultipleProcessingRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainMultipleProcessingRequirement#getEventChain <em>Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainMultipleProcessingRequirement#getEventChain()
	 * @see #getEventChainMultipleProcessingRequirement()
	 * @generated
	 */
	EReference getEventChainMultipleProcessingRequirement_EventChain();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement <em>Event Chain Timing Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain Timing Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement
	 * @generated
	 */
	EClass getEventChainTimingRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getEventChain <em>Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getEventChain()
	 * @see #getEventChainTimingRequirement()
	 * @generated
	 */
	EReference getEventChainTimingRequirement_EventChain();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getFromStep <em>From Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Step</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getFromStep()
	 * @see #getEventChainTimingRequirement()
	 * @generated
	 */
	EReference getEventChainTimingRequirement_FromStep();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getInstanceOffset <em>Instance Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Instance Offset</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getInstanceOffset()
	 * @see #getEventChainTimingRequirement()
	 * @generated
	 */
	EAttribute getEventChainTimingRequirement_InstanceOffset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getStrategy <em>Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Strategy</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getStrategy()
	 * @see #getEventChainTimingRequirement()
	 * @generated
	 */
	EAttribute getEventChainTimingRequirement_Strategy();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getToStep <em>To Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Step</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainTimingRequirement#getToStep()
	 * @see #getEventChainTimingRequirement()
	 * @generated
	 */
	EReference getEventChainTimingRequirement_ToStep();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement <em>Event IEvent JRequirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event IEvent JRequirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventIEventJRequirement
	 * @generated
	 */
	EClass getEventIEventJRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getEndEvent <em>End Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End Event</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getEndEvent()
	 * @see #getEventIEventJRequirement()
	 * @generated
	 */
	EReference getEventIEventJRequirement_EndEvent();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterA <em>Parameter A</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter A</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterA()
	 * @see #getEventIEventJRequirement()
	 * @generated
	 */
	EAttribute getEventIEventJRequirement_ParameterA();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterB <em>Parameter B</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter B</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getParameterB()
	 * @see #getEventIEventJRequirement()
	 * @generated
	 */
	EAttribute getEventIEventJRequirement_ParameterB();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getStartEvent <em>Start Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start Event</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventIEventJRequirement#getStartEvent()
	 * @see #getEventIEventJRequirement()
	 * @generated
	 */
	EReference getEventIEventJRequirement_StartEvent();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement <em>Event Net Exec Time Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Net Exec Time Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement
	 * @generated
	 */
	EClass getEventNetExecTimeRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>End</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getEnd()
	 * @see #getEventNetExecTimeRequirement()
	 * @generated
	 */
	EReference getEventNetExecTimeRequirement_End();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getProcess()
	 * @see #getEventNetExecTimeRequirement()
	 * @generated
	 */
	EReference getEventNetExecTimeRequirement_Process();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getStart()
	 * @see #getEventNetExecTimeRequirement()
	 * @generated
	 */
	EReference getEventNetExecTimeRequirement_Start();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement <em>Event Timing Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Timing Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventTimingRequirement
	 * @generated
	 */
	EClass getEventTimingRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getTrigger <em>Trigger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Trigger</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventTimingRequirement#getTrigger()
	 * @see #getEventTimingRequirement()
	 * @generated
	 */
	EReference getEventTimingRequirement_Trigger();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStart <em>Start</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Start</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStart()
	 * @see #getEventTimingRequirement()
	 * @generated
	 */
	EReference getEventTimingRequirement_Start();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStop <em>Stop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Stop</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStop()
	 * @see #getEventTimingRequirement()
	 * @generated
	 */
	EReference getEventTimingRequirement_Stop();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.GroupOfRequirements <em>Group Of Requirements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Group Of Requirements</em>'.
	 * @see com.inchron.realtime.root.model.requirement.GroupOfRequirements
	 * @generated
	 */
	EClass getGroupOfRequirements();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.requirement.GroupOfRequirements#getRequirements <em>Requirements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Requirements</em>'.
	 * @see com.inchron.realtime.root.model.requirement.GroupOfRequirements#getRequirements()
	 * @see #getGroupOfRequirements()
	 * @generated
	 */
	EReference getGroupOfRequirements_Requirements();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.IllegalEventRequirement <em>Illegal Event Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Illegal Event Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.IllegalEventRequirement
	 * @generated
	 */
	EClass getIllegalEventRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.IllegalEventRequirement#getEvent <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event</em>'.
	 * @see com.inchron.realtime.root.model.requirement.IllegalEventRequirement#getEvent()
	 * @see #getIllegalEventRequirement()
	 * @generated
	 */
	EReference getIllegalEventRequirement_Event();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.LoadRequirement <em>Load Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Load Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement
	 * @generated
	 */
	EClass getLoadRequirement();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getGranularity <em>Granularity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Granularity</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getGranularity()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EReference getLoadRequirement_Granularity();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLimit <em>Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Limit</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getLimit()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EAttribute getLoadRequirement_Limit();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLoadResource <em>Load Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Load Resource</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getLoadResource()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EReference getLoadRequirement_LoadResource();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getPrewarnMargin <em>Prewarn Margin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prewarn Margin</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getPrewarnMargin()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EAttribute getLoadRequirement_PrewarnMargin();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getRelationalOperator <em>Relational Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relational Operator</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getRelationalOperator()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EAttribute getLoadRequirement_RelationalOperator();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Steps</em>'.
	 * @see com.inchron.realtime.root.model.requirement.LoadRequirement#getSteps()
	 * @see #getLoadRequirement()
	 * @generated
	 */
	EAttribute getLoadRequirement_Steps();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.NetExecTimeRequirement <em>Net Exec Time Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Net Exec Time Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetExecTimeRequirement
	 * @generated
	 */
	EClass getNetExecTimeRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.NetExecTimeRequirement#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetExecTimeRequirement#getProcess()
	 * @see #getNetExecTimeRequirement()
	 * @generated
	 */
	EReference getNetExecTimeRequirement_Process();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement <em>Net Slack Time Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Net Slack Time Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement
	 * @generated
	 */
	EClass getNetSlackTimeRequirement();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineDelta <em>Deadline Delta</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deadline Delta</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineDelta()
	 * @see #getNetSlackTimeRequirement()
	 * @generated
	 */
	EReference getNetSlackTimeRequirement_DeadlineDelta();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineEvent <em>Deadline Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Deadline Event</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getDeadlineEvent()
	 * @see #getNetSlackTimeRequirement()
	 * @generated
	 */
	EReference getNetSlackTimeRequirement_DeadlineEvent();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getProcess()
	 * @see #getNetSlackTimeRequirement()
	 * @generated
	 */
	EReference getNetSlackTimeRequirement_Process();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirement#getType()
	 * @see #getNetSlackTimeRequirement()
	 * @generated
	 */
	EAttribute getNetSlackTimeRequirement_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement <em>Periodic Event Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Periodic Event Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.PeriodicEventRequirement
	 * @generated
	 */
	EClass getPeriodicEventRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getEvent <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event</em>'.
	 * @see com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getEvent()
	 * @see #getPeriodicEventRequirement()
	 * @generated
	 */
	EReference getPeriodicEventRequirement_Event();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getPrewarnMarginCritical <em>Prewarn Margin Critical</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Prewarn Margin Critical</em>'.
	 * @see com.inchron.realtime.root.model.requirement.PeriodicEventRequirement#getPrewarnMarginCritical()
	 * @see #getPeriodicEventRequirement()
	 * @generated
	 */
	EReference getPeriodicEventRequirement_PrewarnMarginCritical();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.RecursionRequirement <em>Recursion Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Recursion Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RecursionRequirement
	 * @generated
	 */
	EClass getRecursionRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.RecursionRequirement#getLimit <em>Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Limit</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RecursionRequirement#getLimit()
	 * @see #getRecursionRequirement()
	 * @generated
	 */
	EAttribute getRecursionRequirement_Limit();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.Requirement <em>Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement
	 * @generated
	 */
	EClass getRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#getDescription()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_Description();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#getEtag <em>Etag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Etag</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#getEtag()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_Etag();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#isEvaluate <em>Evaluate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Evaluate</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#isEvaluate()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_Evaluate();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#getProvidedBy <em>Provided By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Provided By</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#getProvidedBy()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_ProvidedBy();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#isShow <em>Show</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Show</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#isShow()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_Show();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.Requirement#getUrl <em>Url</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Url</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Requirement#getUrl()
	 * @see #getRequirement()
	 * @generated
	 */
	EAttribute getRequirement_Url();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.ResponseTimeRequirement <em>Response Time Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Response Time Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.ResponseTimeRequirement
	 * @generated
	 */
	EClass getResponseTimeRequirement();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.requirement.ResponseTimeRequirement#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.requirement.ResponseTimeRequirement#getProcess()
	 * @see #getResponseTimeRequirement()
	 * @generated
	 */
	EReference getResponseTimeRequirement_Process();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.RtosFailureRequirement <em>Rtos Failure Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rtos Failure Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RtosFailureRequirement
	 * @generated
	 */
	EClass getRtosFailureRequirement();

	/**
	 * Returns the meta object for the attribute list '{@link com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getEnabledRTOSFailures <em>Enabled RTOS Failures</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Enabled RTOS Failures</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getEnabledRTOSFailures()
	 * @see #getRtosFailureRequirement()
	 * @generated
	 */
	EAttribute getRtosFailureRequirement_EnabledRTOSFailures();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getBlacklist <em>Blacklist</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Blacklist</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RtosFailureRequirement#getBlacklist()
	 * @see #getRtosFailureRequirement()
	 * @generated
	 */
	EReference getRtosFailureRequirement_Blacklist();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.requirement.TimingRequirement <em>Timing Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Timing Requirement</em>'.
	 * @see com.inchron.realtime.root.model.requirement.TimingRequirement
	 * @generated
	 */
	EClass getTimingRequirement();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getRelationalOperator <em>Relational Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relational Operator</em>'.
	 * @see com.inchron.realtime.root.model.requirement.TimingRequirement#getRelationalOperator()
	 * @see #getTimingRequirement()
	 * @generated
	 */
	EAttribute getTimingRequirement_RelationalOperator();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getLimit <em>Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Limit</em>'.
	 * @see com.inchron.realtime.root.model.requirement.TimingRequirement#getLimit()
	 * @see #getTimingRequirement()
	 * @generated
	 */
	EReference getTimingRequirement_Limit();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMargin <em>Prewarn Margin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Prewarn Margin</em>'.
	 * @see com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMargin()
	 * @see #getTimingRequirement()
	 * @generated
	 */
	EReference getTimingRequirement_PrewarnMargin();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#isRelative <em>Relative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relative</em>'.
	 * @see com.inchron.realtime.root.model.requirement.TimingRequirement#isRelative()
	 * @see #getTimingRequirement()
	 * @generated
	 */
	EAttribute getTimingRequirement_Relative();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.EventChainStrategy <em>Event Chain Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Event Chain Strategy</em>'.
	 * @see com.inchron.realtime.root.model.requirement.EventChainStrategy
	 * @generated
	 */
	EEnum getEventChainStrategy();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType <em>Net Slack Time Requirement Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Net Slack Time Requirement Type</em>'.
	 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType
	 * @generated
	 */
	EEnum getNetSlackTimeRequirementType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.RelationalOperator <em>Relational Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relational Operator</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperator
	 * @generated
	 */
	EEnum getRelationalOperator();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe <em>Relational Operator Le Ge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relational Operator Le Ge</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe
	 * @generated
	 */
	EEnum getRelationalOperatorLeGe();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe <em>Relational Operator Lt Le Gt Ge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relational Operator Lt Le Gt Ge</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe
	 * @generated
	 */
	EEnum getRelationalOperatorLtLeGtGe();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.RTOSFailure <em>RTOS Failure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>RTOS Failure</em>'.
	 * @see com.inchron.realtime.root.model.requirement.RTOSFailure
	 * @generated
	 */
	EEnum getRTOSFailure();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.requirement.Verdict <em>Verdict</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Verdict</em>'.
	 * @see com.inchron.realtime.root.model.requirement.Verdict
	 * @generated
	 */
	EEnum getVerdict();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RequirementFactory getRequirementFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.CallNestingRequirementImpl <em>Call Nesting Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.CallNestingRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getCallNestingRequirement()
		 * @generated
		 */
		EClass CALL_NESTING_REQUIREMENT = eINSTANCE.getCallNestingRequirement();

		/**
		 * The meta object literal for the '<em><b>Limit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_NESTING_REQUIREMENT__LIMIT = eINSTANCE.getCallNestingRequirement_Limit();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EvaluationImpl <em>Evaluation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EvaluationImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEvaluation()
		 * @generated
		 */
		EClass EVALUATION = eINSTANCE.getEvaluation();

		/**
		 * The meta object literal for the '<em><b>Provided By</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVALUATION__PROVIDED_BY = eINSTANCE.getEvaluation_ProvidedBy();

		/**
		 * The meta object literal for the '<em><b>Time Created</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVALUATION__TIME_CREATED = eINSTANCE.getEvaluation_TimeCreated();

		/**
		 * The meta object literal for the '<em><b>Verdict</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVALUATION__VERDICT = eINSTANCE.getEvaluation_Verdict();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl <em>Event Chain Break Off Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventChainBreakOffRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainBreakOffRequirement()
		 * @generated
		 */
		EClass EVENT_CHAIN_BREAK_OFF_REQUIREMENT = eINSTANCE.getEventChainBreakOffRequirement();

		/**
		 * The meta object literal for the '<em><b>Evaluate Break Off As Success</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVALUATE_BREAK_OFF_AS_SUCCESS = eINSTANCE.getEventChainBreakOffRequirement_EvaluateBreakOffAsSuccess();

		/**
		 * The meta object literal for the '<em><b>Event Chain</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_BREAK_OFF_REQUIREMENT__EVENT_CHAIN = eINSTANCE.getEventChainBreakOffRequirement_EventChain();

		/**
		 * The meta object literal for the '<em><b>Ignore Last Instances</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_LAST_INSTANCES = eINSTANCE.getEventChainBreakOffRequirement_IgnoreLastInstances();

		/**
		 * The meta object literal for the '<em><b>Ignore Non Sequential</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_NON_SEQUENTIAL = eINSTANCE.getEventChainBreakOffRequirement_IgnoreNonSequential();

		/**
		 * The meta object literal for the '<em><b>Ignore Skipped</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_BREAK_OFF_REQUIREMENT__IGNORE_SKIPPED = eINSTANCE.getEventChainBreakOffRequirement_IgnoreSkipped();

		/**
		 * The meta object literal for the '<em><b>Required Last Step</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_BREAK_OFF_REQUIREMENT__REQUIRED_LAST_STEP = eINSTANCE.getEventChainBreakOffRequirement_RequiredLastStep();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainJoinRequirementImpl <em>Event Chain Join Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventChainJoinRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainJoinRequirement()
		 * @generated
		 */
		EClass EVENT_CHAIN_JOIN_REQUIREMENT = eINSTANCE.getEventChainJoinRequirement();

		/**
		 * The meta object literal for the '<em><b>Allow Same Instance</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_JOIN_REQUIREMENT__ALLOW_SAME_INSTANCE = eINSTANCE.getEventChainJoinRequirement_AllowSameInstance();

		/**
		 * The meta object literal for the '<em><b>Event Chain</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_JOIN_REQUIREMENT__EVENT_CHAIN = eINSTANCE.getEventChainJoinRequirement_EventChain();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainMultipleProcessingRequirementImpl <em>Event Chain Multiple Processing Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventChainMultipleProcessingRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainMultipleProcessingRequirement()
		 * @generated
		 */
		EClass EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT = eINSTANCE.getEventChainMultipleProcessingRequirement();

		/**
		 * The meta object literal for the '<em><b>Event Chain</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN = eINSTANCE.getEventChainMultipleProcessingRequirement_EventChain();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl <em>Event Chain Timing Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventChainTimingRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainTimingRequirement()
		 * @generated
		 */
		EClass EVENT_CHAIN_TIMING_REQUIREMENT = eINSTANCE.getEventChainTimingRequirement();

		/**
		 * The meta object literal for the '<em><b>Event Chain</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_TIMING_REQUIREMENT__EVENT_CHAIN = eINSTANCE.getEventChainTimingRequirement_EventChain();

		/**
		 * The meta object literal for the '<em><b>From Step</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_TIMING_REQUIREMENT__FROM_STEP = eINSTANCE.getEventChainTimingRequirement_FromStep();

		/**
		 * The meta object literal for the '<em><b>Instance Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_TIMING_REQUIREMENT__INSTANCE_OFFSET = eINSTANCE.getEventChainTimingRequirement_InstanceOffset();

		/**
		 * The meta object literal for the '<em><b>Strategy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_CHAIN_TIMING_REQUIREMENT__STRATEGY = eINSTANCE.getEventChainTimingRequirement_Strategy();

		/**
		 * The meta object literal for the '<em><b>To Step</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_CHAIN_TIMING_REQUIREMENT__TO_STEP = eINSTANCE.getEventChainTimingRequirement_ToStep();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl <em>Event IEvent JRequirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventIEventJRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventIEventJRequirement()
		 * @generated
		 */
		EClass EVENT_IEVENT_JREQUIREMENT = eINSTANCE.getEventIEventJRequirement();

		/**
		 * The meta object literal for the '<em><b>End Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_IEVENT_JREQUIREMENT__END_EVENT = eINSTANCE.getEventIEventJRequirement_EndEvent();

		/**
		 * The meta object literal for the '<em><b>Parameter A</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_IEVENT_JREQUIREMENT__PARAMETER_A = eINSTANCE.getEventIEventJRequirement_ParameterA();

		/**
		 * The meta object literal for the '<em><b>Parameter B</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_IEVENT_JREQUIREMENT__PARAMETER_B = eINSTANCE.getEventIEventJRequirement_ParameterB();

		/**
		 * The meta object literal for the '<em><b>Start Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_IEVENT_JREQUIREMENT__START_EVENT = eINSTANCE.getEventIEventJRequirement_StartEvent();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl <em>Event Net Exec Time Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventNetExecTimeRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventNetExecTimeRequirement()
		 * @generated
		 */
		EClass EVENT_NET_EXEC_TIME_REQUIREMENT = eINSTANCE.getEventNetExecTimeRequirement();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_NET_EXEC_TIME_REQUIREMENT__END = eINSTANCE.getEventNetExecTimeRequirement_End();

		/**
		 * The meta object literal for the '<em><b>Process</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_NET_EXEC_TIME_REQUIREMENT__PROCESS = eINSTANCE.getEventNetExecTimeRequirement_Process();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_NET_EXEC_TIME_REQUIREMENT__START = eINSTANCE.getEventNetExecTimeRequirement_Start();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.EventTimingRequirementImpl <em>Event Timing Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.EventTimingRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventTimingRequirement()
		 * @generated
		 */
		EClass EVENT_TIMING_REQUIREMENT = eINSTANCE.getEventTimingRequirement();

		/**
		 * The meta object literal for the '<em><b>Trigger</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_TIMING_REQUIREMENT__TRIGGER = eINSTANCE.getEventTimingRequirement_Trigger();

		/**
		 * The meta object literal for the '<em><b>Start</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_TIMING_REQUIREMENT__START = eINSTANCE.getEventTimingRequirement_Start();

		/**
		 * The meta object literal for the '<em><b>Stop</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EVENT_TIMING_REQUIREMENT__STOP = eINSTANCE.getEventTimingRequirement_Stop();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.GroupOfRequirementsImpl <em>Group Of Requirements</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.GroupOfRequirementsImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getGroupOfRequirements()
		 * @generated
		 */
		EClass GROUP_OF_REQUIREMENTS = eINSTANCE.getGroupOfRequirements();

		/**
		 * The meta object literal for the '<em><b>Requirements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GROUP_OF_REQUIREMENTS__REQUIREMENTS = eINSTANCE.getGroupOfRequirements_Requirements();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.IllegalEventRequirementImpl <em>Illegal Event Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.IllegalEventRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getIllegalEventRequirement()
		 * @generated
		 */
		EClass ILLEGAL_EVENT_REQUIREMENT = eINSTANCE.getIllegalEventRequirement();

		/**
		 * The meta object literal for the '<em><b>Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ILLEGAL_EVENT_REQUIREMENT__EVENT = eINSTANCE.getIllegalEventRequirement_Event();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl <em>Load Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.LoadRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getLoadRequirement()
		 * @generated
		 */
		EClass LOAD_REQUIREMENT = eINSTANCE.getLoadRequirement();

		/**
		 * The meta object literal for the '<em><b>Granularity</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOAD_REQUIREMENT__GRANULARITY = eINSTANCE.getLoadRequirement_Granularity();

		/**
		 * The meta object literal for the '<em><b>Limit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOAD_REQUIREMENT__LIMIT = eINSTANCE.getLoadRequirement_Limit();

		/**
		 * The meta object literal for the '<em><b>Load Resource</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOAD_REQUIREMENT__LOAD_RESOURCE = eINSTANCE.getLoadRequirement_LoadResource();

		/**
		 * The meta object literal for the '<em><b>Prewarn Margin</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOAD_REQUIREMENT__PREWARN_MARGIN = eINSTANCE.getLoadRequirement_PrewarnMargin();

		/**
		 * The meta object literal for the '<em><b>Relational Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOAD_REQUIREMENT__RELATIONAL_OPERATOR = eINSTANCE.getLoadRequirement_RelationalOperator();

		/**
		 * The meta object literal for the '<em><b>Steps</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LOAD_REQUIREMENT__STEPS = eINSTANCE.getLoadRequirement_Steps();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.NetExecTimeRequirementImpl <em>Net Exec Time Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.NetExecTimeRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetExecTimeRequirement()
		 * @generated
		 */
		EClass NET_EXEC_TIME_REQUIREMENT = eINSTANCE.getNetExecTimeRequirement();

		/**
		 * The meta object literal for the '<em><b>Process</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NET_EXEC_TIME_REQUIREMENT__PROCESS = eINSTANCE.getNetExecTimeRequirement_Process();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl <em>Net Slack Time Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.NetSlackTimeRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetSlackTimeRequirement()
		 * @generated
		 */
		EClass NET_SLACK_TIME_REQUIREMENT = eINSTANCE.getNetSlackTimeRequirement();

		/**
		 * The meta object literal for the '<em><b>Deadline Delta</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NET_SLACK_TIME_REQUIREMENT__DEADLINE_DELTA = eINSTANCE.getNetSlackTimeRequirement_DeadlineDelta();

		/**
		 * The meta object literal for the '<em><b>Deadline Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NET_SLACK_TIME_REQUIREMENT__DEADLINE_EVENT = eINSTANCE.getNetSlackTimeRequirement_DeadlineEvent();

		/**
		 * The meta object literal for the '<em><b>Process</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NET_SLACK_TIME_REQUIREMENT__PROCESS = eINSTANCE.getNetSlackTimeRequirement_Process();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NET_SLACK_TIME_REQUIREMENT__TYPE = eINSTANCE.getNetSlackTimeRequirement_Type();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl <em>Periodic Event Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getPeriodicEventRequirement()
		 * @generated
		 */
		EClass PERIODIC_EVENT_REQUIREMENT = eINSTANCE.getPeriodicEventRequirement();

		/**
		 * The meta object literal for the '<em><b>Event</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERIODIC_EVENT_REQUIREMENT__EVENT = eINSTANCE.getPeriodicEventRequirement_Event();

		/**
		 * The meta object literal for the '<em><b>Prewarn Margin Critical</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL = eINSTANCE.getPeriodicEventRequirement_PrewarnMarginCritical();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.RecursionRequirementImpl <em>Recursion Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.RecursionRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRecursionRequirement()
		 * @generated
		 */
		EClass RECURSION_REQUIREMENT = eINSTANCE.getRecursionRequirement();

		/**
		 * The meta object literal for the '<em><b>Limit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECURSION_REQUIREMENT__LIMIT = eINSTANCE.getRecursionRequirement_Limit();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.RequirementImpl <em>Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRequirement()
		 * @generated
		 */
		EClass REQUIREMENT = eINSTANCE.getRequirement();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__DESCRIPTION = eINSTANCE.getRequirement_Description();

		/**
		 * The meta object literal for the '<em><b>Etag</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__ETAG = eINSTANCE.getRequirement_Etag();

		/**
		 * The meta object literal for the '<em><b>Evaluate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__EVALUATE = eINSTANCE.getRequirement_Evaluate();

		/**
		 * The meta object literal for the '<em><b>Provided By</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__PROVIDED_BY = eINSTANCE.getRequirement_ProvidedBy();

		/**
		 * The meta object literal for the '<em><b>Show</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__SHOW = eINSTANCE.getRequirement_Show();

		/**
		 * The meta object literal for the '<em><b>Url</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REQUIREMENT__URL = eINSTANCE.getRequirement_Url();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.ResponseTimeRequirementImpl <em>Response Time Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.ResponseTimeRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getResponseTimeRequirement()
		 * @generated
		 */
		EClass RESPONSE_TIME_REQUIREMENT = eINSTANCE.getResponseTimeRequirement();

		/**
		 * The meta object literal for the '<em><b>Process</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESPONSE_TIME_REQUIREMENT__PROCESS = eINSTANCE.getResponseTimeRequirement_Process();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl <em>Rtos Failure Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRtosFailureRequirement()
		 * @generated
		 */
		EClass RTOS_FAILURE_REQUIREMENT = eINSTANCE.getRtosFailureRequirement();

		/**
		 * The meta object literal for the '<em><b>Enabled RTOS Failures</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES = eINSTANCE.getRtosFailureRequirement_EnabledRTOSFailures();

		/**
		 * The meta object literal for the '<em><b>Blacklist</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RTOS_FAILURE_REQUIREMENT__BLACKLIST = eINSTANCE.getRtosFailureRequirement_Blacklist();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl <em>Timing Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getTimingRequirement()
		 * @generated
		 */
		EClass TIMING_REQUIREMENT = eINSTANCE.getTimingRequirement();

		/**
		 * The meta object literal for the '<em><b>Relational Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TIMING_REQUIREMENT__RELATIONAL_OPERATOR = eINSTANCE.getTimingRequirement_RelationalOperator();

		/**
		 * The meta object literal for the '<em><b>Limit</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIMING_REQUIREMENT__LIMIT = eINSTANCE.getTimingRequirement_Limit();

		/**
		 * The meta object literal for the '<em><b>Prewarn Margin</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIMING_REQUIREMENT__PREWARN_MARGIN = eINSTANCE.getTimingRequirement_PrewarnMargin();

		/**
		 * The meta object literal for the '<em><b>Relative</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TIMING_REQUIREMENT__RELATIVE = eINSTANCE.getTimingRequirement_Relative();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.EventChainStrategy <em>Event Chain Strategy</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.EventChainStrategy
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getEventChainStrategy()
		 * @generated
		 */
		EEnum EVENT_CHAIN_STRATEGY = eINSTANCE.getEventChainStrategy();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType <em>Net Slack Time Requirement Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.NetSlackTimeRequirementType
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getNetSlackTimeRequirementType()
		 * @generated
		 */
		EEnum NET_SLACK_TIME_REQUIREMENT_TYPE = eINSTANCE.getNetSlackTimeRequirementType();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperator <em>Relational Operator</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.RelationalOperator
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperator()
		 * @generated
		 */
		EEnum RELATIONAL_OPERATOR = eINSTANCE.getRelationalOperator();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe <em>Relational Operator Le Ge</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperatorLeGe()
		 * @generated
		 */
		EEnum RELATIONAL_OPERATOR_LE_GE = eINSTANCE.getRelationalOperatorLeGe();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe <em>Relational Operator Lt Le Gt Ge</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLtLeGtGe
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRelationalOperatorLtLeGtGe()
		 * @generated
		 */
		EEnum RELATIONAL_OPERATOR_LT_LE_GT_GE = eINSTANCE.getRelationalOperatorLtLeGtGe();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.RTOSFailure <em>RTOS Failure</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.RTOSFailure
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getRTOSFailure()
		 * @generated
		 */
		EEnum RTOS_FAILURE = eINSTANCE.getRTOSFailure();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.requirement.Verdict <em>Verdict</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.requirement.Verdict
		 * @see com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl#getVerdict()
		 * @generated
		 */
		EEnum VERDICT = eINSTANCE.getVerdict();

	}

} //RequirementPackage
