/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getRelationalOperator <em>Relational Operator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getLimit <em>Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMargin <em>Prewarn Margin</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.TimingRequirement#isRelative <em>Relative</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement()
 * @model abstract="true"
 * @generated
 */
public interface TimingRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Relational Operator</b></em>' attribute.
	 * The default value is <code>"lt"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.RelationalOperator}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relational Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relational Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperator
	 * @see #setRelationalOperator(RelationalOperator)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_RelationalOperator()
	 * @model default="lt"
	 * @generated
	 */
	RelationalOperator getRelationalOperator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getRelationalOperator <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relational Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperator
	 * @see #getRelationalOperator()
	 * @generated
	 */
	void setRelationalOperator(RelationalOperator value);

	/**
	 * Returns the value of the '<em><b>Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Limit</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Limit</em>' containment reference.
	 * @see #setLimit(Time)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_Limit()
	 * @model containment="true"
	 * @generated
	 */
	Time getLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getLimit <em>Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Limit</em>' containment reference.
	 * @see #getLimit()
	 * @generated
	 */
	void setLimit(Time value);

	/**
	 * Returns the value of the '<em><b>Prewarn Margin</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prewarn Margin</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prewarn Margin</em>' containment reference.
	 * @see #setPrewarnMargin(Time)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_PrewarnMargin()
	 * @model containment="true"
	 * @generated
	 */
	Time getPrewarnMargin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#getPrewarnMargin <em>Prewarn Margin</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prewarn Margin</em>' containment reference.
	 * @see #getPrewarnMargin()
	 * @generated
	 */
	void setPrewarnMargin(Time value);

	/**
	 * Returns the value of the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relative</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relative</em>' attribute.
	 * @see #setRelative(boolean)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getTimingRequirement_Relative()
	 * @model
	 * @generated
	 */
	boolean isRelative();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.TimingRequirement#isRelative <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relative</em>' attribute.
	 * @see #isRelative()
	 * @generated
	 */
	void setRelative(boolean value);

} // TimingRequirement
