/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceEvent;

import com.inchron.realtime.root.model.requirement.PeriodicEventRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Periodic Event Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl#getEvent <em>Event</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.PeriodicEventRequirementImpl#getPrewarnMarginCritical <em>Prewarn Margin Critical</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PeriodicEventRequirementImpl extends TimingRequirementImpl implements PeriodicEventRequirement {
	/**
	 * The cached value of the '{@link #getEvent() <em>Event</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvent()
	 * @generated
	 * @ordered
	 */
	protected TraceEvent event;

	/**
	 * The cached value of the '{@link #getPrewarnMarginCritical() <em>Prewarn Margin Critical</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMarginCritical()
	 * @generated
	 * @ordered
	 */
	protected Time prewarnMarginCritical;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PeriodicEventRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.PERIODIC_EVENT_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent getEvent() {
		if (event != null && event.eIsProxy()) {
			InternalEObject oldEvent = (InternalEObject)event;
			event = (TraceEvent)eResolveProxy(oldEvent);
			if (event != oldEvent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT, oldEvent, event));
			}
		}
		return event;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEvent basicGetEvent() {
		return event;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvent(TraceEvent newEvent) {
		TraceEvent oldEvent = event;
		event = newEvent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT, oldEvent, event));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPrewarnMarginCritical() {
		return prewarnMarginCritical;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPrewarnMarginCritical(Time newPrewarnMarginCritical, NotificationChain msgs) {
		Time oldPrewarnMarginCritical = prewarnMarginCritical;
		prewarnMarginCritical = newPrewarnMarginCritical;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL, oldPrewarnMarginCritical, newPrewarnMarginCritical);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrewarnMarginCritical(Time newPrewarnMarginCritical) {
		if (newPrewarnMarginCritical != prewarnMarginCritical) {
			NotificationChain msgs = null;
			if (prewarnMarginCritical != null)
				msgs = ((InternalEObject)prewarnMarginCritical).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL, null, msgs);
			if (newPrewarnMarginCritical != null)
				msgs = ((InternalEObject)newPrewarnMarginCritical).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL, null, msgs);
			msgs = basicSetPrewarnMarginCritical(newPrewarnMarginCritical, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL, newPrewarnMarginCritical, newPrewarnMarginCritical));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL:
				return basicSetPrewarnMarginCritical(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT:
				if (resolve) return getEvent();
				return basicGetEvent();
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL:
				return getPrewarnMarginCritical();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT:
				setEvent((TraceEvent)newValue);
				return;
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL:
				setPrewarnMarginCritical((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT:
				setEvent((TraceEvent)null);
				return;
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL:
				setPrewarnMarginCritical((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__EVENT:
				return event != null;
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT__PREWARN_MARGIN_CRITICAL:
				return prewarnMarginCritical != null;
		}
		return super.eIsSet(featureID);
	}

} //PeriodicEventRequirementImpl
