/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.requirement.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RequirementFactoryImpl extends EFactoryImpl implements RequirementFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RequirementFactory init() {
		try {
			RequirementFactory theRequirementFactory = (RequirementFactory)EPackage.Registry.INSTANCE.getEFactory(RequirementPackage.eNS_URI);
			if (theRequirementFactory != null) {
				return theRequirementFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new RequirementFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequirementFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case RequirementPackage.CALL_NESTING_REQUIREMENT: return createCallNestingRequirement();
			case RequirementPackage.EVALUATION: return createEvaluation();
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT: return createEventChainBreakOffRequirement();
			case RequirementPackage.EVENT_CHAIN_JOIN_REQUIREMENT: return createEventChainJoinRequirement();
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT: return createEventChainMultipleProcessingRequirement();
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT: return createEventChainTimingRequirement();
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT: return createEventIEventJRequirement();
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT: return createEventNetExecTimeRequirement();
			case RequirementPackage.EVENT_TIMING_REQUIREMENT: return createEventTimingRequirement();
			case RequirementPackage.GROUP_OF_REQUIREMENTS: return createGroupOfRequirements();
			case RequirementPackage.ILLEGAL_EVENT_REQUIREMENT: return createIllegalEventRequirement();
			case RequirementPackage.LOAD_REQUIREMENT: return createLoadRequirement();
			case RequirementPackage.NET_EXEC_TIME_REQUIREMENT: return createNetExecTimeRequirement();
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT: return createNetSlackTimeRequirement();
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT: return createPeriodicEventRequirement();
			case RequirementPackage.RECURSION_REQUIREMENT: return createRecursionRequirement();
			case RequirementPackage.RESPONSE_TIME_REQUIREMENT: return createResponseTimeRequirement();
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT: return createRtosFailureRequirement();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case RequirementPackage.EVENT_CHAIN_STRATEGY:
				return createEventChainStrategyFromString(eDataType, initialValue);
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT_TYPE:
				return createNetSlackTimeRequirementTypeFromString(eDataType, initialValue);
			case RequirementPackage.RELATIONAL_OPERATOR:
				return createRelationalOperatorFromString(eDataType, initialValue);
			case RequirementPackage.RELATIONAL_OPERATOR_LE_GE:
				return createRelationalOperatorLeGeFromString(eDataType, initialValue);
			case RequirementPackage.RELATIONAL_OPERATOR_LT_LE_GT_GE:
				return createRelationalOperatorLtLeGtGeFromString(eDataType, initialValue);
			case RequirementPackage.RTOS_FAILURE:
				return createRTOSFailureFromString(eDataType, initialValue);
			case RequirementPackage.VERDICT:
				return createVerdictFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case RequirementPackage.EVENT_CHAIN_STRATEGY:
				return convertEventChainStrategyToString(eDataType, instanceValue);
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT_TYPE:
				return convertNetSlackTimeRequirementTypeToString(eDataType, instanceValue);
			case RequirementPackage.RELATIONAL_OPERATOR:
				return convertRelationalOperatorToString(eDataType, instanceValue);
			case RequirementPackage.RELATIONAL_OPERATOR_LE_GE:
				return convertRelationalOperatorLeGeToString(eDataType, instanceValue);
			case RequirementPackage.RELATIONAL_OPERATOR_LT_LE_GT_GE:
				return convertRelationalOperatorLtLeGtGeToString(eDataType, instanceValue);
			case RequirementPackage.RTOS_FAILURE:
				return convertRTOSFailureToString(eDataType, instanceValue);
			case RequirementPackage.VERDICT:
				return convertVerdictToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallNestingRequirement createCallNestingRequirement() {
		CallNestingRequirementImpl callNestingRequirement = new CallNestingRequirementImpl();
		return callNestingRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Evaluation createEvaluation() {
		EvaluationImpl evaluation = new EvaluationImpl();
		return evaluation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainBreakOffRequirement createEventChainBreakOffRequirement() {
		EventChainBreakOffRequirementImpl eventChainBreakOffRequirement = new EventChainBreakOffRequirementImpl();
		return eventChainBreakOffRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainJoinRequirement createEventChainJoinRequirement() {
		EventChainJoinRequirementImpl eventChainJoinRequirement = new EventChainJoinRequirementImpl();
		return eventChainJoinRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainMultipleProcessingRequirement createEventChainMultipleProcessingRequirement() {
		EventChainMultipleProcessingRequirementImpl eventChainMultipleProcessingRequirement = new EventChainMultipleProcessingRequirementImpl();
		return eventChainMultipleProcessingRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainTimingRequirement createEventChainTimingRequirement() {
		EventChainTimingRequirementImpl eventChainTimingRequirement = new EventChainTimingRequirementImpl();
		return eventChainTimingRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventIEventJRequirement createEventIEventJRequirement() {
		EventIEventJRequirementImpl eventIEventJRequirement = new EventIEventJRequirementImpl();
		return eventIEventJRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventNetExecTimeRequirement createEventNetExecTimeRequirement() {
		EventNetExecTimeRequirementImpl eventNetExecTimeRequirement = new EventNetExecTimeRequirementImpl();
		return eventNetExecTimeRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventTimingRequirement createEventTimingRequirement() {
		EventTimingRequirementImpl eventTimingRequirement = new EventTimingRequirementImpl();
		return eventTimingRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupOfRequirements createGroupOfRequirements() {
		GroupOfRequirementsImpl groupOfRequirements = new GroupOfRequirementsImpl();
		return groupOfRequirements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IllegalEventRequirement createIllegalEventRequirement() {
		IllegalEventRequirementImpl illegalEventRequirement = new IllegalEventRequirementImpl();
		return illegalEventRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoadRequirement createLoadRequirement() {
		LoadRequirementImpl loadRequirement = new LoadRequirementImpl();
		return loadRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetExecTimeRequirement createNetExecTimeRequirement() {
		NetExecTimeRequirementImpl netExecTimeRequirement = new NetExecTimeRequirementImpl();
		return netExecTimeRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetSlackTimeRequirement createNetSlackTimeRequirement() {
		NetSlackTimeRequirementImpl netSlackTimeRequirement = new NetSlackTimeRequirementImpl();
		return netSlackTimeRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PeriodicEventRequirement createPeriodicEventRequirement() {
		PeriodicEventRequirementImpl periodicEventRequirement = new PeriodicEventRequirementImpl();
		return periodicEventRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RecursionRequirement createRecursionRequirement() {
		RecursionRequirementImpl recursionRequirement = new RecursionRequirementImpl();
		return recursionRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResponseTimeRequirement createResponseTimeRequirement() {
		ResponseTimeRequirementImpl responseTimeRequirement = new ResponseTimeRequirementImpl();
		return responseTimeRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RtosFailureRequirement createRtosFailureRequirement() {
		RtosFailureRequirementImpl rtosFailureRequirement = new RtosFailureRequirementImpl();
		return rtosFailureRequirement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChainStrategy createEventChainStrategyFromString(EDataType eDataType, String initialValue) {
		EventChainStrategy result = EventChainStrategy.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertEventChainStrategyToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetSlackTimeRequirementType createNetSlackTimeRequirementTypeFromString(EDataType eDataType, String initialValue) {
		NetSlackTimeRequirementType result = NetSlackTimeRequirementType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertNetSlackTimeRequirementTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationalOperator createRelationalOperatorFromString(EDataType eDataType, String initialValue) {
		RelationalOperator result = RelationalOperator.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRelationalOperatorToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationalOperatorLeGe createRelationalOperatorLeGeFromString(EDataType eDataType, String initialValue) {
		RelationalOperatorLeGe result = RelationalOperatorLeGe.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRelationalOperatorLeGeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationalOperatorLtLeGtGe createRelationalOperatorLtLeGtGeFromString(EDataType eDataType, String initialValue) {
		RelationalOperatorLtLeGtGe result = RelationalOperatorLtLeGtGe.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRelationalOperatorLtLeGtGeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RTOSFailure createRTOSFailureFromString(EDataType eDataType, String initialValue) {
		RTOSFailure result = RTOSFailure.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRTOSFailureToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Verdict createVerdictFromString(EDataType eDataType, String initialValue) {
		Verdict result = Verdict.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertVerdictToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequirementPackage getRequirementPackage() {
		return (RequirementPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static RequirementPackage getPackage() {
		return RequirementPackage.eINSTANCE;
	}

} //RequirementFactoryImpl
