/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.requirement.RelationalOperator;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.requirement.TimingRequirement;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getRelationalOperator <em>Relational Operator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getLimit <em>Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#getPrewarnMargin <em>Prewarn Margin</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.TimingRequirementImpl#isRelative <em>Relative</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class TimingRequirementImpl extends RequirementImpl implements TimingRequirement {
	/**
	 * The default value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
	protected static final RelationalOperator RELATIONAL_OPERATOR_EDEFAULT = RelationalOperator.LT;

	/**
	 * The cached value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
	protected RelationalOperator relationalOperator = RELATIONAL_OPERATOR_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLimit() <em>Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLimit()
	 * @generated
	 * @ordered
	 */
	protected Time limit;

	/**
	 * The cached value of the '{@link #getPrewarnMargin() <em>Prewarn Margin</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrewarnMargin()
	 * @generated
	 * @ordered
	 */
	protected Time prewarnMargin;

	/**
	 * The default value of the '{@link #isRelative() <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelative()
	 * @generated
	 * @ordered
	 */
	protected static final boolean RELATIVE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRelative() <em>Relative</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRelative()
	 * @generated
	 * @ordered
	 */
	protected boolean relative = RELATIVE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimingRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.TIMING_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationalOperator getRelationalOperator() {
		return relationalOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelationalOperator(RelationalOperator newRelationalOperator) {
		RelationalOperator oldRelationalOperator = relationalOperator;
		relationalOperator = newRelationalOperator == null ? RELATIONAL_OPERATOR_EDEFAULT : newRelationalOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__RELATIONAL_OPERATOR, oldRelationalOperator, relationalOperator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getLimit() {
		return limit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLimit(Time newLimit, NotificationChain msgs) {
		Time oldLimit = limit;
		limit = newLimit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__LIMIT, oldLimit, newLimit);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLimit(Time newLimit) {
		if (newLimit != limit) {
			NotificationChain msgs = null;
			if (limit != null)
				msgs = ((InternalEObject)limit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__LIMIT, null, msgs);
			if (newLimit != null)
				msgs = ((InternalEObject)newLimit).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__LIMIT, null, msgs);
			msgs = basicSetLimit(newLimit, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__LIMIT, newLimit, newLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPrewarnMargin() {
		return prewarnMargin;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPrewarnMargin(Time newPrewarnMargin, NotificationChain msgs) {
		Time oldPrewarnMargin = prewarnMargin;
		prewarnMargin = newPrewarnMargin;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN, oldPrewarnMargin, newPrewarnMargin);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrewarnMargin(Time newPrewarnMargin) {
		if (newPrewarnMargin != prewarnMargin) {
			NotificationChain msgs = null;
			if (prewarnMargin != null)
				msgs = ((InternalEObject)prewarnMargin).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN, null, msgs);
			if (newPrewarnMargin != null)
				msgs = ((InternalEObject)newPrewarnMargin).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN, null, msgs);
			msgs = basicSetPrewarnMargin(newPrewarnMargin, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN, newPrewarnMargin, newPrewarnMargin));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRelative() {
		return relative;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelative(boolean newRelative) {
		boolean oldRelative = relative;
		relative = newRelative;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.TIMING_REQUIREMENT__RELATIVE, oldRelative, relative));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__LIMIT:
				return basicSetLimit(null, msgs);
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN:
				return basicSetPrewarnMargin(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__RELATIONAL_OPERATOR:
				return getRelationalOperator();
			case RequirementPackage.TIMING_REQUIREMENT__LIMIT:
				return getLimit();
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN:
				return getPrewarnMargin();
			case RequirementPackage.TIMING_REQUIREMENT__RELATIVE:
				return isRelative();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__RELATIONAL_OPERATOR:
				setRelationalOperator((RelationalOperator)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__LIMIT:
				setLimit((Time)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN:
				setPrewarnMargin((Time)newValue);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__RELATIVE:
				setRelative((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__RELATIONAL_OPERATOR:
				setRelationalOperator(RELATIONAL_OPERATOR_EDEFAULT);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__LIMIT:
				setLimit((Time)null);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN:
				setPrewarnMargin((Time)null);
				return;
			case RequirementPackage.TIMING_REQUIREMENT__RELATIVE:
				setRelative(RELATIVE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.TIMING_REQUIREMENT__RELATIONAL_OPERATOR:
				return relationalOperator != RELATIONAL_OPERATOR_EDEFAULT;
			case RequirementPackage.TIMING_REQUIREMENT__LIMIT:
				return limit != null;
			case RequirementPackage.TIMING_REQUIREMENT__PREWARN_MARGIN:
				return prewarnMargin != null;
			case RequirementPackage.TIMING_REQUIREMENT__RELATIVE:
				return relative != RELATIVE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (relationalOperator: ");
		result.append(relationalOperator);
		result.append(", relative: ");
		result.append(relative);
		result.append(')');
		return result.toString();
	}

} //TimingRequirementImpl
