/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.Time;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Burst Pattern</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMaximumOccurrences <em>Maximum Occurrences</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMinimumInterArrivalTime <em>Minimum Inter Arrival Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getPatternLength <em>Pattern Length</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPattern()
 * @model
 * @generated
 */
public interface BurstPattern extends EObject {
	/**
	 * Returns the value of the '<em><b>Maximum Occurrences</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Maximum Occurrences</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Maximum Occurrences</em>' attribute.
	 * @see #setMaximumOccurrences(int)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPattern_MaximumOccurrences()
	 * @model default="1"
	 * @generated
	 */
	int getMaximumOccurrences();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMaximumOccurrences <em>Maximum Occurrences</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximum Occurrences</em>' attribute.
	 * @see #getMaximumOccurrences()
	 * @generated
	 */
	void setMaximumOccurrences(int value);

	/**
	 * Returns the value of the '<em><b>Minimum Inter Arrival Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Minimum Inter Arrival Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Minimum Inter Arrival Time</em>' containment reference.
	 * @see #setMinimumInterArrivalTime(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPattern_MinimumInterArrivalTime()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getMinimumInterArrivalTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMinimumInterArrivalTime <em>Minimum Inter Arrival Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Minimum Inter Arrival Time</em>' containment reference.
	 * @see #getMinimumInterArrivalTime()
	 * @generated
	 */
	void setMinimumInterArrivalTime(Time value);

	/**
	 * Returns the value of the '<em><b>Pattern Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pattern Length</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pattern Length</em>' containment reference.
	 * @see #setPatternLength(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getBurstPattern_PatternLength()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getPatternLength();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getPatternLength <em>Pattern Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pattern Length</em>' containment reference.
	 * @see #getPatternLength()
	 * @generated
	 */
	void setPatternLength(Time value);

} // BurstPattern
