/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.stimulation.StimulationFactory
 * @model kind="package"
 * @generated
 */
public interface StimulationPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "stimulation";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/model/stimulation";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "stimulation";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	StimulationPackage eINSTANCE = com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl <em>Burst Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getBurstPattern()
	 * @generated
	 */
	int BURST_PATTERN = 0;

	/**
	 * The feature id for the '<em><b>Maximum Occurrences</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN__MAXIMUM_OCCURRENCES = 0;

	/**
	 * The feature id for the '<em><b>Minimum Inter Arrival Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME = 1;

	/**
	 * The feature id for the '<em><b>Pattern Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN__PATTERN_LENGTH = 2;

	/**
	 * The number of structural features of the '<em>Burst Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Burst Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimuliGeneratorImpl <em>Stimuli Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimuliGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimuliGenerator()
	 * @generated
	 */
	int STIMULI_GENERATOR = 13;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__CLOCK = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__CONNECTIONS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__FILTERS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR__TARGETS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Stimuli Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Stimuli Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULI_GENERATOR_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl <em>Burst Pattern Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getBurstPatternGenerator()
	 * @generated
	 */
	int BURST_PATTERN_GENERATOR = 1;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__INTRINSIC_ID = STIMULI_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__NAME = STIMULI_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__CLOCK = STIMULI_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__CONNECTIONS = STIMULI_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__FILTERS = STIMULI_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__TARGETS = STIMULI_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Burst Pattern Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS = STIMULI_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Iterations</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__ITERATIONS = STIMULI_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__PERIOD = STIMULI_GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__RELATIVE = STIMULI_GENERATOR_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__START_OFFSET = STIMULI_GENERATOR_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Start Offset Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION = STIMULI_GENERATOR_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR__VARIATION = STIMULI_GENERATOR_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Burst Pattern Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR_FEATURE_COUNT = STIMULI_GENERATOR_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Burst Pattern Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BURST_PATTERN_GENERATOR_OPERATION_COUNT = STIMULI_GENERATOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.CSVBasedGeneratorImpl <em>CSV Based Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.CSVBasedGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getCSVBasedGenerator()
	 * @generated
	 */
	int CSV_BASED_GENERATOR = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__INTRINSIC_ID = STIMULI_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__NAME = STIMULI_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__CLOCK = STIMULI_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__CONNECTIONS = STIMULI_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__FILTERS = STIMULI_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__TARGETS = STIMULI_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Filename</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR__FILENAME = STIMULI_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>CSV Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR_FEATURE_COUNT = STIMULI_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>CSV Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CSV_BASED_GENERATOR_OPERATION_COUNT = STIMULI_GENERATOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl <em>Scenario</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimulationScenario()
	 * @generated
	 */
	int STIMULATION_SCENARIO = 12;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Burst Pattern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO__BURST_PATTERN = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generators</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO__GENERATORS = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_SCENARIO_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.CompositeScenarioImpl <em>Composite Scenario</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.CompositeScenarioImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getCompositeScenario()
	 * @generated
	 */
	int COMPOSITE_SCENARIO = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO__INTRINSIC_ID = STIMULATION_SCENARIO__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO__NAME = STIMULATION_SCENARIO__NAME;

	/**
	 * The feature id for the '<em><b>Burst Pattern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO__BURST_PATTERN = STIMULATION_SCENARIO__BURST_PATTERN;

	/**
	 * The feature id for the '<em><b>Generators</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO__GENERATORS = STIMULATION_SCENARIO__GENERATORS;

	/**
	 * The feature id for the '<em><b>Scenarios</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO__SCENARIOS = STIMULATION_SCENARIO_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Composite Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO_FEATURE_COUNT = STIMULATION_SCENARIO_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Composite Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_SCENARIO_OPERATION_COUNT = STIMULATION_SCENARIO_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimulationFilterImpl <em>Filter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationFilterImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimulationFilter()
	 * @generated
	 */
	int STIMULATION_FILTER = 11;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_FILTER__INTRINSIC_ID = ModelPackage.MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_FILTER__NAME = ModelPackage.MODEL_OBJECT__NAME;

	/**
	 * The number of structural features of the '<em>Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_FILTER_FEATURE_COUNT = ModelPackage.MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STIMULATION_FILTER_OPERATION_COUNT = ModelPackage.MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl <em>Disturbance Filter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getDisturbanceFilter()
	 * @generated
	 */
	int DISTURBANCE_FILTER = 4;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER__INTRINSIC_ID = STIMULATION_FILTER__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER__NAME = STIMULATION_FILTER__NAME;

	/**
	 * The feature id for the '<em><b>Disturbance Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY = STIMULATION_FILTER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Disturbance Sigma</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER__DISTURBANCE_SIGMA = STIMULATION_FILTER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Loss Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER__LOSS_PROBABILITY = STIMULATION_FILTER_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Disturbance Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER_FEATURE_COUNT = STIMULATION_FILTER_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Disturbance Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTURBANCE_FILTER_OPERATION_COUNT = STIMULATION_FILTER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl <em>Drift Filter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getDriftFilter()
	 * @generated
	 */
	int DRIFT_FILTER = 5;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__INTRINSIC_ID = STIMULATION_FILTER__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__NAME = STIMULATION_FILTER__NAME;

	/**
	 * The feature id for the '<em><b>Maximum</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__MAXIMUM = STIMULATION_FILTER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Periodic</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__PERIODIC = STIMULATION_FILTER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Repeat</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__REPEAT = STIMULATION_FILTER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Start Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__START_TIME = STIMULATION_FILTER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Time Frame</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER__TIME_FRAME = STIMULATION_FILTER_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Drift Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER_FEATURE_COUNT = STIMULATION_FILTER_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Drift Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIFT_FILTER_OPERATION_COUNT = STIMULATION_FILTER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl <em>Elimination Filter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getEliminationFilter()
	 * @generated
	 */
	int ELIMINATION_FILTER = 6;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER__INTRINSIC_ID = STIMULATION_FILTER__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER__NAME = STIMULATION_FILTER__NAME;

	/**
	 * The feature id for the '<em><b>Source Generator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER__SOURCE_GENERATOR = STIMULATION_FILTER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Time Frame</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER__TIME_FRAME = STIMULATION_FILTER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Elimination Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER_FEATURE_COUNT = STIMULATION_FILTER_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Elimination Filter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELIMINATION_FILTER_OPERATION_COUNT = STIMULATION_FILTER_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.InducedGeneratorImpl <em>Induced Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.InducedGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getInducedGenerator()
	 * @generated
	 */
	int INDUCED_GENERATOR = 7;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__INTRINSIC_ID = STIMULI_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__NAME = STIMULI_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__CLOCK = STIMULI_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__CONNECTIONS = STIMULI_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__FILTERS = STIMULI_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__TARGETS = STIMULI_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__DELAY = STIMULI_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__OFFSET = STIMULI_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR__PERIOD = STIMULI_GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Induced Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR_FEATURE_COUNT = STIMULI_GENERATOR_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Induced Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_GENERATOR_OPERATION_COUNT = STIMULI_GENERATOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl <em>List Based Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getListBasedGenerator()
	 * @generated
	 */
	int LIST_BASED_GENERATOR = 9;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__INTRINSIC_ID = STIMULI_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__NAME = STIMULI_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__CLOCK = STIMULI_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__CONNECTIONS = STIMULI_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__FILTERS = STIMULI_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__TARGETS = STIMULI_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Entry</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__ENTRY = STIMULI_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Source Generator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR__SOURCE_GENERATOR = STIMULI_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>List Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR_FEATURE_COUNT = STIMULI_GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>List Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_BASED_GENERATOR_OPERATION_COUNT = STIMULI_GENERATOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.InducedListBasedGeneratorImpl <em>Induced List Based Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.InducedListBasedGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getInducedListBasedGenerator()
	 * @generated
	 */
	int INDUCED_LIST_BASED_GENERATOR = 8;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__INTRINSIC_ID = LIST_BASED_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__NAME = LIST_BASED_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__CLOCK = LIST_BASED_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__CONNECTIONS = LIST_BASED_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__FILTERS = LIST_BASED_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__TARGETS = LIST_BASED_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Entry</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__ENTRY = LIST_BASED_GENERATOR__ENTRY;

	/**
	 * The feature id for the '<em><b>Source Generator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__SOURCE_GENERATOR = LIST_BASED_GENERATOR__SOURCE_GENERATOR;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__OFFSET = LIST_BASED_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR__PERIOD = LIST_BASED_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Induced List Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR_FEATURE_COUNT = LIST_BASED_GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Induced List Based Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDUCED_LIST_BASED_GENERATOR_OPERATION_COUNT = LIST_BASED_GENERATOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.stimulation.impl.RandomStimuliGeneratorImpl <em>Random Stimuli Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.stimulation.impl.RandomStimuliGeneratorImpl
	 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getRandomStimuliGenerator()
	 * @generated
	 */
	int RANDOM_STIMULI_GENERATOR = 10;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__INTRINSIC_ID = STIMULI_GENERATOR__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__NAME = STIMULI_GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__CLOCK = STIMULI_GENERATOR__CLOCK;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__CONNECTIONS = STIMULI_GENERATOR__CONNECTIONS;

	/**
	 * The feature id for the '<em><b>Filters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__FILTERS = STIMULI_GENERATOR__FILTERS;

	/**
	 * The feature id for the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__TARGETS = STIMULI_GENERATOR__TARGETS;

	/**
	 * The feature id for the '<em><b>Iterations</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__ITERATIONS = STIMULI_GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Min Inter Arrival Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__MIN_INTER_ARRIVAL_TIME = STIMULI_GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__PERIOD = STIMULI_GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Relative</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__RELATIVE = STIMULI_GENERATOR_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Start Offset</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__START_OFFSET = STIMULI_GENERATOR_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Start Offset Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__START_OFFSET_VARIATION = STIMULI_GENERATOR_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Variation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR__VARIATION = STIMULI_GENERATOR_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Random Stimuli Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR_FEATURE_COUNT = STIMULI_GENERATOR_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Random Stimuli Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_STIMULI_GENERATOR_OPERATION_COUNT = STIMULI_GENERATOR_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.BurstPattern <em>Burst Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Burst Pattern</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPattern
	 * @generated
	 */
	EClass getBurstPattern();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMaximumOccurrences <em>Maximum Occurrences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Maximum Occurrences</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPattern#getMaximumOccurrences()
	 * @see #getBurstPattern()
	 * @generated
	 */
	EAttribute getBurstPattern_MaximumOccurrences();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getMinimumInterArrivalTime <em>Minimum Inter Arrival Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Minimum Inter Arrival Time</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPattern#getMinimumInterArrivalTime()
	 * @see #getBurstPattern()
	 * @generated
	 */
	EReference getBurstPattern_MinimumInterArrivalTime();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPattern#getPatternLength <em>Pattern Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pattern Length</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPattern#getPatternLength()
	 * @see #getBurstPattern()
	 * @generated
	 */
	EReference getBurstPattern_PatternLength();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator <em>Burst Pattern Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Burst Pattern Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator
	 * @generated
	 */
	EClass getBurstPatternGenerator();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getBurstPatternSettings <em>Burst Pattern Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Burst Pattern Settings</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getBurstPatternSettings()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EReference getBurstPatternGenerator_BurstPatternSettings();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getIterations <em>Iterations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Iterations</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getIterations()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EAttribute getBurstPatternGenerator_Iterations();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getPeriod()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EReference getBurstPatternGenerator_Period();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#isRelative <em>Relative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relative</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#isRelative()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EAttribute getBurstPatternGenerator_Relative();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffset <em>Start Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Offset</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffset()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EReference getBurstPatternGenerator_StartOffset();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffsetVariation <em>Start Offset Variation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Offset Variation</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getStartOffsetVariation()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EReference getBurstPatternGenerator_StartOffsetVariation();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getVariation <em>Variation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variation</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.BurstPatternGenerator#getVariation()
	 * @see #getBurstPatternGenerator()
	 * @generated
	 */
	EReference getBurstPatternGenerator_Variation();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.CSVBasedGenerator <em>CSV Based Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CSV Based Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.CSVBasedGenerator
	 * @generated
	 */
	EClass getCSVBasedGenerator();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.CSVBasedGenerator#getFilename <em>Filename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Filename</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.CSVBasedGenerator#getFilename()
	 * @see #getCSVBasedGenerator()
	 * @generated
	 */
	EAttribute getCSVBasedGenerator_Filename();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.CompositeScenario <em>Composite Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Scenario</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.CompositeScenario
	 * @generated
	 */
	EClass getCompositeScenario();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.stimulation.CompositeScenario#getScenarios <em>Scenarios</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Scenarios</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.CompositeScenario#getScenarios()
	 * @see #getCompositeScenario()
	 * @generated
	 */
	EReference getCompositeScenario_Scenarios();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter <em>Disturbance Filter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Disturbance Filter</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DisturbanceFilter
	 * @generated
	 */
	EClass getDisturbanceFilter();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceProbability <em>Disturbance Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Disturbance Probability</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceProbability()
	 * @see #getDisturbanceFilter()
	 * @generated
	 */
	EAttribute getDisturbanceFilter_DisturbanceProbability();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceSigma <em>Disturbance Sigma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Disturbance Sigma</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceSigma()
	 * @see #getDisturbanceFilter()
	 * @generated
	 */
	EReference getDisturbanceFilter_DisturbanceSigma();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getLossProbability <em>Loss Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Loss Probability</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getLossProbability()
	 * @see #getDisturbanceFilter()
	 * @generated
	 */
	EAttribute getDisturbanceFilter_LossProbability();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.DriftFilter <em>Drift Filter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Drift Filter</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter
	 * @generated
	 */
	EClass getDriftFilter();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getMaximum <em>Maximum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Maximum</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter#getMaximum()
	 * @see #getDriftFilter()
	 * @generated
	 */
	EReference getDriftFilter_Maximum();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#isPeriodic <em>Periodic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Periodic</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter#isPeriodic()
	 * @see #getDriftFilter()
	 * @generated
	 */
	EAttribute getDriftFilter_Periodic();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getRepeat <em>Repeat</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Repeat</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter#getRepeat()
	 * @see #getDriftFilter()
	 * @generated
	 */
	EReference getDriftFilter_Repeat();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getStartTime <em>Start Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Time</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter#getStartTime()
	 * @see #getDriftFilter()
	 * @generated
	 */
	EReference getDriftFilter_StartTime();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getTimeFrame <em>Time Frame</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Frame</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.DriftFilter#getTimeFrame()
	 * @see #getDriftFilter()
	 * @generated
	 */
	EReference getDriftFilter_TimeFrame();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.EliminationFilter <em>Elimination Filter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Elimination Filter</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.EliminationFilter
	 * @generated
	 */
	EClass getEliminationFilter();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getSourceGenerator <em>Source Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.EliminationFilter#getSourceGenerator()
	 * @see #getEliminationFilter()
	 * @generated
	 */
	EReference getEliminationFilter_SourceGenerator();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getTimeFrame <em>Time Frame</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Frame</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.EliminationFilter#getTimeFrame()
	 * @see #getEliminationFilter()
	 * @generated
	 */
	EReference getEliminationFilter_TimeFrame();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.InducedGenerator <em>Induced Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Induced Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedGenerator
	 * @generated
	 */
	EClass getInducedGenerator();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.InducedGenerator#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedGenerator#getDelay()
	 * @see #getInducedGenerator()
	 * @generated
	 */
	EReference getInducedGenerator_Delay();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.InducedGenerator#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedGenerator#getOffset()
	 * @see #getInducedGenerator()
	 * @generated
	 */
	EAttribute getInducedGenerator_Offset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.InducedGenerator#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedGenerator#getPeriod()
	 * @see #getInducedGenerator()
	 * @generated
	 */
	EAttribute getInducedGenerator_Period();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator <em>Induced List Based Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Induced List Based Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator
	 * @generated
	 */
	EClass getInducedListBasedGenerator();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator#getOffset()
	 * @see #getInducedListBasedGenerator()
	 * @generated
	 */
	EAttribute getInducedListBasedGenerator_Offset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.InducedListBasedGenerator#getPeriod()
	 * @see #getInducedListBasedGenerator()
	 * @generated
	 */
	EAttribute getInducedListBasedGenerator_Period();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator <em>List Based Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Based Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.ListBasedGenerator
	 * @generated
	 */
	EClass getListBasedGenerator();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getEntry <em>Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entry</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getEntry()
	 * @see #getListBasedGenerator()
	 * @generated
	 */
	EReference getListBasedGenerator_Entry();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getSourceGenerator <em>Source Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.ListBasedGenerator#getSourceGenerator()
	 * @see #getListBasedGenerator()
	 * @generated
	 */
	EReference getListBasedGenerator_SourceGenerator();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator <em>Random Stimuli Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Random Stimuli Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator
	 * @generated
	 */
	EClass getRandomStimuliGenerator();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getIterations <em>Iterations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Iterations</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getIterations()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EAttribute getRandomStimuliGenerator_Iterations();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getMinInterArrivalTime <em>Min Inter Arrival Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Min Inter Arrival Time</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getMinInterArrivalTime()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EReference getRandomStimuliGenerator_MinInterArrivalTime();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getPeriod()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EReference getRandomStimuliGenerator_Period();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#isRelative <em>Relative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relative</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#isRelative()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EAttribute getRandomStimuliGenerator_Relative();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getStartOffset <em>Start Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Offset</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getStartOffset()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EReference getRandomStimuliGenerator_StartOffset();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getStartOffsetVariation <em>Start Offset Variation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Offset Variation</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getStartOffsetVariation()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EReference getRandomStimuliGenerator_StartOffsetVariation();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getVariation <em>Variation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variation</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.RandomStimuliGenerator#getVariation()
	 * @see #getRandomStimuliGenerator()
	 * @generated
	 */
	EReference getRandomStimuliGenerator_Variation();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.StimulationFilter <em>Filter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Filter</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationFilter
	 * @generated
	 */
	EClass getStimulationFilter();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.StimulationScenario <em>Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scenario</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationScenario
	 * @generated
	 */
	EClass getStimulationScenario();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.StimulationScenario#getBurstPattern <em>Burst Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Burst Pattern</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationScenario#getBurstPattern()
	 * @see #getStimulationScenario()
	 * @generated
	 */
	EReference getStimulationScenario_BurstPattern();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.stimulation.StimulationScenario#getGenerators <em>Generators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Generators</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationScenario#getGenerators()
	 * @see #getStimulationScenario()
	 * @generated
	 */
	EReference getStimulationScenario_Generators();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator <em>Stimuli Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stimuli Generator</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimuliGenerator
	 * @generated
	 */
	EClass getStimuliGenerator();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getConnections <em>Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connections</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimuliGenerator#getConnections()
	 * @see #getStimuliGenerator()
	 * @generated
	 */
	EReference getStimuliGenerator_Connections();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getFilters <em>Filters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Filters</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimuliGenerator#getFilters()
	 * @see #getStimuliGenerator()
	 * @generated
	 */
	EReference getStimuliGenerator_Filters();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getTargets <em>Targets</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Targets</em>'.
	 * @see com.inchron.realtime.root.model.stimulation.StimuliGenerator#getTargets()
	 * @see #getStimuliGenerator()
	 * @generated
	 */
	EReference getStimuliGenerator_Targets();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	StimulationFactory getStimulationFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl <em>Burst Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getBurstPattern()
		 * @generated
		 */
		EClass BURST_PATTERN = eINSTANCE.getBurstPattern();

		/**
		 * The meta object literal for the '<em><b>Maximum Occurrences</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BURST_PATTERN__MAXIMUM_OCCURRENCES = eINSTANCE.getBurstPattern_MaximumOccurrences();

		/**
		 * The meta object literal for the '<em><b>Minimum Inter Arrival Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME = eINSTANCE.getBurstPattern_MinimumInterArrivalTime();

		/**
		 * The meta object literal for the '<em><b>Pattern Length</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN__PATTERN_LENGTH = eINSTANCE.getBurstPattern_PatternLength();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl <em>Burst Pattern Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.BurstPatternGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getBurstPatternGenerator()
		 * @generated
		 */
		EClass BURST_PATTERN_GENERATOR = eINSTANCE.getBurstPatternGenerator();

		/**
		 * The meta object literal for the '<em><b>Burst Pattern Settings</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN_GENERATOR__BURST_PATTERN_SETTINGS = eINSTANCE.getBurstPatternGenerator_BurstPatternSettings();

		/**
		 * The meta object literal for the '<em><b>Iterations</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BURST_PATTERN_GENERATOR__ITERATIONS = eINSTANCE.getBurstPatternGenerator_Iterations();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN_GENERATOR__PERIOD = eINSTANCE.getBurstPatternGenerator_Period();

		/**
		 * The meta object literal for the '<em><b>Relative</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BURST_PATTERN_GENERATOR__RELATIVE = eINSTANCE.getBurstPatternGenerator_Relative();

		/**
		 * The meta object literal for the '<em><b>Start Offset</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN_GENERATOR__START_OFFSET = eINSTANCE.getBurstPatternGenerator_StartOffset();

		/**
		 * The meta object literal for the '<em><b>Start Offset Variation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN_GENERATOR__START_OFFSET_VARIATION = eINSTANCE.getBurstPatternGenerator_StartOffsetVariation();

		/**
		 * The meta object literal for the '<em><b>Variation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BURST_PATTERN_GENERATOR__VARIATION = eINSTANCE.getBurstPatternGenerator_Variation();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.CSVBasedGeneratorImpl <em>CSV Based Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.CSVBasedGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getCSVBasedGenerator()
		 * @generated
		 */
		EClass CSV_BASED_GENERATOR = eINSTANCE.getCSVBasedGenerator();

		/**
		 * The meta object literal for the '<em><b>Filename</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CSV_BASED_GENERATOR__FILENAME = eINSTANCE.getCSVBasedGenerator_Filename();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.CompositeScenarioImpl <em>Composite Scenario</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.CompositeScenarioImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getCompositeScenario()
		 * @generated
		 */
		EClass COMPOSITE_SCENARIO = eINSTANCE.getCompositeScenario();

		/**
		 * The meta object literal for the '<em><b>Scenarios</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_SCENARIO__SCENARIOS = eINSTANCE.getCompositeScenario_Scenarios();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl <em>Disturbance Filter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.DisturbanceFilterImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getDisturbanceFilter()
		 * @generated
		 */
		EClass DISTURBANCE_FILTER = eINSTANCE.getDisturbanceFilter();

		/**
		 * The meta object literal for the '<em><b>Disturbance Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DISTURBANCE_FILTER__DISTURBANCE_PROBABILITY = eINSTANCE.getDisturbanceFilter_DisturbanceProbability();

		/**
		 * The meta object literal for the '<em><b>Disturbance Sigma</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DISTURBANCE_FILTER__DISTURBANCE_SIGMA = eINSTANCE.getDisturbanceFilter_DisturbanceSigma();

		/**
		 * The meta object literal for the '<em><b>Loss Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DISTURBANCE_FILTER__LOSS_PROBABILITY = eINSTANCE.getDisturbanceFilter_LossProbability();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl <em>Drift Filter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getDriftFilter()
		 * @generated
		 */
		EClass DRIFT_FILTER = eINSTANCE.getDriftFilter();

		/**
		 * The meta object literal for the '<em><b>Maximum</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DRIFT_FILTER__MAXIMUM = eINSTANCE.getDriftFilter_Maximum();

		/**
		 * The meta object literal for the '<em><b>Periodic</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DRIFT_FILTER__PERIODIC = eINSTANCE.getDriftFilter_Periodic();

		/**
		 * The meta object literal for the '<em><b>Repeat</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DRIFT_FILTER__REPEAT = eINSTANCE.getDriftFilter_Repeat();

		/**
		 * The meta object literal for the '<em><b>Start Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DRIFT_FILTER__START_TIME = eINSTANCE.getDriftFilter_StartTime();

		/**
		 * The meta object literal for the '<em><b>Time Frame</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DRIFT_FILTER__TIME_FRAME = eINSTANCE.getDriftFilter_TimeFrame();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl <em>Elimination Filter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getEliminationFilter()
		 * @generated
		 */
		EClass ELIMINATION_FILTER = eINSTANCE.getEliminationFilter();

		/**
		 * The meta object literal for the '<em><b>Source Generator</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ELIMINATION_FILTER__SOURCE_GENERATOR = eINSTANCE.getEliminationFilter_SourceGenerator();

		/**
		 * The meta object literal for the '<em><b>Time Frame</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ELIMINATION_FILTER__TIME_FRAME = eINSTANCE.getEliminationFilter_TimeFrame();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.InducedGeneratorImpl <em>Induced Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.InducedGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getInducedGenerator()
		 * @generated
		 */
		EClass INDUCED_GENERATOR = eINSTANCE.getInducedGenerator();

		/**
		 * The meta object literal for the '<em><b>Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INDUCED_GENERATOR__DELAY = eINSTANCE.getInducedGenerator_Delay();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INDUCED_GENERATOR__OFFSET = eINSTANCE.getInducedGenerator_Offset();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INDUCED_GENERATOR__PERIOD = eINSTANCE.getInducedGenerator_Period();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.InducedListBasedGeneratorImpl <em>Induced List Based Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.InducedListBasedGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getInducedListBasedGenerator()
		 * @generated
		 */
		EClass INDUCED_LIST_BASED_GENERATOR = eINSTANCE.getInducedListBasedGenerator();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INDUCED_LIST_BASED_GENERATOR__OFFSET = eINSTANCE.getInducedListBasedGenerator_Offset();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INDUCED_LIST_BASED_GENERATOR__PERIOD = eINSTANCE.getInducedListBasedGenerator_Period();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl <em>List Based Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getListBasedGenerator()
		 * @generated
		 */
		EClass LIST_BASED_GENERATOR = eINSTANCE.getListBasedGenerator();

		/**
		 * The meta object literal for the '<em><b>Entry</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LIST_BASED_GENERATOR__ENTRY = eINSTANCE.getListBasedGenerator_Entry();

		/**
		 * The meta object literal for the '<em><b>Source Generator</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LIST_BASED_GENERATOR__SOURCE_GENERATOR = eINSTANCE.getListBasedGenerator_SourceGenerator();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.RandomStimuliGeneratorImpl <em>Random Stimuli Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.RandomStimuliGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getRandomStimuliGenerator()
		 * @generated
		 */
		EClass RANDOM_STIMULI_GENERATOR = eINSTANCE.getRandomStimuliGenerator();

		/**
		 * The meta object literal for the '<em><b>Iterations</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RANDOM_STIMULI_GENERATOR__ITERATIONS = eINSTANCE.getRandomStimuliGenerator_Iterations();

		/**
		 * The meta object literal for the '<em><b>Min Inter Arrival Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_STIMULI_GENERATOR__MIN_INTER_ARRIVAL_TIME = eINSTANCE.getRandomStimuliGenerator_MinInterArrivalTime();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_STIMULI_GENERATOR__PERIOD = eINSTANCE.getRandomStimuliGenerator_Period();

		/**
		 * The meta object literal for the '<em><b>Relative</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RANDOM_STIMULI_GENERATOR__RELATIVE = eINSTANCE.getRandomStimuliGenerator_Relative();

		/**
		 * The meta object literal for the '<em><b>Start Offset</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_STIMULI_GENERATOR__START_OFFSET = eINSTANCE.getRandomStimuliGenerator_StartOffset();

		/**
		 * The meta object literal for the '<em><b>Start Offset Variation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_STIMULI_GENERATOR__START_OFFSET_VARIATION = eINSTANCE.getRandomStimuliGenerator_StartOffsetVariation();

		/**
		 * The meta object literal for the '<em><b>Variation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_STIMULI_GENERATOR__VARIATION = eINSTANCE.getRandomStimuliGenerator_Variation();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimulationFilterImpl <em>Filter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationFilterImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimulationFilter()
		 * @generated
		 */
		EClass STIMULATION_FILTER = eINSTANCE.getStimulationFilter();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl <em>Scenario</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimulationScenario()
		 * @generated
		 */
		EClass STIMULATION_SCENARIO = eINSTANCE.getStimulationScenario();

		/**
		 * The meta object literal for the '<em><b>Burst Pattern</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STIMULATION_SCENARIO__BURST_PATTERN = eINSTANCE.getStimulationScenario_BurstPattern();

		/**
		 * The meta object literal for the '<em><b>Generators</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STIMULATION_SCENARIO__GENERATORS = eINSTANCE.getStimulationScenario_Generators();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.stimulation.impl.StimuliGeneratorImpl <em>Stimuli Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimuliGeneratorImpl
		 * @see com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl#getStimuliGenerator()
		 * @generated
		 */
		EClass STIMULI_GENERATOR = eINSTANCE.getStimuliGenerator();

		/**
		 * The meta object literal for the '<em><b>Connections</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STIMULI_GENERATOR__CONNECTIONS = eINSTANCE.getStimuliGenerator_Connections();

		/**
		 * The meta object literal for the '<em><b>Filters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STIMULI_GENERATOR__FILTERS = eINSTANCE.getStimuliGenerator_Filters();

		/**
		 * The meta object literal for the '<em><b>Targets</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STIMULI_GENERATOR__TARGETS = eINSTANCE.getStimuliGenerator_Targets();

	}

} //StimulationPackage
