/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scenario</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.StimulationScenario#getBurstPattern <em>Burst Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.StimulationScenario#getGenerators <em>Generators</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimulationScenario()
 * @model
 * @generated
 */
public interface StimulationScenario extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Burst Pattern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Burst Pattern</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Burst Pattern</em>' containment reference.
	 * @see #setBurstPattern(BurstPattern)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimulationScenario_BurstPattern()
	 * @model containment="true"
	 * @generated
	 */
	BurstPattern getBurstPattern();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.StimulationScenario#getBurstPattern <em>Burst Pattern</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Burst Pattern</em>' containment reference.
	 * @see #getBurstPattern()
	 * @generated
	 */
	void setBurstPattern(BurstPattern value);

	/**
	 * Returns the value of the '<em><b>Generators</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.stimulation.StimuliGenerator}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Generators</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Generators</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimulationScenario_Generators()
	 * @model containment="true"
	 * @generated
	 */
	EList<StimuliGenerator> getGenerators();

} // StimulationScenario
