/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.stimulation.BurstPattern;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Burst Pattern</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl#getMaximumOccurrences <em>Maximum Occurrences</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl#getMinimumInterArrivalTime <em>Minimum Inter Arrival Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.BurstPatternImpl#getPatternLength <em>Pattern Length</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BurstPatternImpl extends MinimalEObjectImpl.Container implements BurstPattern {
	/**
	 * The default value of the '{@link #getMaximumOccurrences() <em>Maximum Occurrences</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximumOccurrences()
	 * @generated
	 * @ordered
	 */
	protected static final int MAXIMUM_OCCURRENCES_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getMaximumOccurrences() <em>Maximum Occurrences</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximumOccurrences()
	 * @generated
	 * @ordered
	 */
	protected int maximumOccurrences = MAXIMUM_OCCURRENCES_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMinimumInterArrivalTime() <em>Minimum Inter Arrival Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimumInterArrivalTime()
	 * @generated
	 * @ordered
	 */
	protected Time minimumInterArrivalTime;

	/**
	 * The cached value of the '{@link #getPatternLength() <em>Pattern Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPatternLength()
	 * @generated
	 * @ordered
	 */
	protected Time patternLength;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BurstPatternImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.BURST_PATTERN;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMaximumOccurrences() {
		return maximumOccurrences;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaximumOccurrences(int newMaximumOccurrences) {
		int oldMaximumOccurrences = maximumOccurrences;
		maximumOccurrences = newMaximumOccurrences;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN__MAXIMUM_OCCURRENCES, oldMaximumOccurrences, maximumOccurrences));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMinimumInterArrivalTime() {
		return minimumInterArrivalTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMinimumInterArrivalTime(Time newMinimumInterArrivalTime, NotificationChain msgs) {
		Time oldMinimumInterArrivalTime = minimumInterArrivalTime;
		minimumInterArrivalTime = newMinimumInterArrivalTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME, oldMinimumInterArrivalTime, newMinimumInterArrivalTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinimumInterArrivalTime(Time newMinimumInterArrivalTime) {
		if (newMinimumInterArrivalTime != minimumInterArrivalTime) {
			NotificationChain msgs = null;
			if (minimumInterArrivalTime != null)
				msgs = ((InternalEObject)minimumInterArrivalTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME, null, msgs);
			if (newMinimumInterArrivalTime != null)
				msgs = ((InternalEObject)newMinimumInterArrivalTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME, null, msgs);
			msgs = basicSetMinimumInterArrivalTime(newMinimumInterArrivalTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME, newMinimumInterArrivalTime, newMinimumInterArrivalTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPatternLength() {
		return patternLength;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPatternLength(Time newPatternLength, NotificationChain msgs) {
		Time oldPatternLength = patternLength;
		patternLength = newPatternLength;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN__PATTERN_LENGTH, oldPatternLength, newPatternLength);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPatternLength(Time newPatternLength) {
		if (newPatternLength != patternLength) {
			NotificationChain msgs = null;
			if (patternLength != null)
				msgs = ((InternalEObject)patternLength).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN__PATTERN_LENGTH, null, msgs);
			if (newPatternLength != null)
				msgs = ((InternalEObject)newPatternLength).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.BURST_PATTERN__PATTERN_LENGTH, null, msgs);
			msgs = basicSetPatternLength(newPatternLength, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.BURST_PATTERN__PATTERN_LENGTH, newPatternLength, newPatternLength));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME:
				return basicSetMinimumInterArrivalTime(null, msgs);
			case StimulationPackage.BURST_PATTERN__PATTERN_LENGTH:
				return basicSetPatternLength(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN__MAXIMUM_OCCURRENCES:
				return getMaximumOccurrences();
			case StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME:
				return getMinimumInterArrivalTime();
			case StimulationPackage.BURST_PATTERN__PATTERN_LENGTH:
				return getPatternLength();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN__MAXIMUM_OCCURRENCES:
				setMaximumOccurrences((Integer)newValue);
				return;
			case StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME:
				setMinimumInterArrivalTime((Time)newValue);
				return;
			case StimulationPackage.BURST_PATTERN__PATTERN_LENGTH:
				setPatternLength((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN__MAXIMUM_OCCURRENCES:
				setMaximumOccurrences(MAXIMUM_OCCURRENCES_EDEFAULT);
				return;
			case StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME:
				setMinimumInterArrivalTime((Time)null);
				return;
			case StimulationPackage.BURST_PATTERN__PATTERN_LENGTH:
				setPatternLength((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.BURST_PATTERN__MAXIMUM_OCCURRENCES:
				return maximumOccurrences != MAXIMUM_OCCURRENCES_EDEFAULT;
			case StimulationPackage.BURST_PATTERN__MINIMUM_INTER_ARRIVAL_TIME:
				return minimumInterArrivalTime != null;
			case StimulationPackage.BURST_PATTERN__PATTERN_LENGTH:
				return patternLength != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (maximumOccurrences: ");
		result.append(maximumOccurrences);
		result.append(')');
		return result.toString();
	}

} //BurstPatternImpl
