/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.RootPackage;

import com.inchron.realtime.root.impl.RootPackageImpl;

import com.inchron.realtime.root.model.ModelPackage;

import com.inchron.realtime.root.model.autosar.AutosarPackage;

import com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl;

import com.inchron.realtime.root.model.fmi.FmiPackage;

import com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl;

import com.inchron.realtime.root.model.fmi.type.TypePackage;

import com.inchron.realtime.root.model.fmi.type.impl.TypePackageImpl;

import com.inchron.realtime.root.model.fmi.unit.UnitPackage;

import com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl;

import com.inchron.realtime.root.model.fmi.variable.VariablePackage;

import com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl;

import com.inchron.realtime.root.model.impl.ModelPackageImpl;

import com.inchron.realtime.root.model.memory.MemoryPackage;

import com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl;

import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl;

import com.inchron.realtime.root.model.requirement.RequirementPackage;

import com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl;

import com.inchron.realtime.root.model.stimulation.StimulationFactory;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import com.inchron.realtime.root.settings.SettingsPackage;

import com.inchron.realtime.root.settings.impl.SettingsPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class StimulationPackageImpl extends EPackageImpl implements StimulationPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass burstPatternEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass burstPatternGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass csvBasedGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass compositeScenarioEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass disturbanceFilterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass driftFilterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eliminationFilterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inducedGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass inducedListBasedGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass listBasedGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass randomStimuliGeneratorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stimulationFilterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stimulationScenarioEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stimuliGeneratorEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private StimulationPackageImpl() {
		super(eNS_URI, StimulationFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link StimulationPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @generated
	 */
	public static StimulationPackage init() {
		if (isInited) return (StimulationPackage)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI);

		// Obtain or create and register package
		StimulationPackageImpl theStimulationPackage = (StimulationPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof StimulationPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new StimulationPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		RootPackageImpl theRootPackage = (RootPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) instanceof RootPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) : RootPackage.eINSTANCE);
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		FmiPackageImpl theFmiPackage = (FmiPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) instanceof FmiPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) : FmiPackage.eINSTANCE);
		TypePackageImpl theTypePackage = (TypePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) instanceof TypePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) : TypePackage.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackage.eINSTANCE);
		VariablePackageImpl theVariablePackage = (VariablePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) instanceof VariablePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) : VariablePackage.eINSTANCE);
		MemoryPackageImpl theMemoryPackage = (MemoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) instanceof MemoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) : MemoryPackage.eINSTANCE);
		PeripheralPackageImpl thePeripheralPackage = (PeripheralPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) instanceof PeripheralPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) : PeripheralPackage.eINSTANCE);
		RequirementPackageImpl theRequirementPackage = (RequirementPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) instanceof RequirementPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) : RequirementPackage.eINSTANCE);
		SettingsPackageImpl theSettingsPackage = (SettingsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) instanceof SettingsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) : SettingsPackage.eINSTANCE);

		// Load packages
		theRootPackage.loadPackage();

		// Fix loaded packages
		theStimulationPackage.fixPackageContents();
		theRootPackage.fixPackageContents();
		theModelPackage.fixPackageContents();
		theAutosarPackage.fixPackageContents();
		theFmiPackage.fixPackageContents();
		theTypePackage.fixPackageContents();
		theUnitPackage.fixPackageContents();
		theVariablePackage.fixPackageContents();
		theMemoryPackage.fixPackageContents();
		thePeripheralPackage.fixPackageContents();
		theRequirementPackage.fixPackageContents();
		theSettingsPackage.fixPackageContents();

		// Mark meta-data to indicate it can't be changed
		theStimulationPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(StimulationPackage.eNS_URI, theStimulationPackage);
		return theStimulationPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBurstPattern() {
		if (burstPatternEClass == null) {
			burstPatternEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(0);
		}
		return burstPatternEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBurstPattern_MaximumOccurrences() {
        return (EAttribute)getBurstPattern().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPattern_MinimumInterArrivalTime() {
        return (EReference)getBurstPattern().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPattern_PatternLength() {
        return (EReference)getBurstPattern().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBurstPatternGenerator() {
		if (burstPatternGeneratorEClass == null) {
			burstPatternGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(1);
		}
		return burstPatternGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPatternGenerator_BurstPatternSettings() {
        return (EReference)getBurstPatternGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBurstPatternGenerator_Iterations() {
        return (EAttribute)getBurstPatternGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPatternGenerator_Period() {
        return (EReference)getBurstPatternGenerator().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBurstPatternGenerator_Relative() {
        return (EAttribute)getBurstPatternGenerator().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPatternGenerator_StartOffset() {
        return (EReference)getBurstPatternGenerator().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPatternGenerator_StartOffsetVariation() {
        return (EReference)getBurstPatternGenerator().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBurstPatternGenerator_Variation() {
        return (EReference)getBurstPatternGenerator().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCSVBasedGenerator() {
		if (csvBasedGeneratorEClass == null) {
			csvBasedGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(2);
		}
		return csvBasedGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCSVBasedGenerator_Filename() {
        return (EAttribute)getCSVBasedGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCompositeScenario() {
		if (compositeScenarioEClass == null) {
			compositeScenarioEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(3);
		}
		return compositeScenarioEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCompositeScenario_Scenarios() {
        return (EReference)getCompositeScenario().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDisturbanceFilter() {
		if (disturbanceFilterEClass == null) {
			disturbanceFilterEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(4);
		}
		return disturbanceFilterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDisturbanceFilter_DisturbanceProbability() {
        return (EAttribute)getDisturbanceFilter().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDisturbanceFilter_DisturbanceSigma() {
        return (EReference)getDisturbanceFilter().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDisturbanceFilter_LossProbability() {
        return (EAttribute)getDisturbanceFilter().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDriftFilter() {
		if (driftFilterEClass == null) {
			driftFilterEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(5);
		}
		return driftFilterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDriftFilter_Maximum() {
        return (EReference)getDriftFilter().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDriftFilter_Periodic() {
        return (EAttribute)getDriftFilter().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDriftFilter_Repeat() {
        return (EReference)getDriftFilter().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDriftFilter_StartTime() {
        return (EReference)getDriftFilter().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDriftFilter_TimeFrame() {
        return (EReference)getDriftFilter().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEliminationFilter() {
		if (eliminationFilterEClass == null) {
			eliminationFilterEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(6);
		}
		return eliminationFilterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEliminationFilter_SourceGenerator() {
        return (EReference)getEliminationFilter().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEliminationFilter_TimeFrame() {
        return (EReference)getEliminationFilter().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInducedGenerator() {
		if (inducedGeneratorEClass == null) {
			inducedGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(7);
		}
		return inducedGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInducedGenerator_Delay() {
        return (EReference)getInducedGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInducedGenerator_Offset() {
        return (EAttribute)getInducedGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInducedGenerator_Period() {
        return (EAttribute)getInducedGenerator().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInducedListBasedGenerator() {
		if (inducedListBasedGeneratorEClass == null) {
			inducedListBasedGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(8);
		}
		return inducedListBasedGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInducedListBasedGenerator_Offset() {
        return (EAttribute)getInducedListBasedGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInducedListBasedGenerator_Period() {
        return (EAttribute)getInducedListBasedGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getListBasedGenerator() {
		if (listBasedGeneratorEClass == null) {
			listBasedGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(9);
		}
		return listBasedGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getListBasedGenerator_Entry() {
        return (EReference)getListBasedGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getListBasedGenerator_SourceGenerator() {
        return (EReference)getListBasedGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRandomStimuliGenerator() {
		if (randomStimuliGeneratorEClass == null) {
			randomStimuliGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(10);
		}
		return randomStimuliGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRandomStimuliGenerator_Iterations() {
        return (EAttribute)getRandomStimuliGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomStimuliGenerator_MinInterArrivalTime() {
        return (EReference)getRandomStimuliGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomStimuliGenerator_Period() {
        return (EReference)getRandomStimuliGenerator().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRandomStimuliGenerator_Relative() {
        return (EAttribute)getRandomStimuliGenerator().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomStimuliGenerator_StartOffset() {
        return (EReference)getRandomStimuliGenerator().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomStimuliGenerator_StartOffsetVariation() {
        return (EReference)getRandomStimuliGenerator().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRandomStimuliGenerator_Variation() {
        return (EReference)getRandomStimuliGenerator().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStimulationFilter() {
		if (stimulationFilterEClass == null) {
			stimulationFilterEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(11);
		}
		return stimulationFilterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStimulationScenario() {
		if (stimulationScenarioEClass == null) {
			stimulationScenarioEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(12);
		}
		return stimulationScenarioEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStimulationScenario_BurstPattern() {
        return (EReference)getStimulationScenario().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStimulationScenario_Generators() {
        return (EReference)getStimulationScenario().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStimuliGenerator() {
		if (stimuliGeneratorEClass == null) {
			stimuliGeneratorEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI).getEClassifiers().get(13);
		}
		return stimuliGeneratorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStimuliGenerator_Connections() {
        return (EReference)getStimuliGenerator().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStimuliGenerator_Filters() {
        return (EReference)getStimuliGenerator().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStimuliGenerator_Targets() {
        return (EReference)getStimuliGenerator().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimulationFactory getStimulationFactory() {
		return (StimulationFactory)getEFactoryInstance();
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isFixed = false;

	/**
	 * Fixes up the loaded package, to make it appear as if it had been programmatically built.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fixPackageContents() {
		if (isFixed) return;
		isFixed = true;
		fixEClassifiers();
	}

	/**
	 * Sets the instance class on the given classifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void fixInstanceClass(EClassifier eClassifier) {
		if (eClassifier.getInstanceClassName() == null) {
			eClassifier.setInstanceClassName("com.inchron.realtime.root.model.stimulation." + eClassifier.getName());
			setGeneratedClassName(eClassifier);
		}
	}

} //StimulationPackageImpl
