/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.settings.SettingsFactory
 * @model kind="package"
 * @generated
 */
public interface SettingsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "settings";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.3/settings";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "settings";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SettingsPackage eINSTANCE = com.inchron.realtime.root.settings.impl.SettingsPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ColorImpl <em>Color</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ColorImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColor()
	 * @generated
	 */
	int COLOR = 0;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR__URI = 0;

	/**
	 * The number of structural features of the '<em>Color</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Color</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ColorEntryImpl <em>Color Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ColorEntryImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColorEntry()
	 * @generated
	 */
	int COLOR_ENTRY = 1;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Color</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY__COLOR = 1;

	/**
	 * The number of structural features of the '<em>Color Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Color Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ColorEntryContainerImpl <em>Color Entry Container</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ColorEntryContainerImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColorEntryContainer()
	 * @generated
	 */
	int COLOR_ENTRY_CONTAINER = 2;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_CONTAINER__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Color</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_CONTAINER__COLOR = 1;

	/**
	 * The number of structural features of the '<em>Color Entry Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_CONTAINER_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Color Entry Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLOR_ENTRY_CONTAINER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.CursorImpl <em>Cursor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.CursorImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getCursor()
	 * @generated
	 */
	int CURSOR = 3;

	/**
	 * The feature id for the '<em><b>Position</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CURSOR__POSITION = 0;

	/**
	 * The feature id for the '<em><b>Master</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CURSOR__MASTER = 1;

	/**
	 * The number of structural features of the '<em>Cursor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CURSOR_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Cursor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CURSOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.DiagramSettingsImpl <em>Diagram Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.DiagramSettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getDiagramSettings()
	 * @generated
	 */
	int DIAGRAM_SETTINGS = 4;

	/**
	 * The number of structural features of the '<em>Diagram Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_SETTINGS_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Diagram Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.EditorSettingsImpl <em>Editor Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.EditorSettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getEditorSettings()
	 * @generated
	 */
	int EDITOR_SETTINGS = 5;

	/**
	 * The feature id for the '<em><b>Collapsation States</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDITOR_SETTINGS__COLLAPSATION_STATES = 0;

	/**
	 * The number of structural features of the '<em>Editor Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDITOR_SETTINGS_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Editor Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDITOR_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.EObjectFlagImpl <em>EObject Flag</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.EObjectFlagImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getEObjectFlag()
	 * @generated
	 */
	int EOBJECT_FLAG = 6;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EOBJECT_FLAG__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Flag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EOBJECT_FLAG__FLAG = 1;

	/**
	 * The number of structural features of the '<em>EObject Flag</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EOBJECT_FLAG_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>EObject Flag</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EOBJECT_FLAG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ModelObjectFlagImpl <em>Model Object Flag</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ModelObjectFlagImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getModelObjectFlag()
	 * @generated
	 */
	int MODEL_OBJECT_FLAG = 7;

	/**
	 * The feature id for the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_FLAG__OBJECT = 0;

	/**
	 * The feature id for the '<em><b>Flag</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_FLAG__FLAG = 1;

	/**
	 * The number of structural features of the '<em>Model Object Flag</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_FLAG_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Model Object Flag</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_FLAG_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ModelSettingsImpl <em>Model Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ModelSettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getModelSettings()
	 * @generated
	 */
	int MODEL_SETTINGS = 8;

	/**
	 * The feature id for the '<em><b>Colors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SETTINGS__COLORS = 0;

	/**
	 * The feature id for the '<em><b>Colors By Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SETTINGS__COLORS_BY_INSTANCE = 1;

	/**
	 * The number of structural features of the '<em>Model Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SETTINGS_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Model Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.SettingsImpl <em>Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.SettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getSettings()
	 * @generated
	 */
	int SETTINGS = 9;

	/**
	 * The feature id for the '<em><b>Editor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS__EDITOR = 0;

	/**
	 * The feature id for the '<em><b>Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS__MODEL = 1;

	/**
	 * The feature id for the '<em><b>Tool</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS__TOOL = 2;

	/**
	 * The feature id for the '<em><b>Views</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS__VIEWS = 3;

	/**
	 * The number of structural features of the '<em>Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ToolSettingsImpl <em>Tool Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ToolSettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getToolSettings()
	 * @generated
	 */
	int TOOL_SETTINGS = 10;

	/**
	 * The number of structural features of the '<em>Tool Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_SETTINGS_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Tool Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl <em>Trace Event Type Configuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getTraceEventTypeConfiguration()
	 * @generated
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION = 11;

	/**
	 * The feature id for the '<em><b>Color</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION__COLOR = 0;

	/**
	 * The feature id for the '<em><b>Trace Event Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Visible</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE = 2;

	/**
	 * The number of structural features of the '<em>Trace Event Type Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Trace Event Type Configuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_TYPE_CONFIGURATION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl <em>View Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.settings.impl.ViewSettingsImpl
	 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getViewSettings()
	 * @generated
	 */
	int VIEW_SETTINGS = 12;

	/**
	 * The feature id for the '<em><b>Diagrams</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS__DIAGRAMS = 0;

	/**
	 * The feature id for the '<em><b>Event Labels Visible</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS__EVENT_LABELS_VISIBLE = 1;

	/**
	 * The feature id for the '<em><b>Horizontal Labels</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS__HORIZONTAL_LABELS = 2;

	/**
	 * The feature id for the '<em><b>Cursors</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS__CURSORS = 3;

	/**
	 * The feature id for the '<em><b>Trace Event Type Configurations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS = 4;

	/**
	 * The number of structural features of the '<em>View Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>View Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIEW_SETTINGS_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.Color <em>Color</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Color</em>'.
	 * @see com.inchron.realtime.root.settings.Color
	 * @generated
	 */
	EClass getColor();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.Color#getUri <em>Uri</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uri</em>'.
	 * @see com.inchron.realtime.root.settings.Color#getUri()
	 * @see #getColor()
	 * @generated
	 */
	EAttribute getColor_Uri();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ColorEntry <em>Color Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Color Entry</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntry
	 * @generated
	 */
	EClass getColorEntry();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.settings.ColorEntry#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntry#getObject()
	 * @see #getColorEntry()
	 * @generated
	 */
	EReference getColorEntry_Object();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.settings.ColorEntry#getColor <em>Color</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Color</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntry#getColor()
	 * @see #getColorEntry()
	 * @generated
	 */
	EReference getColorEntry_Color();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ColorEntryContainer <em>Color Entry Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Color Entry Container</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntryContainer
	 * @generated
	 */
	EClass getColorEntryContainer();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.settings.ColorEntryContainer#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntryContainer#getObject()
	 * @see #getColorEntryContainer()
	 * @generated
	 */
	EReference getColorEntryContainer_Object();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.ColorEntryContainer#getColor <em>Color</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Color</em>'.
	 * @see com.inchron.realtime.root.settings.ColorEntryContainer#getColor()
	 * @see #getColorEntryContainer()
	 * @generated
	 */
	EReference getColorEntryContainer_Color();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.Cursor <em>Cursor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cursor</em>'.
	 * @see com.inchron.realtime.root.settings.Cursor
	 * @generated
	 */
	EClass getCursor();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.settings.Cursor#getPosition <em>Position</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Position</em>'.
	 * @see com.inchron.realtime.root.settings.Cursor#getPosition()
	 * @see #getCursor()
	 * @generated
	 */
	EReference getCursor_Position();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.Cursor#isMaster <em>Master</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Master</em>'.
	 * @see com.inchron.realtime.root.settings.Cursor#isMaster()
	 * @see #getCursor()
	 * @generated
	 */
	EAttribute getCursor_Master();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.DiagramSettings <em>Diagram Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Diagram Settings</em>'.
	 * @see com.inchron.realtime.root.settings.DiagramSettings
	 * @generated
	 */
	EClass getDiagramSettings();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.EditorSettings <em>Editor Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Editor Settings</em>'.
	 * @see com.inchron.realtime.root.settings.EditorSettings
	 * @generated
	 */
	EClass getEditorSettings();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.EditorSettings#getCollapsationStates <em>Collapsation States</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Collapsation States</em>'.
	 * @see com.inchron.realtime.root.settings.EditorSettings#getCollapsationStates()
	 * @see #getEditorSettings()
	 * @generated
	 */
	EReference getEditorSettings_CollapsationStates();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.EObjectFlag <em>EObject Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>EObject Flag</em>'.
	 * @see com.inchron.realtime.root.settings.EObjectFlag
	 * @generated
	 */
	EClass getEObjectFlag();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.settings.EObjectFlag#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see com.inchron.realtime.root.settings.EObjectFlag#getObject()
	 * @see #getEObjectFlag()
	 * @generated
	 */
	EReference getEObjectFlag_Object();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.EObjectFlag#isFlag <em>Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Flag</em>'.
	 * @see com.inchron.realtime.root.settings.EObjectFlag#isFlag()
	 * @see #getEObjectFlag()
	 * @generated
	 */
	EAttribute getEObjectFlag_Flag();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ModelObjectFlag <em>Model Object Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Object Flag</em>'.
	 * @see com.inchron.realtime.root.settings.ModelObjectFlag
	 * @generated
	 */
	EClass getModelObjectFlag();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.settings.ModelObjectFlag#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Object</em>'.
	 * @see com.inchron.realtime.root.settings.ModelObjectFlag#getObject()
	 * @see #getModelObjectFlag()
	 * @generated
	 */
	EReference getModelObjectFlag_Object();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.ModelObjectFlag#isFlag <em>Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Flag</em>'.
	 * @see com.inchron.realtime.root.settings.ModelObjectFlag#isFlag()
	 * @see #getModelObjectFlag()
	 * @generated
	 */
	EAttribute getModelObjectFlag_Flag();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ModelSettings <em>Model Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Settings</em>'.
	 * @see com.inchron.realtime.root.settings.ModelSettings
	 * @generated
	 */
	EClass getModelSettings();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.ModelSettings#getColors <em>Colors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Colors</em>'.
	 * @see com.inchron.realtime.root.settings.ModelSettings#getColors()
	 * @see #getModelSettings()
	 * @generated
	 */
	EReference getModelSettings_Colors();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.settings.ModelSettings#getColorsByInstance <em>Colors By Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Colors By Instance</em>'.
	 * @see com.inchron.realtime.root.settings.ModelSettings#getColorsByInstance()
	 * @see #getModelSettings()
	 * @generated
	 */
	EReference getModelSettings_ColorsByInstance();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.Settings <em>Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Settings</em>'.
	 * @see com.inchron.realtime.root.settings.Settings
	 * @generated
	 */
	EClass getSettings();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.settings.Settings#getEditor <em>Editor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Editor</em>'.
	 * @see com.inchron.realtime.root.settings.Settings#getEditor()
	 * @see #getSettings()
	 * @generated
	 */
	EReference getSettings_Editor();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.settings.Settings#getModel <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Model</em>'.
	 * @see com.inchron.realtime.root.settings.Settings#getModel()
	 * @see #getSettings()
	 * @generated
	 */
	EReference getSettings_Model();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.settings.Settings#getTool <em>Tool</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Tool</em>'.
	 * @see com.inchron.realtime.root.settings.Settings#getTool()
	 * @see #getSettings()
	 * @generated
	 */
	EReference getSettings_Tool();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.Settings#getViews <em>Views</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Views</em>'.
	 * @see com.inchron.realtime.root.settings.Settings#getViews()
	 * @see #getSettings()
	 * @generated
	 */
	EReference getSettings_Views();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ToolSettings <em>Tool Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tool Settings</em>'.
	 * @see com.inchron.realtime.root.settings.ToolSettings
	 * @generated
	 */
	EClass getToolSettings();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration <em>Trace Event Type Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trace Event Type Configuration</em>'.
	 * @see com.inchron.realtime.root.settings.TraceEventTypeConfiguration
	 * @generated
	 */
	EClass getTraceEventTypeConfiguration();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getColor <em>Color</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Color</em>'.
	 * @see com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getColor()
	 * @see #getTraceEventTypeConfiguration()
	 * @generated
	 */
	EReference getTraceEventTypeConfiguration_Color();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getTraceEventType <em>Trace Event Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Trace Event Type</em>'.
	 * @see com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getTraceEventType()
	 * @see #getTraceEventTypeConfiguration()
	 * @generated
	 */
	EAttribute getTraceEventTypeConfiguration_TraceEventType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#isVisible <em>Visible</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Visible</em>'.
	 * @see com.inchron.realtime.root.settings.TraceEventTypeConfiguration#isVisible()
	 * @see #getTraceEventTypeConfiguration()
	 * @generated
	 */
	EAttribute getTraceEventTypeConfiguration_Visible();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.settings.ViewSettings <em>View Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>View Settings</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings
	 * @generated
	 */
	EClass getViewSettings();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.ViewSettings#getDiagrams <em>Diagrams</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Diagrams</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings#getDiagrams()
	 * @see #getViewSettings()
	 * @generated
	 */
	EReference getViewSettings_Diagrams();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.ViewSettings#isEventLabelsVisible <em>Event Labels Visible</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Event Labels Visible</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings#isEventLabelsVisible()
	 * @see #getViewSettings()
	 * @generated
	 */
	EAttribute getViewSettings_EventLabelsVisible();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.settings.ViewSettings#isHorizontalLabels <em>Horizontal Labels</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Horizontal Labels</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings#isHorizontalLabels()
	 * @see #getViewSettings()
	 * @generated
	 */
	EAttribute getViewSettings_HorizontalLabels();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.ViewSettings#getCursors <em>Cursors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cursors</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings#getCursors()
	 * @see #getViewSettings()
	 * @generated
	 */
	EReference getViewSettings_Cursors();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.settings.ViewSettings#getTraceEventTypeConfigurations <em>Trace Event Type Configurations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Trace Event Type Configurations</em>'.
	 * @see com.inchron.realtime.root.settings.ViewSettings#getTraceEventTypeConfigurations()
	 * @see #getViewSettings()
	 * @generated
	 */
	EReference getViewSettings_TraceEventTypeConfigurations();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SettingsFactory getSettingsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ColorImpl <em>Color</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ColorImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColor()
		 * @generated
		 */
		EClass COLOR = eINSTANCE.getColor();

		/**
		 * The meta object literal for the '<em><b>Uri</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COLOR__URI = eINSTANCE.getColor_Uri();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ColorEntryImpl <em>Color Entry</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ColorEntryImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColorEntry()
		 * @generated
		 */
		EClass COLOR_ENTRY = eINSTANCE.getColorEntry();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLOR_ENTRY__OBJECT = eINSTANCE.getColorEntry_Object();

		/**
		 * The meta object literal for the '<em><b>Color</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLOR_ENTRY__COLOR = eINSTANCE.getColorEntry_Color();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ColorEntryContainerImpl <em>Color Entry Container</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ColorEntryContainerImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getColorEntryContainer()
		 * @generated
		 */
		EClass COLOR_ENTRY_CONTAINER = eINSTANCE.getColorEntryContainer();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLOR_ENTRY_CONTAINER__OBJECT = eINSTANCE.getColorEntryContainer_Object();

		/**
		 * The meta object literal for the '<em><b>Color</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLOR_ENTRY_CONTAINER__COLOR = eINSTANCE.getColorEntryContainer_Color();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.CursorImpl <em>Cursor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.CursorImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getCursor()
		 * @generated
		 */
		EClass CURSOR = eINSTANCE.getCursor();

		/**
		 * The meta object literal for the '<em><b>Position</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CURSOR__POSITION = eINSTANCE.getCursor_Position();

		/**
		 * The meta object literal for the '<em><b>Master</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CURSOR__MASTER = eINSTANCE.getCursor_Master();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.DiagramSettingsImpl <em>Diagram Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.DiagramSettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getDiagramSettings()
		 * @generated
		 */
		EClass DIAGRAM_SETTINGS = eINSTANCE.getDiagramSettings();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.EditorSettingsImpl <em>Editor Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.EditorSettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getEditorSettings()
		 * @generated
		 */
		EClass EDITOR_SETTINGS = eINSTANCE.getEditorSettings();

		/**
		 * The meta object literal for the '<em><b>Collapsation States</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EDITOR_SETTINGS__COLLAPSATION_STATES = eINSTANCE.getEditorSettings_CollapsationStates();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.EObjectFlagImpl <em>EObject Flag</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.EObjectFlagImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getEObjectFlag()
		 * @generated
		 */
		EClass EOBJECT_FLAG = eINSTANCE.getEObjectFlag();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EOBJECT_FLAG__OBJECT = eINSTANCE.getEObjectFlag_Object();

		/**
		 * The meta object literal for the '<em><b>Flag</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EOBJECT_FLAG__FLAG = eINSTANCE.getEObjectFlag_Flag();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ModelObjectFlagImpl <em>Model Object Flag</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ModelObjectFlagImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getModelObjectFlag()
		 * @generated
		 */
		EClass MODEL_OBJECT_FLAG = eINSTANCE.getModelObjectFlag();

		/**
		 * The meta object literal for the '<em><b>Object</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_OBJECT_FLAG__OBJECT = eINSTANCE.getModelObjectFlag_Object();

		/**
		 * The meta object literal for the '<em><b>Flag</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_OBJECT_FLAG__FLAG = eINSTANCE.getModelObjectFlag_Flag();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ModelSettingsImpl <em>Model Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ModelSettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getModelSettings()
		 * @generated
		 */
		EClass MODEL_SETTINGS = eINSTANCE.getModelSettings();

		/**
		 * The meta object literal for the '<em><b>Colors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SETTINGS__COLORS = eINSTANCE.getModelSettings_Colors();

		/**
		 * The meta object literal for the '<em><b>Colors By Instance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_SETTINGS__COLORS_BY_INSTANCE = eINSTANCE.getModelSettings_ColorsByInstance();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.SettingsImpl <em>Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.SettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getSettings()
		 * @generated
		 */
		EClass SETTINGS = eINSTANCE.getSettings();

		/**
		 * The meta object literal for the '<em><b>Editor</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SETTINGS__EDITOR = eINSTANCE.getSettings_Editor();

		/**
		 * The meta object literal for the '<em><b>Model</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SETTINGS__MODEL = eINSTANCE.getSettings_Model();

		/**
		 * The meta object literal for the '<em><b>Tool</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SETTINGS__TOOL = eINSTANCE.getSettings_Tool();

		/**
		 * The meta object literal for the '<em><b>Views</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SETTINGS__VIEWS = eINSTANCE.getSettings_Views();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ToolSettingsImpl <em>Tool Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ToolSettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getToolSettings()
		 * @generated
		 */
		EClass TOOL_SETTINGS = eINSTANCE.getToolSettings();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl <em>Trace Event Type Configuration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getTraceEventTypeConfiguration()
		 * @generated
		 */
		EClass TRACE_EVENT_TYPE_CONFIGURATION = eINSTANCE.getTraceEventTypeConfiguration();

		/**
		 * The meta object literal for the '<em><b>Color</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRACE_EVENT_TYPE_CONFIGURATION__COLOR = eINSTANCE.getTraceEventTypeConfiguration_Color();

		/**
		 * The meta object literal for the '<em><b>Trace Event Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE = eINSTANCE.getTraceEventTypeConfiguration_TraceEventType();

		/**
		 * The meta object literal for the '<em><b>Visible</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE = eINSTANCE.getTraceEventTypeConfiguration_Visible();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.settings.impl.ViewSettingsImpl <em>View Settings</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.settings.impl.ViewSettingsImpl
		 * @see com.inchron.realtime.root.settings.impl.SettingsPackageImpl#getViewSettings()
		 * @generated
		 */
		EClass VIEW_SETTINGS = eINSTANCE.getViewSettings();

		/**
		 * The meta object literal for the '<em><b>Diagrams</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VIEW_SETTINGS__DIAGRAMS = eINSTANCE.getViewSettings_Diagrams();

		/**
		 * The meta object literal for the '<em><b>Event Labels Visible</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VIEW_SETTINGS__EVENT_LABELS_VISIBLE = eINSTANCE.getViewSettings_EventLabelsVisible();

		/**
		 * The meta object literal for the '<em><b>Horizontal Labels</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VIEW_SETTINGS__HORIZONTAL_LABELS = eINSTANCE.getViewSettings_HorizontalLabels();

		/**
		 * The meta object literal for the '<em><b>Cursors</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VIEW_SETTINGS__CURSORS = eINSTANCE.getViewSettings_Cursors();

		/**
		 * The meta object literal for the '<em><b>Trace Event Type Configurations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VIEW_SETTINGS__TRACE_EVENT_TYPE_CONFIGURATIONS = eINSTANCE.getViewSettings_TraceEventTypeConfigurations();

	}

} //SettingsPackage
