/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings.impl;

import com.inchron.realtime.root.settings.ColorEntry;
import com.inchron.realtime.root.settings.ColorEntryContainer;
import com.inchron.realtime.root.settings.ModelSettings;
import com.inchron.realtime.root.settings.SettingsPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Settings</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ModelSettingsImpl#getColors <em>Colors</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.ModelSettingsImpl#getColorsByInstance <em>Colors By Instance</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ModelSettingsImpl extends MinimalEObjectImpl.Container implements ModelSettings {
	/**
	 * The cached value of the '{@link #getColors() <em>Colors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColors()
	 * @generated
	 * @ordered
	 */
	protected EList<ColorEntry> colors;

	/**
	 * The cached value of the '{@link #getColorsByInstance() <em>Colors By Instance</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColorsByInstance()
	 * @generated
	 * @ordered
	 */
	protected EList<ColorEntryContainer> colorsByInstance;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelSettingsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SettingsPackage.Literals.MODEL_SETTINGS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ColorEntry> getColors() {
		if (colors == null) {
			colors = new EObjectContainmentEList<ColorEntry>(ColorEntry.class, this, SettingsPackage.MODEL_SETTINGS__COLORS);
		}
		return colors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ColorEntryContainer> getColorsByInstance() {
		if (colorsByInstance == null) {
			colorsByInstance = new EObjectResolvingEList<ColorEntryContainer>(ColorEntryContainer.class, this, SettingsPackage.MODEL_SETTINGS__COLORS_BY_INSTANCE);
		}
		return colorsByInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SettingsPackage.MODEL_SETTINGS__COLORS:
				return ((InternalEList<?>)getColors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SettingsPackage.MODEL_SETTINGS__COLORS:
				return getColors();
			case SettingsPackage.MODEL_SETTINGS__COLORS_BY_INSTANCE:
				return getColorsByInstance();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SettingsPackage.MODEL_SETTINGS__COLORS:
				getColors().clear();
				getColors().addAll((Collection<? extends ColorEntry>)newValue);
				return;
			case SettingsPackage.MODEL_SETTINGS__COLORS_BY_INSTANCE:
				getColorsByInstance().clear();
				getColorsByInstance().addAll((Collection<? extends ColorEntryContainer>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SettingsPackage.MODEL_SETTINGS__COLORS:
				getColors().clear();
				return;
			case SettingsPackage.MODEL_SETTINGS__COLORS_BY_INSTANCE:
				getColorsByInstance().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SettingsPackage.MODEL_SETTINGS__COLORS:
				return colors != null && !colors.isEmpty();
			case SettingsPackage.MODEL_SETTINGS__COLORS_BY_INSTANCE:
				return colorsByInstance != null && !colorsByInstance.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //ModelSettingsImpl
