/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings.impl;

import com.inchron.realtime.root.settings.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SettingsFactoryImpl extends EFactoryImpl implements SettingsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SettingsFactory init() {
		try {
			SettingsFactory theSettingsFactory = (SettingsFactory)EPackage.Registry.INSTANCE.getEFactory(SettingsPackage.eNS_URI);
			if (theSettingsFactory != null) {
				return theSettingsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SettingsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SettingsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case SettingsPackage.COLOR: return createColor();
			case SettingsPackage.COLOR_ENTRY: return createColorEntry();
			case SettingsPackage.COLOR_ENTRY_CONTAINER: return createColorEntryContainer();
			case SettingsPackage.CURSOR: return createCursor();
			case SettingsPackage.DIAGRAM_SETTINGS: return createDiagramSettings();
			case SettingsPackage.EDITOR_SETTINGS: return createEditorSettings();
			case SettingsPackage.EOBJECT_FLAG: return createEObjectFlag();
			case SettingsPackage.MODEL_OBJECT_FLAG: return createModelObjectFlag();
			case SettingsPackage.MODEL_SETTINGS: return createModelSettings();
			case SettingsPackage.SETTINGS: return createSettings();
			case SettingsPackage.TOOL_SETTINGS: return createToolSettings();
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION: return createTraceEventTypeConfiguration();
			case SettingsPackage.VIEW_SETTINGS: return createViewSettings();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Color createColor() {
		ColorImpl color = new ColorImpl();
		return color;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ColorEntry createColorEntry() {
		ColorEntryImpl colorEntry = new ColorEntryImpl();
		return colorEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ColorEntryContainer createColorEntryContainer() {
		ColorEntryContainerImpl colorEntryContainer = new ColorEntryContainerImpl();
		return colorEntryContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Cursor createCursor() {
		CursorImpl cursor = new CursorImpl();
		return cursor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DiagramSettings createDiagramSettings() {
		DiagramSettingsImpl diagramSettings = new DiagramSettingsImpl();
		return diagramSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EditorSettings createEditorSettings() {
		EditorSettingsImpl editorSettings = new EditorSettingsImpl();
		return editorSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObjectFlag createEObjectFlag() {
		EObjectFlagImpl eObjectFlag = new EObjectFlagImpl();
		return eObjectFlag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelObjectFlag createModelObjectFlag() {
		ModelObjectFlagImpl modelObjectFlag = new ModelObjectFlagImpl();
		return modelObjectFlag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelSettings createModelSettings() {
		ModelSettingsImpl modelSettings = new ModelSettingsImpl();
		return modelSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Settings createSettings() {
		SettingsImpl settings = new SettingsImpl();
		return settings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToolSettings createToolSettings() {
		ToolSettingsImpl toolSettings = new ToolSettingsImpl();
		return toolSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEventTypeConfiguration createTraceEventTypeConfiguration() {
		TraceEventTypeConfigurationImpl traceEventTypeConfiguration = new TraceEventTypeConfigurationImpl();
		return traceEventTypeConfiguration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ViewSettings createViewSettings() {
		ViewSettingsImpl viewSettings = new ViewSettingsImpl();
		return viewSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SettingsPackage getSettingsPackage() {
		return (SettingsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static SettingsPackage getPackage() {
		return SettingsPackage.eINSTANCE;
	}

} //SettingsFactoryImpl
