package templates.m2m.hw

import com.google.inject.Inject
import com.inchron.realtime.root.model.Model
import org.eclipse.app4mc.amalthea.model.Cache
import org.eclipse.app4mc.amalthea.model.HwStructure
import org.eclipse.app4mc.amalthea.model.Memory
import org.eclipse.app4mc.amalthea.model.StructureType
import templates.AbstractAmaltheaInchronTransformer

class HWStructure_ECUTransformer extends AbstractAmaltheaInchronTransformer{
	
	@Inject HWStructure_MicroControllerTransformer  microControllerTransformer
	
	@Inject MemoryTransformer memoryTransformer
	
	@Inject CacheTransformer cacheTransformer
	
	public def transformHWECU(HwStructure amltHWECU, Model inchronModel) {
		
		amltHWECU.modules.forEach[
					amltHwModule|{
						if(amltHwModule instanceof Memory){
							inchronModel.memories.add(memoryTransformer.createMemory(amltHwModule))
							
						}else if(amltHwModule instanceof Cache){
							inchronModel.memories.add(cacheTransformer.createCache(amltHwModule))
						}
					}
				]
				
		 
		
		 amltHWECU.structures.forEach[amltHwMicroController|{
			
			if(amltHwMicroController.structureType==StructureType.MICROCONTROLLER){
				
				inchronModel.cpus.add(microControllerTransformer.createCpu(amltHwMicroController ))
			}
		}]
		 
	}
}