package templates.m2m.hw

import com.google.inject.Inject
import com.inchron.realtime.root.model.Model
import org.eclipse.app4mc.amalthea.model.FrequencyDomain
import org.eclipse.app4mc.amalthea.model.HWModel
import templates.AbstractAmaltheaInchronTransformer

class HWTransformer extends AbstractAmaltheaInchronTransformer{
	
	@Inject HWStructure_SystemTransformer hwStructure_SystemTransformer
	
	@Inject FrequencyDomainTransformer  frequencyDomainTransformer
	
	public def transfromHWModel(HWModel amltHWModel, Model inchronModel) {

		this.inchronModel=inchronModel
			
			amltHWModel.domains.forEach[
				domain| {
					if(domain instanceof FrequencyDomain){
						var inchronClock=frequencyDomainTransformer.createClock(domain as FrequencyDomain)
						
						inchronModel.clocks.add(inchronClock)
						
					}
				}
			]
		
			hwStructure_SystemTransformer.transformHWSystem(amltHWModel,inchronModel)
		
		}
}