/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.hector2.mpos;

import net.sourceforge.plantuml.cucadiagram.IEntity;
import net.sourceforge.plantuml.hector2.layering.Layer;

public class MutationLayerMove implements MutationLayer {

	private final Layer layer;
	private final IEntity entity;
	private final int newLongitude;

	public MutationLayerMove(Layer layer, IEntity entity, int newLongitude) {
		this.layer = layer;
		this.entity = entity;
		this.newLongitude = newLongitude;
	}

	public Layer mute() {
		final Layer result = layer.duplicate();
		result.put(entity, newLongitude);
		return result;
	}

	public Layer getOriginal() {
		return layer;
	}

	@Override
	public String toString() {
		return "{" + layer.getId() + "} " + entity + " moveto " + newLongitude;
	}
}
