/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.preproc;

import java.io.IOException;
import java.util.regex.Matcher;

class IfManagerPositif extends IfManager {

	public IfManagerPositif(ReadLine source, Defines defines) {
		super(source, defines);
	}

	@Override
	protected String readLineInternal() throws IOException {
		String s = super.readLineInternal();
		if (s == null) {
			return null;
		}
		Matcher m = endifPattern.matcher(s);
		if (m.find()) {
			return null;
		}
		m = elsePattern.matcher(s);
		if (m.find()) {
			do {
				s = readLine();
				if (s == null) {
					return null;
				}
				m = endifPattern.matcher(s);
				if (m.find()) {
					return null;
				}
			} while (true);
		}
		return s;
	}

}
